;;;;;;;;;;;;;;;;;;;;;;;;;;;;;<--OGI-->;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                        ;;
;;             Center for Spoken Language Understanding                   ;;
;;        Oregon Graduate Institute of Science & Technology               ;;
;;                         Portland, OR USA                               ;;
;;                        Copyright (c) 1999                              ;;
;;                                                                        ;;
;;      This module is not part of the CSTR/University of Edinburgh       ;;
;;               release of the Festival TTS system.                      ;;
;;                                                                        ;;
;;  In addition to any conditions disclaimers below, please see the file  ;;
;;  "license_ogi_tts.txt" distributed with this software for information  ;;
;;  on usage and redistribution, and for a DISCLAIMER OF ALL WARRANTIES.  ;;
;;                                                                        ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;<--OGI-->;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                       ;;
;;                Center for Spoken Language Understanding               ;;
;;                     Oregon Graduate Institute                         ;;
;;                         Copyright (c) 1998                            ;;
;;                        All Rights Reserved.                           ;;
;;                                                                       ;;
;;  Permission to use, copy, modify, distribute this software and its    ;;
;;  documentation for research, educational and individual use only, is  ;;
;;  hereby granted without fee, subject to the following conditions:     ;;
;;   1. The code must retain the above copyright notice, this list of    ;;
;;      conditions and the following disclaimer.                         ;;
;;   2. Any modifications must be clearly marked as such.                ;;
;;   3. Original authors' names are not deleted.                         ;;
;;  This software may not be used for commercial purposes without        ;;
;;  specific prior written permission from the authors.                  ;;
;;                                                                       ;;
;;  OREGON GRADUTE INSTITUTE AND THE CONTRIBUTORS TO THIS WORK           ;;
;;  DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING      ;;
;;  ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT   ;;
;;  SHALL OREGON GRADUATE INSTITUTE NOR THE CONTRIBUTORS BE LIABLE       ;;
;;  FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES    ;;
;;  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN   ;;
;;  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,          ;;
;;  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF       ;;
;;  THIS SOFTWARE.                                                       ;;
;;                                                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                                                       ;;
;;       A German Voice for the Festival Speech Synthesis System         ;;
;;        Authors: Karin Mueller, Bettina Saeuberlich, Horst Meyer,      ;;
;;                 Mike Macon and Alan W Black                           ;;
;;          Date:  OGI, June/July 1998                                   ;;
;;                                                                       ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;  These letter to sound rules were trained from about one third of
;;  Grman CELEX lexicon.
;;
;;  Note you must have a licence for the CELEX lexicon in order to
;;  use these rules
;;
;;  On held out data from the lexicon it gets the following results
;;
;;  a total 6265 correct 6022.000 96.121%
;;  b total 2434 correct 2404.000 98.767%
;;  c total 3352 correct 3324.000 99.165%
;;  d total 2253 correct 2231.000 99.024%
;;  e total 20094 correct 19768.000 98.378%
;;  f total 2117 correct 2111.000 99.717%
;;  g total 3470 correct 3419.000 98.530%
;;  h total 4735 correct 4713.000 99.535%
;;  i total 6800 correct 6749.000 99.250%
;;  j total 78 correct 74.000 94.872%
;;  k total 1966 correct 1963.000 99.847%
;;  l total 4601 correct 4513.000 98.087%
;;  m total 2786 correct 2781.000 99.821%
;;  n total 7988 correct 7917.000 99.111%
;;  o total 2716 correct 2637.000 97.091%
;;  p total 1524 correct 1517.000 99.541%
;;  q total 60 correct 60.000 100.000%
;;  r total 8697 correct 8680.000 99.805%
;;  s total 9360 correct 9228.000 98.590%
;;  t total 9501 correct 9463.000 99.600%
;;  u total 4503 correct 4437.000 98.534%
;;  v total 916 correct 894.000 97.598%
;;  w total 1092 correct 1091.000 99.908%
;;  x total 82 correct 82.000 100.000%
;;  y total 81 correct 80.000 98.765%
;;  z total 1269 correct 1268.000 99.921%
;;  total 108740 correct 107426 (98.791613)
;;  words 9631 correct 8608 (89.38)

;; This assumes umlauts are converted to to asccii plus e and
;; everything is reduced to lower case

;; LTS rules generated from German CELEX
(set! de-celex_lts_cart_list '
((a
  ((n.name is u)
   ((p.p.name is c) ((p.p.p.name is s) ((aU)) ((O))) ((aU)))
   ((n.name is e)
    ((n.n.name is u)
     ((n.n.n.name is z) ((aU)) ((OY)))
     ((n.n.name is n)
      ((n.n.n.name is e)
       ((E:))
       ((n.n.n.name is t)
        ((p.name is m) ((_epsilon_)) ((E:)))
        ((p.p.name is i)
         ((p.p.p.name is a) ((aI)) ((_epsilon_)))
         ((n.n.n.name is i)
          ((E:))
          ((n.n.n.name is s)
           ((p.name is g) ((_epsilon_)) ((E:)))
           ((_epsilon_)))))))
      ((n.n.name is h)
       ((E:))
       ((n.n.n.name is e)
        ((p.p.name is p)
         ((p.p.p.name is s)
          ((E:))
          ((n.n.name is g) ((E:)) ((_epsilon_))))
         ((p.name is h) ((n.n.name is r) ((_epsilon_)) ((E:))) ((E:))))
        ((n.n.n.name is s)
         ((p.name is m)
          ((n.n.name is r) ((_epsilon_)) ((E:)))
          ((n.n.name is s)
           ((p.name is l)
            ((_epsilon_))
            ((p.p.name is #)
             ((_epsilon_))
             ((p.name is w)
              ((_epsilon_))
              ((p.p.name is n)
               ((_epsilon_))
               ((p.p.name is g)
                ((_epsilon_))
                ((p.p.p.name is u)
                 ((_epsilon_))
                 ((p.name is n) ((_epsilon_)) ((E:)))))))))
           ((n.n.name is l)
            ((_epsilon_))
            ((p.p.name is r)
             ((p.name is k) ((E:)) ((_epsilon_)))
             ((p.p.name is #)
              ((p.name is r)
               ((E:))
               ((n.n.name is t) ((_epsilon_)) ((E:))))
              ((E:)))))))
         ((n.n.name is g)
          ((n.n.n.name is n)
           ((p.p.p.name is r) ((E:)) ((_epsilon_)))
           ((p.name is #) ((_epsilon_)) ((E:))))
          ((n.n.n.name is #)
           ((E:))
           ((n.n.n.name is i)
            ((p.p.name is p)
             ((n.n.name is m)
              ((E:))
              ((p.name is r) ((_epsilon_)) ((E:))))
             ((p.name is t)
              ((E:))
              ((p.p.p.name is a)
               ((_epsilon_))
               ((n.n.name is l)
                ((E:))
                ((p.p.name is g)
                 ((E:))
                 ((n.n.name is d)
                  ((p.p.name is #) ((_epsilon_)) ((E:)))
                  ((E:))))))))
            ((n.n.n.name is m)
             ((_epsilon_))
             ((n.n.name is l)
              ((p.p.name is q) ((E:)) ((_epsilon_)))
              ((n.n.n.name is l)
               ((E:))
               ((n.n.n.name is o)
                ((p.name is #)
                 ((a))
                 ((p.name is d) ((E:)) ((_epsilon_))))
                ((n.n.n.name is k)
                 ((_epsilon_))
                 ((n.n.name is e)
                  ((E:))
                  ((n.n.name is t)
                   ((n.n.n.name is h)
                    ((E:))
                    ((p.name is p) ((E:)) ((_epsilon_))))
                   ((n.n.name is b)
                    ((E:))
                    ((p.p.name is p)
                     ((p.p.p.name is s) ((E:)) ((_epsilon_)))
                     ((n.n.name is r)
                      ((p.name is w)
                       ((_epsilon_))
                       ((p.name is h)
                        ((_epsilon_))
                        ((p.name is f)
                         ((_epsilon_))
                         ((n.n.n.name is g)
                          ((_epsilon_))
                          ((p.p.p.name is e)
                           ((p.p.name is k) ((_epsilon_)) ((E:)))
                           ((p.p.name is #)
                            ((n.n.n.name is c)
                             ((E:))
                             ((n.n.n.name is t) ((E:)) ((_epsilon_))))
                            ((p.name is #) ((_epsilon_)) ((E:)))))))))
                      ((n.n.n.name is p)
                       ((_epsilon_))
                       ((p.name is r)
                        ((n.n.name is m)
                         ((E:))
                         ((n.n.name is s) ((E:)) ((_epsilon_))))
                        ((p.name is d)
                         ((_epsilon_))
                         ((p.name is k)
                          ((n.n.name is m) ((E:)) ((_epsilon_)))
                          ((n.n.name is c)
                           ((p.name is t)
                            ((E:))
                            ((p.name is f)
                             ((p.p.p.name is u)
                              ((E:))
                              ((p.p.p.name is z)
                               ((E:))
                               ((p.p.name is #) ((E:)) ((_epsilon_)))))
                             ((p.name is n)
                              ((p.p.name is #) ((E:)) ((_epsilon_)))
                              ((_epsilon_)))))
                           ((p.p.name is h)
                            ((E:))
                            ((p.name is m)
                             ((n.n.name is d) ((E:)) ((_epsilon_)))
                             ((n.n.name is f)
                              ((_epsilon_))
                              ((p.p.name is b)
                               ((E:))
                               ((p.p.name is c)
                                ((_epsilon_))
                                ((p.p.name is a)
                                 ((p.p.p.name is n)
                                  ((E:))
                                  ((_epsilon_)))
                                 ((n.n.name is d)
                                  ((p.name is l) ((E:)) ((_epsilon_)))
                                  ((_epsilon_))))))))))))))))))))))))))))))))
    ((n.n.name is e)
     ((p.name is #)
      ((n.name is n)
       ((a))
       ((n.name is l)
        ((a))
        ((n.name is m)
         ((a))
         ((n.name is s)
          ((a))
          ((n.name is g)
           ((a))
           ((n.name is t)
            ((a:))
            ((n.n.n.name is n)
             ((a:))
             ((n.name is d) ((a:)) ((n.n.n.name is r) ((a:)) ((a)))))))))))
      ((n.name is i)
       ((aI))
       ((n.name is g)
        ((p.p.name is a)
         ((p.p.p.name is p) ((a)) ((I)))
         ((p.p.p.name is o)
          ((p.name is s) ((E:)) ((a:)))
          ((p.p.p.name is #) ((n.n.n.name is n) ((a)) ((a:))) ((a:)))))
        ((p.name is b)
         ((n.name is r)
          ((a:))
          ((n.name is d)
           ((a:))
           ((n.n.n.name is r)
            ((a:))
            ((p.p.name is r) ((a:)) ((n.n.n.name is n) ((a:)) ((a)))))))
         ((n.n.n.name is u)
          ((n.name is l) ((a:)) ((a)))
          ((n.n.n.name is #)
           ((a:))
           ((p.name is k)
            ((p.p.name is i)
             ((a:))
             ((p.p.name is o)
              ((a:))
              ((n.name is b)
               ((a:))
               ((p.p.p.name is b)
                ((a:))
                ((p.p.p.name is a)
                 ((a:))
                 ((p.p.name is r)
                  ((a:))
                  ((p.p.name is s)
                   ((a:))
                   ((n.name is p)
                    ((a:))
                    ((n.n.n.name is m)
                     ((a))
                     ((p.p.p.name is d)
                      ((a))
                      ((p.p.name is #)
                       ((a))
                       ((n.n.n.name is r) ((a)) ((a:))))))))))))))
            ((n.name is d)
             ((p.p.name is i) ((a)) ((a:)))
             ((n.n.n.name is t)
              ((n.name is t)
               ((a:))
               ((p.p.name is p)
                ((a))
                ((p.name is l)
                 ((a:))
                 ((p.name is h)
                  ((a:))
                  ((n.name is l)
                   ((a:))
                   ((n.name is k)
                    ((a))
                    ((p.name is r)
                     ((a:))
                     ((p.p.name is s)
                      ((a:))
                      ((p.p.p.name is #)
                       ((a))
                       ((p.p.name is #)
                        ((a))
                        ((n.name is r) ((a)) ((a:)))))))))))))
              ((n.n.n.name is z)
               ((a))
               ((n.name is s)
                ((a:))
                ((p.p.name is #)
                 ((p.name is p)
                  ((a))
                  ((p.name is n)
                   ((a:))
                   ((p.name is m)
                    ((n.name is t) ((a)) ((n.name is j) ((a)) ((a:))))
                    ((p.name is l)
                     ((n.name is t) ((a)) ((n.name is x) ((a)) ((a:))))
                     ((p.name is t)
                      ((n.name is b)
                       ((a))
                       ((n.name is l) ((a)) ((a:))))
                      ((n.n.n.name is n)
                       ((a:))
                       ((n.name is b)
                        ((a:))
                        ((p.name is v)
                         ((a:))
                         ((n.name is n)
                          ((a:))
                          ((n.n.n.name is r) ((a:)) ((a))))))))))))
                 ((n.name is m)
                  ((p.name is s)
                   ((a:))
                   ((n.n.n.name is h)
                    ((a:))
                    ((p.p.name is g)
                     ((a:))
                     ((p.p.p.name is i)
                      ((a:))
                      ((p.p.name is r)
                       ((a))
                       ((p.p.name is s)
                        ((a))
                        ((p.p.p.name is p)
                         ((a))
                         ((n.n.n.name is s)
                          ((a))
                          ((p.p.p.name is a)
                           ((a))
                           ((p.name is d)
                            ((a))
                            ((n.n.n.name is n) ((a:)) ((a)))))))))))))
                  ((n.n.n.name is k)
                   ((a))
                   ((n.name is b)
                    ((a:))
                    ((n.n.n.name is e)
                     ((a))
                     ((n.n.n.name is l)
                      ((n.name is k)
                       ((a:))
                       ((p.p.name is s)
                        ((p.p.p.name is #)
                         ((a:))
                         ((p.p.p.name is f) ((a)) ((a:))))
                        ((n.name is f) ((a:)) ((a)))))
                      ((p.p.p.name is #)
                       ((p.p.name is t)
                        ((a))
                        ((p.p.name is s)
                         ((a:))
                         ((n.name is r)
                          ((a:))
                          ((n.n.n.name is s)
                           ((a:))
                           ((n.n.n.name is n)
                            ((a:))
                            ((p.name is r) ((a:)) ((a))))))))
                       ((p.p.p.name is s)
                        ((a:))
                        ((p.name is v)
                         ((n.name is l) ((a)) ((a:)))
                         ((p.p.name is m)
                          ((a))
                          ((n.n.n.name is i)
                           ((a))
                           ((p.p.p.name is n)
                            ((p.p.name is s) ((a)) ((a:)))
                            ((n.name is z)
                             ((a))
                             ((p.p.name is n)
                              ((p.p.p.name is u) ((a)) ((a:)))
                              ((n.name is l)
                               ((a:))
                               ((n.n.n.name is r)
                                ((p.p.p.name is o) ((a)) ((a:)))
                                ((p.p.name is o)
                                 ((p.p.p.name is r)
                                  ((a:))
                                  ((p.p.p.name is t)
                                   ((a:))
                                   ((n.n.n.name is n)
                                    ((n.name is t) ((a:)) ((a)))
                                    ((a:)))))
                                 ((a:))))))))))))))))))))))))))))))
     ((n.name is h)
      ((n.n.name is i)
       ((p.p.name is #) ((a:)) ((a)))
       ((n.n.name is a)
        ((a))
        ((p.name is z) ((p.p.p.name is u) ((E:)) ((a:))) ((a:)))))
      ((n.name is a)
       ((n.n.n.name is t)
        ((p.name is r)
         ((a:))
         ((p.name is h)
          ((_epsilon_))
          ((p.name is p) ((_epsilon_)) ((a:)))))
        ((_epsilon_)))
       ((p.name is #)
        ((n.name is r)
         ((n.n.name is z) ((a:)) ((a)))
         ((n.name is t)
          ((n.n.name is m) ((a:)) ((a)))
          ((n.name is d) ((n.n.name is l) ((a:)) ((a))) ((a)))))
        ((n.name is i)
         ((n.n.n.name is c)
          ((p.p.p.name is r)
           ((a:))
           ((p.p.p.name is t) ((a)) ((p.p.p.name is n) ((a)) ((a:)))))
          ((p.p.name is t)
           ((p.name is r)
            ((p.p.p.name is s)
             ((E))
             ((p.p.p.name is r) ((E)) ((p.p.p.name is #) ((E:)) ((E)))))
            ((aI)))
           ((n.n.name is l)
            ((n.n.n.name is l) ((a)) ((_epsilon_)))
            ((n.n.name is r)
             ((E:))
             ((n.n.n.name is o)
              ((E))
              ((p.name is n)
               ((a))
               ((p.p.name is #)
                ((aI))
                ((n.n.name is n)
                 ((p.p.name is n) ((aI)) ((E)))
                 ((p.p.p.name is r)
                  ((a))
                  ((n.n.name is k) ((a)) ((aI))))))))))))
         ((n.n.name is #)
          ((p.name is h)
           ((n.name is t) ((a)) ((a:)))
           ((n.name is k) ((_epsilon_)) ((a:))))
          ((n.name is n)
           ((n.n.name is i)
            ((p.p.name is #)
             ((a))
             ((p.name is g)
              ((a))
              ((n.n.n.name is e)
               ((p.p.name is s) ((a:)) ((p.name is l) ((a:)) ((a))))
               ((p.name is w)
                ((a))
                ((p.p.p.name is e)
                 ((a:))
                 ((p.p.name is o)
                  ((p.name is m) ((a:)) ((a)))
                  ((p.name is t)
                   ((a:))
                   ((n.n.n.name is s)
                    ((p.p.p.name is s) ((a)) ((a:)))
                    ((p.p.name is t) ((a:)) ((a)))))))))))
            ((n.n.name is c)
             ((p.p.p.name is m) ((a)) ((p.p.name is #) ((a)) ((a~:))))
             ((p.p.name is p)
              ((p.name is l)
               ((n.n.n.name is t)
                ((a))
                ((n.n.name is t)
                 ((n.n.n.name is e) ((a:)) ((a)))
                 ((a:))))
               ((a)))
              ((n.n.n.name is i)
               ((n.n.name is g)
                ((p.p.name is c)
                 ((a~:))
                 ((p.name is r)
                  ((p.p.name is #)
                   ((a~:))
                   ((p.p.p.name is u) ((a~:)) ((a))))
                  ((a))))
                ((p.name is h) ((n.n.name is d) ((E)) ((a))) ((a))))
               ((n.n.name is a)
                ((n.n.n.name is g)
                 ((E))
                 ((p.p.p.name is u)
                  ((a:))
                  ((n.n.n.name is t)
                   ((a))
                   ((n.n.n.name is l)
                    ((a))
                    ((p.p.name is #)
                     ((a))
                     ((p.p.p.name is a) ((a)) ((a:))))))))
                ((n.n.name is s)
                 ((n.n.n.name is #)
                  ((a:))
                  ((p.p.p.name is u) ((a:)) ((a))))
                 ((n.n.name is h)
                  ((a:))
                  ((p.p.name is a)
                   ((p.p.p.name is #)
                    ((a~:))
                    ((p.p.p.name is h) ((a~:)) ((a))))
                   ((n.n.name is o)
                    ((p.name is k) ((a:)) ((a)))
                    ((p.p.p.name is l)
                     ((p.name is g) ((a~:)) ((a)))
                     ((n.n.name is m)
                      ((a:))
                      ((n.n.n.name is r)
                       ((a))
                       ((p.p.name is z)
                        ((a))
                        ((p.name is p)
                         ((n.n.name is n)
                          ((a))
                          ((p.p.name is s) ((a:)) ((a))))
                         ((a))))))))))))))))
           ((n.name is g)
            ((n.n.name is t)
             ((a:))
             ((n.n.name is s)
              ((a:))
              ((p.p.p.name is c)
               ((a:))
               ((p.p.name is t)
                ((n.n.name is i) ((a)) ((n.n.name is n) ((a)) ((a:))))
                ((p.name is j)
                 ((a:))
                 ((n.n.name is l)
                  ((p.p.name is #) ((a)) ((a:)))
                  ((n.n.name is h)
                   ((a:))
                   ((n.n.name is b)
                    ((a:))
                    ((n.n.name is w)
                     ((a:))
                     ((n.n.name is u)
                      ((n.n.n.name is n) ((a:)) ((a)))
                      ((n.n.name is r)
                       ((n.n.n.name is a) ((a)) ((a:)))
                       ((n.n.name is i)
                        ((p.p.name is e) ((a:)) ((a)))
                        ((a))))))))))))))
            ((p.name is h)
             ((n.name is f)
              ((n.n.name is t) ((a)) ((n.n.name is f) ((a)) ((a:))))
              ((n.name is l)
               ((n.n.name is i)
                ((n.n.n.name is e) ((a)) ((a:)))
                ((n.n.name is t)
                 ((a))
                 ((p.p.name is p)
                  ((a:))
                  ((p.p.p.name is s)
                   ((n.n.name is l)
                    ((a))
                    ((n.n.name is k) ((a)) ((a:))))
                   ((a))))))
               ((n.name is b)
                ((n.n.name is t)
                 ((a:))
                 ((p.p.name is c) ((a)) ((n.n.name is i) ((a)) ((a:)))))
                ((n.name is k)
                 ((a:))
                 ((p.p.name is c)
                  ((n.name is m)
                   ((p.p.p.name is s)
                    ((n.n.name is p) ((a)) ((a:)))
                    ((a)))
                   ((p.p.p.name is s)
                    ((n.name is d)
                     ((n.n.name is i) ((a)) ((a:)))
                     ((a)))
                    ((n.n.n.name is i) ((a:)) ((a)))))
                  ((n.n.name is z)
                   ((a:))
                   ((n.n.name is i)
                    ((p.p.p.name is #) ((a)) ((a:)))
                    ((a)))))))))
             ((n.n.name is s)
              ((n.name is s)
               ((p.name is m)
                ((n.n.n.name is i)
                 ((a))
                 ((n.n.n.name is a)
                  ((a))
                  ((n.n.n.name is e)
                   ((p.p.name is #) ((a)) ((a:)))
                   ((a:)))))
                ((p.p.p.name is s)
                 ((a:))
                 ((p.name is s)
                  ((a:))
                  ((p.p.name is s)
                   ((p.p.p.name is #) ((a:)) ((a)))
                   ((p.p.name is f) ((p.name is r) ((a:)) ((a))) ((a)))))))
               ((n.n.n.name is c)
                ((n.name is d)
                 ((a:))
                 ((p.name is w)
                  ((a:))
                  ((p.p.name is t)
                   ((a:))
                   ((p.p.p.name is l)
                    ((a:))
                    ((p.name is m)
                     ((a))
                     ((n.name is r)
                      ((p.p.name is #) ((a)) ((a:)))
                      ((p.name is r)
                       ((n.name is t) ((a:)) ((a)))
                       ((a)))))))))
                ((n.name is p)
                 ((a))
                 ((n.name is b)
                  ((p.name is g) ((a:)) ((p.p.name is s) ((a:)) ((a))))
                  ((p.p.name is #)
                   ((n.name is t)
                    ((a:))
                    ((n.name is d)
                     ((a:))
                     ((p.name is f)
                      ((a))
                      ((p.name is g)
                       ((a))
                       ((p.name is b) ((a)) ((a:)))))))
                   ((n.name is k)
                    ((p.p.p.name is #) ((a:)) ((a)))
                    ((n.n.n.name is i)
                     ((p.p.name is b) ((a)) ((a:)))
                     ((n.n.n.name is t)
                      ((a:))
                      ((n.name is m)
                       ((a))
                       ((p.name is b)
                        ((n.name is d) ((a:)) ((a)))
                        ((a:))))))))))))
              ((p.name is n)
               ((n.n.name is h)
                ((p.p.name is #)
                 ((n.n.n.name is t) ((a)) ((a:)))
                 ((p.p.name is n)
                  ((a:))
                  ((p.p.p.name is b)
                   ((a:))
                   ((n.n.n.name is t)
                    ((a))
                    ((n.name is c)
                     ((p.p.p.name is e) ((a:)) ((a)))
                     ((a)))))))
                ((p.p.p.name is #)
                 ((p.p.name is u) ((n.name is r) ((a:)) ((a))) ((a)))
                 ((n.name is t)
                  ((n.n.n.name is s)
                   ((a:))
                   ((n.n.name is u)
                    ((a))
                    ((n.n.name is i)
                     ((a))
                     ((n.n.name is t)
                      ((a))
                      ((n.n.name is o) ((a)) ((a:)))))))
                  ((p.p.p.name is c)
                   ((a))
                   ((p.p.name is k)
                    ((a))
                    ((p.p.name is #)
                     ((n.n.name is l)
                      ((a:))
                      ((n.n.n.name is u) ((a:)) ((a))))
                     ((n.name is p)
                      ((a))
                      ((p.p.p.name is h)
                       ((p.p.name is e)
                        ((n.n.n.name is e) ((a)) ((a:)))
                        ((a)))
                       ((n.n.n.name is h)
                        ((a))
                        ((p.p.p.name is e)
                         ((n.n.name is i) ((a:)) ((a)))
                         ((n.n.name is y)
                          ((a))
                          ((n.name is z)
                           ((a))
                           ((n.n.name is m)
                            ((a))
                            ((p.p.p.name is b)
                             ((p.p.name is e) ((a)) ((a:)))
                             ((n.n.n.name is g)
                              ((a:))
                              ((p.p.name is m)
                               ((a))
                               ((n.n.n.name is s)
                                ((n.name is l)
                                 ((p.p.p.name is m)
                                  ((a))
                                  ((p.p.p.name is i) ((a)) ((a:))))
                                 ((a:)))
                                ((n.name is l)
                                 ((a:))
                                 ((n.n.name is b)
                                  ((a))
                                  ((p.p.name is i)
                                   ((a:))
                                   ((n.name is r)
                                    ((p.p.p.name is n)
                                     ((a:))
                                     ((n.n.name is z)
                                      ((a:))
                                      ((p.p.p.name is t)
                                       ((a:))
                                       ((n.n.name is t) ((a:)) ((a))))))
                                    ((n.n.name is t) ((a)) ((a:))))))))))))))))))))))))
               ((p.p.name is #)
                ((n.name is d)
                 ((n.n.n.name is o)
                  ((a:))
                  ((n.n.name is f)
                   ((a:))
                   ((n.n.n.name is g)
                    ((a:))
                    ((n.n.n.name is u)
                     ((a:))
                     ((p.name is r)
                      ((n.n.name is i)
                       ((a))
                       ((n.n.name is a) ((a)) ((a:))))
                      ((a)))))))
                 ((n.name is c)
                  ((a))
                  ((p.name is d)
                   ((n.n.name is p)
                    ((a))
                    ((n.n.n.name is n)
                     ((a:))
                     ((n.name is r)
                      ((n.n.n.name is i) ((a)) ((a:)))
                      ((n.n.name is a) ((a:)) ((a))))))
                   ((p.name is z)
                    ((n.name is p) ((a)) ((a:)))
                    ((p.name is p)
                     ((a))
                     ((p.name is a)
                      ((a:))
                      ((n.n.n.name is #)
                       ((n.name is l) ((a)) ((a:)))
                       ((p.name is k)
                        ((a))
                        ((n.n.n.name is i)
                         ((a))
                         ((n.n.name is m)
                          ((a))
                          ((n.n.name is c)
                           ((a))
                           ((p.name is b)
                            ((n.name is r)
                             ((n.n.name is o) ((a)) ((a:)))
                             ((a)))
                            ((n.n.name is a)
                             ((n.n.n.name is k)
                              ((a:))
                              ((p.name is l)
                               ((a:))
                               ((n.name is t)
                                ((p.name is s) ((a:)) ((a)))
                                ((n.name is r)
                                 ((n.n.n.name is n) ((a)) ((a:)))
                                 ((a))))))
                             ((p.name is v)
                              ((n.name is k) ((a:)) ((a)))
                              ((p.name is g)
                               ((n.name is r)
                                ((n.n.name is t) ((a:)) ((a)))
                                ((a)))
                               ((n.n.n.name is a)
                                ((n.n.name is f) ((a:)) ((a)))
                                ((n.name is t)
                                 ((p.name is t)
                                  ((n.n.name is t) ((a)) ((a:)))
                                  ((p.name is r)
                                   ((n.n.name is i)
                                    ((a))
                                    ((n.n.name is t) ((a)) ((a:))))
                                   ((a))))
                                 ((p.name is w)
                                  ((a))
                                  ((n.n.name is n)
                                   ((a))
                                   ((n.name is k)
                                    ((n.n.name is t)
                                     ((a))
                                     ((n.n.name is u)
                                      ((a))
                                      ((p.name is m) ((a:)) ((a)))))
                                    ((a))))))))))))))))))))))
                ((n.n.n.name is s)
                 ((n.n.name is i)
                  ((n.name is l)
                   ((p.name is k)
                    ((a:))
                    ((p.name is u)
                     ((a))
                     ((p.p.p.name is t)
                      ((a))
                      ((p.name is e)
                       ((a))
                       ((p.p.p.name is s)
                        ((a:))
                        ((p.p.p.name is p)
                         ((a:))
                         ((p.p.p.name is #)
                          ((a))
                          ((p.p.p.name is u)
                           ((a))
                           ((p.p.name is r)
                            ((p.p.p.name is e)
                             ((p.name is b) ((a:)) ((a)))
                             ((a)))
                            ((p.p.name is t)
                             ((a:))
                             ((p.p.name is s)
                              ((a:))
                              ((p.p.p.name is r)
                               ((a))
                               ((p.p.name is e)
                                ((p.p.p.name is n)
                                 ((a))
                                 ((p.p.p.name is b) ((a)) ((a:))))
                                ((p.name is t)
                                 ((p.p.p.name is e) ((a:)) ((a)))
                                 ((p.p.name is i)
                                  ((a:))
                                  ((p.name is d)
                                   ((a))
                                   ((p.p.p.name is e)
                                    ((a:))
                                    ((p.p.p.name is m)
                                     ((a:))
                                     ((p.p.p.name is o) ((a:)) ((a)))))))))))))))))))))
                   ((n.name is x)
                    ((a))
                    ((p.p.p.name is #)
                     ((n.name is v)
                      ((a))
                      ((p.p.name is s) ((a)) ((a:))))
                     ((p.p.name is s)
                      ((a:))
                      ((p.p.p.name is h)
                       ((a))
                       ((p.p.p.name is l)
                        ((p.p.name is i)
                         ((p.name is m) ((a)) ((a:)))
                         ((p.name is t) ((a)) ((a:))))
                        ((p.p.p.name is n)
                         ((a:))
                         ((p.p.p.name is r)
                          ((a:))
                          ((p.p.p.name is s)
                           ((a:))
                           ((p.p.name is a)
                            ((a))
                            ((n.name is d)
                             ((a:))
                             ((p.p.p.name is k)
                              ((a:))
                              ((p.p.name is h)
                               ((a:))
                               ((p.p.p.name is e)
                                ((a:))
                                ((p.p.name is u)
                                 ((a:))
                                 ((p.p.name is l)
                                  ((a:))
                                  ((p.name is r)
                                   ((a:))
                                   ((p.p.p.name is m)
                                    ((a:))
                                    ((p.name is b)
                                     ((a:))
                                     ((n.name is t)
                                      ((p.p.p.name is a)
                                       ((p.p.name is g) ((a)) ((a:)))
                                       ((a:)))
                                      ((p.name is l) ((a:)) ((a)))))))))))))))))))))))
                  ((p.p.name is p)
                   ((p.p.p.name is #) ((a)) ((a:)))
                   ((p.name is w)
                    ((a))
                    ((n.n.name is t)
                     ((n.name is r)
                      ((p.p.p.name is #) ((a)) ((a:)))
                      ((p.p.p.name is b) ((a:)) ((a))))
                     ((p.name is t)
                      ((n.n.name is h) ((a:)) ((a)))
                      ((n.n.name is a)
                       ((a))
                       ((p.p.name is b)
                        ((p.name is r) ((a:)) ((a)))
                        ((a)))))))))
                 ((n.name is #)
                  ((a:))
                  ((p.name is a)
                   ((a:))
                   ((p.name is w)
                    ((a))
                    ((n.name is m)
                     ((n.n.name is m)
                      ((a))
                      ((n.n.name is p)
                       ((p.p.name is t)
                        ((p.p.p.name is s)
                         ((a))
                         ((n.n.n.name is f) ((a)) ((E))))
                        ((a)))
                       ((p.name is k)
                        ((a:))
                        ((n.n.name is k)
                         ((a:))
                         ((p.name is r)
                          ((p.p.name is d)
                           ((a:))
                           ((p.p.name is k)
                            ((a:))
                            ((p.p.p.name is p)
                             ((a))
                             ((p.p.p.name is #)
                              ((a))
                              ((n.n.name is t) ((a)) ((a:)))))))
                          ((p.p.p.name is a)
                           ((n.n.name is i) ((a:)) ((a)))
                           ((p.p.p.name is n)
                            ((a))
                            ((p.p.name is a)
                             ((p.name is l) ((a:)) ((a)))
                             ((a))))))))))
                     ((n.n.n.name is t)
                      ((n.n.name is z)
                       ((n.name is r) ((a:)) ((a)))
                       ((n.name is l)
                        ((n.n.name is i)
                         ((p.p.p.name is #)
                          ((a))
                          ((p.p.name is o) ((a)) ((a:))))
                         ((a)))
                        ((p.name is r)
                         ((a))
                         ((p.name is t)
                          ((n.name is c)
                           ((p.p.name is s) ((a:)) ((a)))
                           ((a)))
                          ((a))))))
                      ((p.name is f)
                       ((a))
                       ((p.p.p.name is s)
                        ((n.name is c)
                         ((a:))
                         ((n.name is f)
                          ((p.p.name is t)
                           ((n.n.name is f) ((a)) ((a:)))
                           ((a)))
                          ((n.n.name is l)
                           ((a:))
                           ((p.p.name is p)
                            ((a))
                            ((p.name is l)
                             ((n.n.name is i) ((a:)) ((a)))
                             ((n.n.name is a)
                              ((a))
                              ((n.name is t)
                               ((a))
                               ((p.name is m)
                                ((n.name is l) ((a:)) ((a)))
                                ((n.name is l)
                                 ((a))
                                 ((n.n.n.name is l)
                                  ((a))
                                  ((n.name is k)
                                   ((a))
                                   ((n.name is r) ((a)) ((a:))))))))))))))
                        ((n.name is b)
                         ((n.n.name is l)
                          ((n.n.n.name is e) ((a:)) ((a)))
                          ((n.n.name is t)
                           ((a:))
                           ((p.name is t)
                            ((n.n.n.name is l)
                             ((a))
                             ((p.p.name is l) ((a)) ((a:))))
                            ((a)))))
                         ((n.name is r)
                          ((p.name is l)
                           ((p.p.name is k)
                            ((a:))
                            ((n.n.name is t)
                             ((a:))
                             ((p.p.p.name is p)
                              ((a:))
                              ((p.p.p.name is t)
                               ((a:))
                               ((n.n.name is i) ((a:)) ((a)))))))
                           ((n.n.name is t)
                            ((p.p.name is q)
                             ((a))
                             ((n.n.n.name is i)
                              ((p.name is p)
                               ((a))
                               ((p.p.p.name is n)
                                ((a))
                                ((p.p.name is i) ((a)) ((a:)))))
                              ((n.n.n.name is #)
                               ((a:))
                               ((p.name is b)
                                ((a:))
                                ((p.name is t)
                                 ((a))
                                 ((p.name is p)
                                  ((p.p.name is s)
                                   ((n.n.n.name is e) ((a:)) ((a)))
                                   ((a)))
                                  ((p.name is k) ((a)) ((a:)))))))))
                            ((p.name is b)
                             ((n.n.name is k)
                              ((a:))
                              ((n.n.name is m)
                               ((a))
                               ((p.p.p.name is p)
                                ((a:))
                                ((p.p.p.name is o)
                                 ((a))
                                 ((n.n.n.name is i) ((a)) ((a:)))))))
                             ((n.n.name is z)
                              ((a:))
                              ((n.n.name is i)
                               ((p.name is u)
                                ((a:))
                                ((p.p.p.name is i)
                                 ((a))
                                 ((p.p.p.name is h)
                                  ((a))
                                  ((p.name is p)
                                   ((a))
                                   ((n.n.n.name is f)
                                    ((a))
                                    ((n.n.n.name is e)
                                     ((a:))
                                     ((p.name is t) ((a:)) ((a)))))))))
                               ((p.name is p)
                                ((p.p.name is s)
                                 ((n.n.n.name is u)
                                  ((a:))
                                  ((n.n.n.name is e) ((a)) ((a:))))
                                 ((a)))
                                ((p.p.name is n)
                                 ((p.p.p.name is a)
                                  ((a))
                                  ((p.p.p.name is i) ((a)) ((a:))))
                                 ((a)))))))))
                          ((n.n.name is t)
                           ((p.p.p.name is c)
                            ((p.name is l) ((a:)) ((a)))
                            ((p.name is m)
                             ((n.name is l) ((a:)) ((a)))
                             ((n.n.n.name is #)
                              ((n.name is s)
                               ((p.name is l) ((a:)) ((a)))
                               ((a)))
                              ((p.name is o)
                               ((p.p.p.name is d) ((a)) ((_epsilon_)))
                               ((n.n.n.name is r)
                                ((p.name is t)
                                 ((a))
                                 ((p.p.p.name is n) ((a)) ((a:))))
                                ((p.p.name is g)
                                 ((p.p.p.name is r) ((a:)) ((a)))
                                 ((a))))))))
                           ((p.p.name is g)
                            ((n.name is p)
                             ((a:))
                             ((n.n.n.name is k)
                              ((a:))
                              ((n.n.n.name is o)
                               ((a:))
                               ((n.n.n.name is g)
                                ((a:))
                                ((n.name is s)
                                 ((a:))
                                 ((n.name is l)
                                  ((a:))
                                  ((n.n.n.name is e)
                                   ((p.p.p.name is #) ((a:)) ((a)))
                                   ((a)))))))))
                            ((n.name is l)
                             ((p.p.name is s)
                              ((a))
                              ((p.name is i)
                               ((a:))
                               ((n.n.name is l)
                                ((n.n.n.name is o) ((a:)) ((a)))
                                ((n.n.name is z)
                                 ((a))
                                 ((p.name is m)
                                  ((p.p.name is a) ((a)) ((a:)))
                                  ((p.p.name is t)
                                   ((a:))
                                   ((p.name is d)
                                    ((a:))
                                    ((p.p.name is o)
                                     ((a:))
                                     ((p.p.p.name is p)
                                      ((a:))
                                      ((p.p.name is q)
                                       ((a))
                                       ((p.name is v)
                                        ((a))
                                        ((n.n.name is o)
                                         ((a))
                                         ((p.name is t)
                                          ((a:))
                                          ((n.n.name is a)
                                           ((a))
                                           ((n.n.name is k)
                                            ((a))
                                            ((p.name is s)
                                             ((a))
                                             ((p.p.p.name is a)
                                              ((a:))
                                              ((n.n.name is i)
                                               ((a))
                                               ((n.n.n.name is e)
                                                ((a))
                                                ((p.name is r)
                                                 ((a))
                                                 ((a:))))))))))))))))))))))
                             ((n.n.name is k)
                              ((a))
                              ((n.n.n.name is o)
                               ((n.n.name is l)
                                ((a:))
                                ((n.name is t)
                                 ((a))
                                 ((p.name is p)
                                  ((a))
                                  ((n.n.name is i)
                                   ((a:))
                                   ((p.name is l) ((a:)) ((a)))))))
                               ((p.p.name is i)
                                ((n.n.n.name is e)
                                 ((a:))
                                 ((p.p.p.name is d)
                                  ((a))
                                  ((p.name is r)
                                   ((a))
                                   ((n.n.name is i)
                                    ((p.name is t) ((a:)) ((a)))
                                    ((n.n.n.name is r)
                                     ((p.name is l)
                                      ((a:))
                                      ((p.p.p.name is g)
                                       ((a:))
                                       ((p.p.p.name is l) ((a:)) ((a)))))
                                     ((a:)))))))
                                ((n.name is p)
                                 ((a))
                                 ((p.p.name is b)
                                  ((p.name is r)
                                   ((n.n.name is h)
                                    ((a:))
                                    ((n.name is t) ((a:)) ((a))))
                                   ((n.name is s)
                                    ((p.p.p.name is #) ((a)) ((a:)))
                                    ((a))))
                                  ((p.p.name is h)
                                   ((n.n.n.name is b)
                                    ((a:))
                                    ((p.p.p.name is p)
                                     ((a:))
                                     ((n.n.name is w)
                                      ((a:))
                                      ((n.n.n.name is e)
                                       ((a))
                                       ((n.name is c)
                                        ((a:))
                                        ((p.name is l)
                                         ((a:))
                                         ((n.name is t)
                                          ((p.name is e)
                                           ((a))
                                           ((n.n.n.name is l)
                                            ((a))
                                            ((a:))))
                                          ((a)))))))))
                                   ((n.name is c)
                                    ((a))
                                    ((n.n.n.name is v)
                                     ((a))
                                     ((n.n.name is z)
                                      ((a))
                                      ((n.name is t)
                                       ((n.n.name is u)
                                        ((a))
                                        ((n.n.name is m)
                                         ((a:))
                                         ((p.p.name is k)
                                          ((a))
                                          ((p.p.p.name is u)
                                           ((a))
                                           ((n.n.name is r)
                                            ((p.name is i)
                                             ((a:))
                                             ((a)))
                                            ((n.n.n.name is i)
                                             ((a:))
                                             ((p.p.name is m)
                                              ((a))
                                              ((p.p.p.name is l)
                                               ((a:))
                                               ((p.name is k)
                                                ((a))
                                                ((p.name is r)
                                                 ((a:))
                                                 ((n.n.n.name is #)
                                                  ((a:))
                                                  ((n.n.n.name is k)
                                                   ((a:))
                                                   ((p.name is p)
                                                    ((a:))
                                                    ((p.p.name is s)
                                                     ((a))
                                                     ((p.p.name is e)
                                                      ((a))
                                                      ((n.n.n.name
                                                        is
                                                        r)
                                                       ((p.name is l)
                                                        ((a))
                                                        ((a:)))
                                                       ((n.n.name is i)
                                                        ((p.name is d)
                                                         ((a))
                                                         ((a:)))
                                                        ((a)))))))))))))))))))
                                       ((n.n.n.name is g)
                                        ((a:))
                                        ((n.n.name is l)
                                         ((a:))
                                         ((p.p.p.name is l)
                                          ((n.n.n.name is e)
                                           ((a))
                                           ((a:)))
                                          ((p.p.name is o)
                                           ((n.n.name is a)
                                            ((a:))
                                            ((a)))
                                           ((n.name is d)
                                            ((p.name is l)
                                             ((a:))
                                             ((a)))
                                            ((n.n.n.name is a)
                                             ((n.name is s)
                                              ((a))
                                              ((a:)))
                                             ((a))))))))))))))))))))))))))))))))))))))))))))))
 (b
  ((p.p.name is #)
   ((n.name is e)
    ((n.n.n.name is k) ((p)) ((b)))
    ((n.name is o) ((b)) ((n.name is i) ((b)) ((p)))))
   ((n.name is s)
    ((p))
    ((n.name is t)
     ((p))
     ((n.name is b)
      ((p.p.name is e)
       ((p))
       ((p.p.name is a)
        ((p))
        ((p.p.name is i)
         ((p))
         ((p.p.p.name is #)
          ((_epsilon_))
          ((p.p.p.name is t)
           ((_epsilon_))
           ((p.p.p.name is q)
            ((_epsilon_))
            ((p.p.p.name is e)
             ((_epsilon_))
             ((p.p.name is l)
              ((_epsilon_))
              ((p.p.name is w)
               ((_epsilon_))
               ((p.p.p.name is k)
                ((p.p.name is r)
                 ((n.n.n.name is i) ((_epsilon_)) ((b)))
                 ((_epsilon_)))
                ((p.p.p.name is b)
                 ((_epsilon_))
                 ((n.n.n.name is r)
                  ((p))
                  ((p.p.name is r) ((p)) ((_epsilon_)))))))))))))))
      ((n.name is e)
       ((p.p.name is a)
        ((n.n.n.name is i)
         ((p.p.p.name is l) ((_epsilon_)) ((b)))
         ((b)))
        ((b)))
       ((n.name is #)
        ((p))
        ((n.name is h)
         ((p))
         ((n.name is f)
          ((p))
          ((n.name is g)
           ((p))
           ((n.name is n)
            ((n.n.n.name is r) ((b)) ((p)))
            ((n.name is l)
             ((n.n.n.name is c)
              ((p.p.p.name is r)
               ((p.p.name is c) ((b)) ((p)))
               ((p.p.p.name is w)
                ((p))
                ((p.p.p.name is l)
                 ((p))
                 ((p.p.p.name is s)
                  ((p))
                  ((p.p.p.name is t)
                   ((p))
                   ((p.p.p.name is #)
                    ((p.p.name is a)
                     ((b))
                     ((p.p.name is u) ((b)) ((p))))
                    ((p.p.p.name is n)
                     ((p))
                     ((p.p.p.name is d) ((p)) ((b))))))))))
              ((n.n.n.name is d)
               ((p))
               ((p.p.name is a)
                ((p.p.p.name is #)
                 ((b))
                 ((n.n.n.name is g)
                  ((b))
                  ((p.p.p.name is s) ((b)) ((p)))))
                ((p.p.p.name is #)
                 ((p.p.name is l) ((p)) ((b)))
                 ((p.p.p.name is l)
                  ((p.p.name is i) ((p)) ((b)))
                  ((p.p.name is s)
                   ((b))
                   ((p.p.name is n)
                    ((p.p.p.name is e)
                     ((b))
                     ((p.p.p.name is o)
                      ((b))
                      ((p.p.p.name is i) ((b)) ((p)))))
                    ((p.p.p.name is b)
                     ((b))
                     ((p.p.p.name is e)
                      ((p.p.name is r)
                       ((n.n.n.name is e) ((p)) ((b)))
                       ((b)))
                      ((b)))))))))))
             ((n.name is w)
              ((p))
              ((n.name is j)
               ((p))
               ((n.name is k)
                ((p))
                ((n.name is m)
                 ((p))
                 ((n.name is d)
                  ((p))
                  ((n.name is z)
                   ((p))
                   ((n.name is p)
                    ((p))
                    ((n.name is v)
                     ((p))
                     ((n.name is c)
                      ((p))
                      ((p.p.p.name is l)
                       ((p.p.name is i)
                        ((n.name is i)
                         ((b))
                         ((n.name is r) ((b)) ((p))))
                        ((b)))
                       ((p.p.name is a)
                        ((p.p.p.name is #)
                         ((b))
                         ((n.name is i)
                          ((b))
                          ((n.n.n.name is t) ((p)) ((b)))))
                        ((p.p.name is r)
                         ((n.name is r)
                          ((n.n.n.name is i) ((p)) ((b)))
                          ((b)))
                         ((b))))))))))))))))))))))))))
 (c
  ((p.name is s)
   ((p.p.name is t)
    ((n.n.name is t)
     ((_epsilon_))
     ((p.p.p.name is u)
      ((n.n.name is r)
       ((S))
       ((n.n.n.name is n)
        ((n.n.name is e) ((_epsilon_)) ((S)))
        ((_epsilon_))))
      ((p.p.p.name is a)
       ((n.n.n.name is l)
        ((S))
        ((n.n.name is l)
         ((S))
         ((n.n.name is e)
          ((n.n.n.name is n)
           ((_epsilon_))
           ((n.n.n.name is #)
            ((_epsilon_))
            ((n.n.n.name is t) ((_epsilon_)) ((S)))))
          ((_epsilon_)))))
       ((p.p.p.name is #)
        ((_epsilon_))
        ((p.p.p.name is e)
         ((S))
         ((p.p.p.name is i)
          ((n.n.name is n) ((_epsilon_)) ((S)))
          ((S))))))))
    ((n.n.n.name is n)
     ((p.p.name is e)
      ((p.p.p.name is m) ((x)) ((S)))
      ((p.p.name is s) ((x)) ((S))))
     ((S))))
   ((n.name is h)
    ((n.n.name is s)
     ((n.n.n.name is e)
      ((p.name is r)
       ((x))
       ((p.p.name is n) ((x)) ((p.p.name is e) ((x)) ((k)))))
      ((p.p.name is w)
       ((n.n.n.name is i) ((x)) ((k)))
       ((p.name is i)
        ((x))
        ((p.p.p.name is w)
         ((n.n.n.name is t) ((x)) ((k)))
         ((p.p.name is #)
          ((k))
          ((p.p.name is f)
           ((p.name is a) ((x)) ((k)))
           ((p.p.name is s)
            ((p.p.p.name is #) ((k)) ((x)))
            ((p.p.name is l)
             ((p.name is o) ((x)) ((p.name is a) ((x)) ((k))))
             ((n.n.n.name is i) ((p.p.p.name is s) ((k)) ((x))) ((x)))))))))))
     ((p.name is #)
      ((n.n.name is e)
       ((x))
       ((n.n.name is i)
        ((x))
        ((n.n.name is a) ((n.n.n.name is r) ((k)) ((S))) ((k)))))
      ((p.name is n)
       ((n.n.name is e)
        ((p.p.name is a) ((S)) ((x)))
        ((n.n.name is i)
         ((S))
         ((p.p.p.name is n)
          ((S))
          ((n.n.name is r) ((k)) ((n.n.n.name is l) ((k)) ((x)))))))
       ((n.n.name is r)
        ((n.n.n.name is o)
         ((k))
         ((n.n.n.name is i)
          ((p.name is a) ((x)) ((p.p.p.name is d) ((x)) ((k))))
          ((x))))
        ((n.n.name is i)
         ((n.n.n.name is e) ((S)) ((p.p.name is m) ((k)) ((x))))
         ((p.p.name is o)
          ((n.n.n.name is s)
           ((p.name is r) ((k)) ((x)))
           ((p.p.p.name is s) ((S)) ((x))))
          ((n.n.name is o)
           ((p.p.p.name is p)
            ((x))
            ((p.p.p.name is #)
             ((x))
             ((p.name is e) ((x)) ((p.name is r) ((x)) ((k))))))
           ((p.name is b)
            ((p.p.p.name is #) ((S)) ((x)))
            ((p.name is t)
             ((x))
             ((p.name is m)
              ((x))
              ((n.n.name is a)
               ((x))
               ((n.n.name is e)
                ((p.p.p.name is #)
                 ((p.name is e) ((n.n.n.name is r) ((S)) ((x))) ((x)))
                 ((x)))
                ((x))))))))))))))
    ((n.name is k)
     ((_epsilon_))
     ((p.name is n)
      ((s))
      ((n.name is i)
       ((n.n.name is e) ((p.p.name is o) ((ts)) ((s))) ((ts)))
       ((n.name is e) ((s)) ((k)))))))))
 (d
  ((n.name is #)
   ((t))
   ((n.name is s)
    ((n.n.name is #)
     ((ts))
     ((n.n.n.name is #)
      ((ts))
      ((n.n.name is t)
       ((t))
       ((n.n.n.name is h)
        ((t))
        ((p.p.name is a)
         ((n.n.name is i) ((t)) ((ts)))
         ((n.n.n.name is o)
          ((ts))
          ((n.n.n.name is m)
           ((t))
           ((n.n.n.name is l)
            ((t))
            ((n.n.name is i)
             ((t))
             ((p.p.name is u)
              ((t))
              ((n.n.name is u)
               ((t))
               ((p.name is e) ((ts)) ((n.n.n.name is e) ((ts)) ((t)))))))))))))))
    ((n.name is e)
     ((n.n.name is i)
      ((p.name is n) ((p.p.name is i) ((d)) ((t))) ((d)))
      ((n.n.name is u)
       ((n.n.n.name is t) ((d)) ((p.name is e) ((t)) ((d))))
       ((n.n.n.name is f)
        ((p.p.name is e) ((p.name is i) ((t)) ((d))) ((d)))
        ((d)))))
     ((n.name is t)
      ((n.n.name is a)
       ((t))
       ((p.p.name is u)
        ((t))
        ((p.p.name is e)
         ((t))
         ((p.name is e)
          ((_epsilon_))
          ((p.name is a)
           ((_epsilon_))
           ((n.n.n.name is s)
            ((_epsilon_))
            ((n.n.name is s)
             ((_epsilon_))
             ((n.n.n.name is r)
              ((_epsilon_))
              ((n.n.n.name is n)
               ((_epsilon_))
               ((n.n.name is #)
                ((_epsilon_))
                ((n.n.n.name is #)
                 ((_epsilon_))
                 ((n.n.n.name is m) ((_epsilon_)) ((t))))))))))))))
      ((n.name is i)
       ((d))
       ((p.name is #)
        ((d))
        ((n.name is d)
         ((p.p.name is i)
          ((t))
          ((n.n.n.name is u) ((t)) ((_epsilon_))))
         ((n.name is u)
          ((d))
          ((n.name is r)
           ((p.name is l)
            ((n.n.name is u)
             ((d))
             ((p.p.name is l) ((d)) ((n.n.name is e) ((t)) ((d)))))
            ((p.name is n)
             ((p.p.name is u)
              ((t))
              ((p.p.name is i)
               ((d))
               ((n.n.name is a) ((p.p.name is e) ((d)) ((t))) ((d)))))
             ((d))))
           ((n.name is a)
            ((n.n.name is p)
             ((p.p.name is #) ((d)) ((t)))
             ((n.n.n.name is b)
              ((t))
              ((p.p.name is o)
               ((n.n.name is m) ((t)) ((d)))
               ((n.n.n.name is t)
                ((p.name is e)
                 ((d))
                 ((n.n.name is u)
                  ((d))
                  ((p.p.name is d)
                   ((d))
                   ((p.name is n) ((n.n.name is n) ((d)) ((t))) ((t))))))
                ((n.n.n.name is f) ((p.p.name is a) ((t)) ((d))) ((d)))))))
            ((n.name is o)
             ((n.n.n.name is t)
              ((p.p.name is #)
               ((d))
               ((p.name is n) ((n.n.name is r) ((t)) ((d))) ((t))))
              ((d)))
             ((n.name is n)
              ((n.n.name is e) ((d)) ((n.n.name is u) ((d)) ((t))))
              ((n.name is l)
               ((n.n.n.name is c)
                ((t))
                ((n.n.name is a)
                 ((t))
                 ((n.n.name is o)
                  ((t))
                  ((n.n.name is i)
                   ((p.name is a) ((d)) ((t)))
                   ((p.name is l) ((t)) ((p.p.name is u) ((t)) ((d))))))))
               ((n.name is y)
                ((d))
                ((p.p.name is b) ((_epsilon_)) ((t))))))))))))))))))
 (e
  ((n.name is i)
   ((p.name is a)
    ((_epsilon_))
    ((p.name is o)
     ((_epsilon_))
     ((n.n.n.name is r)
      ((n.n.name is r)
       ((@))
       ((p.p.name is k)
        ((p.name is r) ((e:)) ((aI)))
        ((p.p.p.name is l)
         ((aI))
         ((p.p.p.name is a)
          ((p.p.name is b) ((aI)) ((p.p.name is n) ((aI)) ((e:))))
          ((aI))))))
      ((n.n.name is s)
       ((p.p.name is t)
        ((p.name is h) ((e:)) ((aI)))
        ((n.n.n.name is c)
         ((p.p.name is s) ((e:)) ((p.p.name is y) ((e:)) ((aI))))
         ((aI))))
       ((aI))))))
   ((n.n.name is #)
    ((p.name is i)
     ((n.name is n)
      ((@))
      ((p.p.name is e)
       ((@))
       ((n.name is r)
        ((p.p.name is t)
         ((_epsilon_))
         ((p.p.name is p)
          ((_epsilon_))
          ((p.p.p.name is a) ((@)) ((_epsilon_)))))
        ((_epsilon_)))))
     ((p.name is a)
      ((_epsilon_))
      ((p.name is o)
       ((_epsilon_))
       ((p.name is w)
        ((e:))
        ((p.name is e)
         ((p.p.name is i)
          ((@))
          ((p.p.name is a) ((@)) ((n.name is n) ((@)) ((e:)))))
         ((n.name is e)
          ((_epsilon_))
          ((n.name is u)
           ((OY))
           ((p.name is u)
            ((p.p.name is a)
             ((@))
             ((p.p.name is e)
              ((@))
              ((p.p.name is r)
               ((_epsilon_))
               ((n.name is n)
                ((@))
                ((n.name is t) ((@)) ((_epsilon_)))))))
            ((n.name is x)
             ((E))
             ((p.p.p.name is y)
              ((n.name is n) ((@)) ((e:)))
              ((p.name is t)
               ((@))
               ((p.p.name is e)
                ((@))
                ((n.name is n) ((@)) ((p.p.p.name is #) ((e:)) ((@))))))))))))))))
    ((p.name is i)
     ((p.p.name is e)
      ((n.name is r)
       ((p.p.p.name is r) ((n.n.name is t) ((_epsilon_)) ((@))) ((@)))
       ((n.name is #)
        ((@))
        ((n.name is s) ((@)) ((n.name is n) ((@)) ((E))))))
      ((n.name is n)
       ((p.p.name is d)
        ((p.p.p.name is u) ((@)) ((_epsilon_)))
        ((n.n.name is t)
         ((n.n.n.name is r) ((@)) ((E)))
         ((n.n.name is e)
          ((_epsilon_))
          ((n.n.name is i)
           ((e:))
           ((p.p.name is z)
            ((@))
            ((n.n.n.name is i)
             ((@))
             ((n.n.name is a)
              ((@))
              ((n.n.n.name is e)
               ((p.p.p.name is i)
                ((@))
                ((p.p.name is r) ((@)) ((_epsilon_))))
               ((@))))))))))
       ((n.n.name is l)
        ((n.name is l)
         ((n.n.n.name is o) ((_epsilon_)) ((E)))
         ((_epsilon_)))
        ((p.p.p.name is z)
         ((n.n.n.name is a)
          ((aI))
          ((n.name is l) ((aI)) ((_epsilon_))))
         ((n.n.name is n)
          ((p.p.name is v) ((E)) ((n.name is r) ((@)) ((_epsilon_))))
          ((n.name is u)
           ((2:))
           ((n.name is #)
            ((p.p.p.name is i)
             ((p.p.name is l) ((_epsilon_)) ((@)))
             ((p.p.name is g)
              ((_epsilon_))
              ((p.p.name is h)
               ((_epsilon_))
               ((p.p.name is m)
                ((_epsilon_))
                ((p.p.name is n)
                 ((_epsilon_))
                 ((p.p.name is s)
                  ((_epsilon_))
                  ((p.p.name is p)
                   ((_epsilon_))
                   ((p.p.p.name is t)
                    ((_epsilon_))
                    ((p.p.p.name is e)
                     ((_epsilon_))
                     ((p.p.name is r) ((@)) ((_epsilon_))))))))))))
            ((n.name is h)
             ((_epsilon_))
             ((n.n.name is a)
              ((n.name is t) ((e:)) ((_epsilon_)))
              ((n.n.n.name is #)
               ((n.n.name is s)
                ((n.name is r)
                 ((p.p.name is p)
                  ((_epsilon_))
                  ((p.p.p.name is a) ((@)) ((_epsilon_))))
                 ((_epsilon_)))
                ((_epsilon_)))
               ((n.n.name is i)
                ((n.n.n.name is n) ((@)) ((_epsilon_)))
                ((_epsilon_)))))))))))))
     ((p.name is u)
      ((p.p.name is a)
       ((@))
       ((p.p.name is e)
        ((n.n.name is o)
         ((e:))
         ((p.p.p.name is g) ((_epsilon_)) ((@))))
        ((p.p.name is q)
         ((n.name is r)
          ((e:))
          ((n.name is m)
           ((e:))
           ((n.n.n.name is e)
            ((E))
            ((p.p.p.name is e)
             ((E))
             ((p.p.p.name is #)
              ((E))
              ((n.name is t) ((E)) ((_epsilon_))))))))
         ((n.name is l)
          ((n.n.name is l)
           ((p.p.name is f)
            ((_epsilon_))
            ((p.p.name is h)
             ((_epsilon_))
             ((p.p.p.name is b)
              ((_epsilon_))
              ((p.p.name is m)
               ((_epsilon_))
               ((p.p.name is n)
                ((n.n.n.name is e) ((E)) ((_epsilon_)))
                ((E)))))))
           ((_epsilon_)))
          ((p.p.name is t)
           ((n.n.name is i)
            ((n.n.n.name is s) ((@)) ((_epsilon_)))
            ((p.p.p.name is s)
             ((_epsilon_))
             ((n.n.name is d)
              ((@))
              ((n.n.n.name is #)
               ((n.name is s) ((@)) ((_epsilon_)))
               ((n.name is #) ((@)) ((_epsilon_)))))))
           ((p.p.name is z)
            ((n.name is r)
             ((n.n.name is n)
              ((_epsilon_))
              ((p.p.p.name is #)
               ((n.n.n.name is e) ((E)) ((_epsilon_)))
               ((E))))
             ((_epsilon_)))
            ((n.name is h)
             ((n.n.name is e)
              ((p.p.p.name is f) ((@)) ((_epsilon_)))
              ((_epsilon_)))
             ((n.n.name is i)
              ((n.name is r) ((e:)) ((_epsilon_)))
              ((n.n.name is t)
               ((n.name is n)
                ((_epsilon_))
                ((n.n.n.name is i)
                 ((n.name is s) ((_epsilon_)) ((E)))
                 ((_epsilon_))))
               ((_epsilon_)))))))))))
      ((p.name is a)
       ((n.name is n)
        ((n.n.name is e)
         ((_epsilon_))
         ((n.n.name is t)
          ((p.p.name is m) ((E)) ((_epsilon_)))
          ((n.n.name is i)
           ((_epsilon_))
           ((n.n.name is s)
            ((n.n.n.name is e) ((E)) ((_epsilon_)))
            ((E))))))
        ((n.name is h)
         ((n.n.name is e)
          ((p.p.p.name is n) ((@)) ((_epsilon_)))
          ((_epsilon_)))
         ((n.name is u)
          ((_epsilon_))
          ((n.n.name is e)
           ((p.p.p.name is p)
            ((n.name is g)
             ((_epsilon_))
             ((p.p.name is h) ((_epsilon_)) ((E))))
            ((p.p.name is h)
             ((n.name is r) ((E)) ((_epsilon_)))
             ((_epsilon_))))
           ((n.n.name is s)
            ((p.p.name is m)
             ((n.n.n.name is c) ((E)) ((_epsilon_)))
             ((n.name is s)
              ((p.p.name is l)
               ((E))
               ((p.p.p.name is #)
                ((E))
                ((p.p.p.name is n)
                 ((E))
                 ((p.p.name is w)
                  ((E))
                  ((n.n.n.name is l)
                   ((E))
                   ((p.p.name is r)
                    ((_epsilon_))
                    ((p.p.p.name is f)
                     ((E))
                     ((p.p.name is n) ((E)) ((_epsilon_))))))))))
              ((n.n.n.name is c)
               ((p.p.p.name is g) ((_epsilon_)) ((E)))
               ((p.p.name is h) ((E)) ((_epsilon_))))))
            ((n.n.n.name is g)
             ((n.n.name is i) ((_epsilon_)) ((E)))
             ((n.name is g)
              ((n.n.name is n)
               ((p.p.p.name is p) ((E)) ((_epsilon_)))
               ((n.n.n.name is i)
                ((_epsilon_))
                ((n.n.name is t)
                 ((_epsilon_))
                 ((p.p.name is r) ((_epsilon_)) ((E))))))
              ((n.n.n.name is #)
               ((p.p.name is h)
                ((n.name is l)
                 ((E))
                 ((n.name is f) ((E)) ((_epsilon_))))
                ((n.n.name is t)
                 ((_epsilon_))
                 ((n.name is e) ((_epsilon_)) ((E)))))
               ((n.n.name is m)
                ((E))
                ((n.name is l)
                 ((p.p.p.name is q)
                  ((_epsilon_))
                  ((n.n.name is i) ((_epsilon_)) ((E))))
                 ((n.n.name is l)
                  ((_epsilon_))
                  ((n.n.name is o)
                   ((n.name is r)
                    ((e:))
                    ((p.p.name is d) ((_epsilon_)) ((E))))
                   ((n.n.n.name is n)
                    ((_epsilon_))
                    ((p.p.p.name is i)
                     ((p.p.name is n) ((E)) ((_epsilon_)))
                     ((n.n.name is h)
                      ((n.n.n.name is t)
                       ((E))
                       ((p.p.p.name is p)
                        ((_epsilon_))
                        ((p.p.name is n)
                         ((_epsilon_))
                         ((p.p.p.name is s)
                          ((_epsilon_))
                          ((p.p.name is f)
                           ((_epsilon_))
                           ((n.name is c) ((E)) ((_epsilon_))))))))
                      ((n.n.name is c)
                       ((n.name is s) ((E)) ((_epsilon_)))
                       ((n.name is r)
                        ((p.p.name is b)
                         ((_epsilon_))
                         ((n.n.name is z)
                          ((p.p.name is w) ((E)) ((_epsilon_)))
                          ((n.n.n.name is a)
                           ((_epsilon_))
                           ((p.p.name is z)
                            ((_epsilon_))
                            ((p.p.name is g)
                             ((_epsilon_))
                             ((p.p.p.name is p)
                              ((_epsilon_))
                              ((p.p.name is l)
                               ((E))
                               ((p.p.p.name is s)
                                ((n.n.name is k) ((E)) ((_epsilon_)))
                                ((E))))))))))
                        ((n.n.name is i)
                         ((n.name is z)
                          ((E))
                          ((n.n.n.name is s)
                           ((_epsilon_))
                           ((n.n.n.name is e)
                            ((p.p.name is r)
                             ((p.p.p.name is p) ((_epsilon_)) ((E)))
                             ((E)))
                            ((E)))))
                         ((n.n.name is r)
                          ((p.p.name is r) ((E)) ((_epsilon_)))
                          ((n.name is e)
                           ((_epsilon_))
                           ((p.p.name is p)
                            ((p.p.p.name is a) ((_epsilon_)) ((E)))
                            ((n.name is m)
                             ((n.n.name is p)
                              ((E))
                              ((p.p.name is s)
                               ((E))
                               ((p.p.name is r) ((_epsilon_)) ((E)))))
                             ((E))))))))))))))))))))))))
       ((p.name is o)
        ((p.p.name is p)
         ((n.n.name is i) ((e:)) ((_epsilon_)))
         ((n.n.n.name is o)
          ((_epsilon_))
          ((p.p.p.name is o)
           ((_epsilon_))
           ((n.n.name is i)
            ((_epsilon_))
            ((p.p.name is m)
             ((n.name is l)
              ((p.p.p.name is h) ((_epsilon_)) ((e:)))
              ((_epsilon_)))
             ((_epsilon_)))))))
        ((n.name is u)
         ((n.n.name is r)
          ((p.p.name is #)
           ((p.name is b) ((@)) ((OY)))
           ((n.n.n.name is o) ((OY)) ((2:))))
          ((n.n.name is m)
           ((n.n.n.name is s) ((e:)) ((OY)))
           ((n.n.n.name is b)
            ((p.name is g) ((@)) ((OY)))
            ((n.n.name is n)
             ((p.p.name is #) ((p.name is n) ((OY)) ((@))) ((OY)))
             ((OY))))))
         ((n.name is #)
          ((p.name is e) ((p.p.name is i) ((@)) ((e:))) ((@)))
          ((p.name is v)
           ((p.p.name is #)
            ((n.name is r)
             ((E))
             ((n.n.name is e) ((e:)) ((n.name is l) ((e:)) ((E)))))
            ((p.p.name is i)
             ((n.n.name is e) ((@)) ((n.name is r) ((E)) ((@))))
             ((n.n.name is i)
              ((p.p.p.name is u) ((@)) ((e:)))
              ((n.n.n.name is #)
               ((p.p.p.name is u)
                ((@))
                ((p.p.name is l)
                 ((E))
                 ((p.p.p.name is l)
                  ((@))
                  ((p.p.name is e) ((@)) ((E))))))
               ((n.name is r)
                ((p.p.name is u)
                 ((n.n.name is a) ((@)) ((n.n.name is t) ((e:)) ((E))))
                 ((p.p.name is l)
                  ((p.p.p.name is u) ((@)) ((E)))
                  ((p.p.name is a)
                   ((n.n.name is s)
                    ((E))
                    ((p.p.p.name is k) ((E)) ((@))))
                   ((E)))))
                ((n.n.name is t)
                 ((E))
                 ((n.name is n)
                  ((p.p.name is r)
                   ((@))
                   ((p.p.p.name is l) ((@)) ((e:))))
                  ((n.n.name is h) ((@)) ((E))))))))))
           ((p.name is #)
            ((n.n.name is e)
             ((n.name is x) ((E)) ((n.name is r) ((E)) ((e:))))
             ((n.name is h)
              ((e:))
              ((n.n.name is o)
               ((n.name is x)
                ((E))
                ((n.name is r) ((n.n.n.name is t) ((e:)) ((E))) ((e:))))
               ((n.n.name is i)
                ((n.name is x) ((E)) ((n.name is r) ((E)) ((e:))))
                ((n.n.name is a)
                 ((n.name is x) ((E)) ((n.name is r) ((E)) ((e:))))
                 ((n.name is n)
                  ((E))
                  ((n.n.name is u)
                   ((e:))
                   ((n.name is k)
                    ((n.n.name is s) ((E)) ((e:)))
                    ((n.n.n.name is t)
                     ((E))
                     ((n.n.name is d)
                      ((n.n.n.name is r)
                       ((E))
                       ((n.n.n.name is i)
                        ((E))
                        ((n.n.n.name is e)
                         ((E))
                         ((n.n.n.name is a) ((E)) ((e:))))))
                      ((n.name is t)
                       ((n.n.n.name is i) ((e:)) ((E)))
                       ((n.n.n.name is n)
                        ((e:))
                        ((n.n.name is z)
                         ((E))
                         ((n.name is r)
                          ((E))
                          ((n.n.name is b)
                           ((a~:))
                           ((n.name is g) ((e:)) ((E))))))))))))))))))
            ((n.n.n.name is #)
             ((n.name is h)
              ((e:))
              ((n.name is g)
               ((e:))
               ((n.name is b)
                ((e:))
                ((p.name is w)
                 ((n.n.name is k)
                  ((E))
                  ((n.name is r) ((p.p.name is o) ((@)) ((e:))) ((E))))
                 ((n.name is e)
                  ((n.n.name is n) ((e:)) ((_epsilon_)))
                  ((n.n.name is z)
                   ((E))
                   ((n.n.name is e)
                    ((n.name is r)
                     ((p.name is e) ((e:)) ((@)))
                     ((p.name is r)
                      ((n.name is n) ((@)) ((e:)))
                      ((n.name is s)
                       ((e:))
                       ((n.name is x)
                        ((E))
                        ((p.name is e)
                         ((e:))
                         ((n.name is m)
                          ((e:))
                          ((p.p.name is o)
                           ((@))
                           ((p.p.name is a)
                            ((p.name is k) ((e:)) ((@)))
                            ((@))))))))))
                    ((n.name is t)
                     ((n.n.name is t) ((E)) ((e:)))
                     ((n.n.name is l)
                      ((E))
                      ((n.n.name is k)
                       ((E))
                       ((n.name is s)
                        ((@))
                        ((n.name is m)
                         ((n.n.name is d) ((E)) ((e:)))
                         ((n.n.name is t)
                          ((n.name is n)
                           ((E))
                           ((n.name is k)
                            ((E))
                            ((p.name is e)
                             ((e:))
                             ((p.p.p.name is s)
                              ((@))
                              ((n.name is r)
                               ((@))
                               ((n.name is l) ((@)) ((E))))))))
                          ((p.p.name is #)
                           ((E))
                           ((n.name is n)
                            ((@))
                            ((n.n.name is d)
                             ((n.name is l) ((E)) ((e:)))
                             ((n.n.name is b)
                              ((E))
                              ((n.n.name is r)
                               ((E))
                               ((p.name is e)
                                ((@))
                                ((p.p.name is o)
                                 ((@))
                                 ((p.name is h)
                                  ((n.name is r)
                                   ((@))
                                   ((n.n.name is n) ((@)) ((E))))
                                  ((n.n.name is s)
                                   ((@))
                                   ((n.n.name is n)
                                    ((p.p.p.name is e)
                                     ((@))
                                     ((p.p.name is n)
                                      ((@))
                                      ((p.name is k)
                                       ((p.p.name is i)
                                        ((@))
                                        ((p.p.name is c)
                                         ((@))
                                         ((n.name is l) ((@)) ((E)))))
                                       ((@)))))
                                    ((E)))))))))))))))))))))))))
             ((n.n.name is e)
              ((n.name is r)
               ((p.p.name is #)
                ((p.name is h) ((E)) ((p.name is z) ((e:)) ((@))))
                ((p.name is e)
                 ((e:))
                 ((p.name is w)
                  ((e:))
                  ((n.n.n.name is o)
                   ((e:))
                   ((p.name is f)
                    ((p.p.name is n)
                     ((e:))
                     ((p.p.name is e) ((e:)) ((@))))
                    ((@)))))))
               ((n.n.n.name is n)
                ((n.name is t)
                 ((p.name is t)
                  ((@))
                  ((p.name is d)
                   ((p.p.p.name is s) ((e:)) ((@)))
                   ((p.name is n)
                    ((@))
                    ((p.p.p.name is a) ((@)) ((e:))))))
                 ((n.name is n)
                  ((p.p.p.name is s) ((e:)) ((@)))
                  ((p.name is b)
                   ((n.name is s) ((e:)) ((@)))
                   ((n.name is l)
                    ((p.name is g)
                     ((@))
                     ((p.name is e)
                      ((e:))
                      ((p.name is d) ((@)) ((e:)))))
                    ((n.name is m)
                     ((p.p.p.name is e)
                      ((@))
                      ((p.name is g)
                       ((@))
                       ((p.name is l)
                        ((e:))
                        ((p.name is h)
                         ((e:))
                         ((p.p.name is #)
                          ((e:))
                          ((p.name is r) ((e:)) ((@))))))))
                     ((n.name is w)
                      ((@))
                      ((n.name is a)
                       ((@))
                       ((p.name is h)
                        ((p.p.name is #) ((E)) ((e:)))
                        ((e:))))))))))
                ((p.name is r)
                 ((n.name is n)
                  ((p.p.name is o)
                   ((@))
                   ((p.p.p.name is a) ((@)) ((e:))))
                  ((n.n.n.name is i)
                   ((@))
                   ((p.p.name is u)
                    ((@))
                    ((p.p.p.name is i)
                     ((p.p.name is r) ((@)) ((e:)))
                     ((e:))))))
                 ((p.name is l)
                  ((n.name is n) ((@)) ((n.name is x) ((E)) ((e:))))
                  ((p.name is w)
                   ((e:))
                   ((p.name is b)
                    ((n.name is t)
                     ((n.n.n.name is t)
                      ((e:))
                      ((n.n.n.name is i)
                       ((@))
                       ((p.p.name is #) ((@)) ((e:)))))
                     ((@)))
                    ((p.p.name is #)
                     ((p.name is g)
                      ((n.name is n)
                       ((n.n.n.name is h) ((@)) ((e:)))
                       ((n.name is b)
                        ((n.n.n.name is f) ((e:)) ((@)))
                        ((@))))
                      ((e:)))
                     ((n.name is h)
                      ((n.n.n.name is i)
                       ((@))
                       ((n.n.n.name is u)
                        ((@))
                        ((n.n.n.name is m)
                         ((@))
                         ((p.p.name is s)
                          ((e:))
                          ((p.p.p.name is e)
                           ((e:))
                           ((p.name is s)
                            ((e:))
                            ((n.n.n.name is s)
                             ((e:))
                             ((n.n.n.name is t) ((e:)) ((@))))))))))
                      ((n.name is b)
                       ((n.n.n.name is l)
                        ((e:))
                        ((p.p.name is h)
                         ((@))
                         ((n.n.n.name is r)
                          ((e:))
                          ((n.n.n.name is t)
                           ((e:))
                           ((n.n.n.name is s)
                            ((p.name is z) ((@)) ((e:)))
                            ((@)))))))
                       ((n.name is x)
                        ((E))
                        ((p.name is m)
                         ((n.name is t) ((e:)) ((@)))
                         ((p.p.p.name is #)
                          ((e:))
                          ((n.name is g)
                           ((p.name is g)
                            ((@))
                            ((p.p.p.name is u)
                             ((e:))
                             ((p.name is d)
                              ((@))
                              ((p.name is h)
                               ((@))
                               ((p.p.p.name is e) ((@)) ((e:)))))))
                           ((n.name is d)
                            ((p.name is g) ((@)) ((e:)))
                            ((p.name is p)
                             ((p.p.p.name is e) ((@)) ((e:)))
                             ((p.p.name is o)
                              ((p.p.p.name is z)
                               ((@))
                               ((p.name is g)
                                ((p.p.p.name is t)
                                 ((e:))
                                 ((p.p.p.name is m) ((e:)) ((@))))
                                ((@))))
                              ((p.name is e)
                               ((e:))
                               ((p.p.name is f)
                                ((@))
                                ((n.n.n.name is t)
                                 ((@))
                                 ((p.p.p.name is u)
                                  ((@))
                                  ((n.name is k)
                                   ((e:))
                                   ((p.name is g)
                                    ((@))
                                    ((n.name is n)
                                     ((@))
                                     ((n.name is t)
                                      ((n.n.n.name is s)
                                       ((@))
                                       ((p.p.name is n)
                                        ((p.p.p.name is i)
                                         ((e:))
                                         ((@)))
                                        ((p.p.p.name is n)
                                         ((@))
                                         ((p.name is t)
                                          ((@))
                                          ((p.p.p.name is i)
                                           ((@))
                                           ((p.p.p.name is r)
                                            ((@))
                                            ((e:))))))))
                                      ((n.n.n.name is s)
                                       ((e:))
                                       ((n.n.n.name is m) ((e:)) ((@))))))))))))))))))))))))))))
              ((p.name is b)
               ((n.name is e)
                ((p.p.name is #)
                 ((@))
                 ((n.n.name is r) ((_epsilon_)) ((@))))
                ((p.p.name is i)
                 ((p.p.p.name is l) ((e:)) ((@)))
                 ((p.p.p.name is u)
                  ((n.name is r)
                   ((@))
                   ((n.n.name is s)
                    ((E))
                    ((n.name is c)
                     ((E))
                     ((n.name is t)
                      ((n.n.name is r) ((@)) ((E)))
                      ((@))))))
                  ((n.n.name is g)
                   ((p.p.name is #)
                    ((E))
                    ((p.p.p.name is e) ((E)) ((@))))
                   ((n.n.n.name is e)
                    ((n.n.name is s)
                     ((n.name is n) ((@)) ((E)))
                     ((n.name is t)
                      ((n.n.name is t) ((E)) ((@)))
                      ((n.n.name is k)
                       ((E))
                       ((n.name is s)
                        ((n.n.name is t)
                         ((p.p.name is t) ((E)) ((@)))
                         ((@)))
                        ((n.n.name is l)
                         ((n.name is l) ((E)) ((@)))
                         ((@)))))))
                    ((n.n.n.name is i)
                     ((n.n.name is r)
                      ((@))
                      ((p.p.name is e)
                       ((p.p.p.name is r)
                        ((E))
                        ((p.p.p.name is l) ((E)) ((@))))
                       ((n.n.name is z)
                        ((E))
                        ((p.p.p.name is t) ((E)) ((@))))))
                     ((p.p.p.name is t)
                      ((n.name is r)
                       ((E))
                       ((n.n.name is l) ((E)) ((@))))
                      ((n.n.name is t)
                       ((n.name is t)
                        ((E))
                        ((n.n.n.name is s) ((E)) ((@))))
                       ((n.n.name is i)
                        ((n.name is t)
                         ((e:))
                         ((p.p.p.name is #)
                          ((e:))
                          ((p.p.name is r)
                           ((n.name is w) ((e:)) ((@)))
                           ((@)))))
                        ((p.p.name is t)
                         ((p.p.p.name is n) ((e:)) ((@)))
                         ((p.p.name is r)
                          ((@))
                          ((n.name is t)
                           ((@))
                           ((n.n.n.name is t)
                            ((p.p.name is #)
                             ((n.n.name is u)
                              ((@))
                              ((n.name is a)
                               ((@))
                               ((n.n.name is a) ((@)) ((E)))))
                             ((@)))
                            ((@)))))))))))))))
               ((p.name is g)
                ((n.n.name is t)
                 ((n.name is n)
                  ((p.p.name is e)
                   ((@))
                   ((n.n.n.name is u)
                    ((@))
                    ((n.n.n.name is e)
                     ((E))
                     ((n.n.n.name is i)
                      ((E))
                      ((n.n.n.name is s) ((E)) ((@)))))))
                  ((n.n.n.name is i)
                   ((p.p.name is g) ((E)) ((@)))
                   ((p.p.name is t)
                    ((p.p.p.name is n) ((E)) ((@)))
                    ((@)))))
                 ((n.n.name is d)
                  ((n.name is l)
                   ((n.n.n.name is e)
                    ((E))
                    ((n.n.n.name is s)
                     ((E))
                     ((p.p.name is #) ((E)) ((@)))))
                   ((p.p.p.name is l)
                    ((n.n.n.name is a) ((E)) ((@)))
                    ((@))))
                  ((n.n.name is m)
                   ((n.name is r) ((E)) ((@)))
                   ((n.n.name is b)
                    ((n.n.n.name is e)
                     ((n.name is l) ((E)) ((@)))
                     ((n.n.n.name is a)
                      ((n.name is l) ((@)) ((e:)))
                      ((@))))
                    ((n.name is s)
                     ((n.n.name is s)
                      ((p.p.p.name is i) ((@)) ((E)))
                      ((@)))
                     ((n.n.name is n)
                      ((n.name is b)
                       ((e:))
                       ((n.name is g)
                        ((e:))
                        ((n.name is a) ((_epsilon_)) ((@)))))
                      ((n.n.name is i)
                       ((n.name is n)
                        ((n.n.n.name is o)
                         ((e:))
                         ((n.n.n.name is a)
                          ((e:))
                          ((n.n.n.name is t)
                           ((e:))
                           ((n.n.n.name is e)
                            ((p.p.name is #)
                             ((@))
                             ((p.p.p.name is u) ((@)) ((e:))))
                            ((@))))))
                        ((n.name is t)
                         ((p.p.name is #) ((@)) ((e:)))
                         ((p.p.name is r)
                          ((n.n.n.name is s)
                           ((n.name is r) ((@)) ((_epsilon_)))
                           ((@)))
                          ((p.p.name is i) ((e:)) ((@))))))
                       ((n.name is h)
                        ((n.n.n.name is t)
                         ((e:))
                         ((n.n.name is r) ((e:)) ((@))))
                        ((n.name is c)
                         ((E))
                         ((p.p.p.name is v)
                          ((p.p.name is e) ((e:)) ((@)))
                          ((n.name is b)
                           ((n.n.n.name is i)
                            ((p.p.p.name is s)
                             ((e:))
                             ((p.p.name is r) ((e:)) ((@))))
                            ((n.n.n.name is n)
                             ((p.p.name is s)
                              ((@))
                              ((p.p.p.name is u)
                               ((@))
                               ((p.p.name is t) ((@)) ((e:)))))
                             ((@))))
                           ((n.name is o)
                            ((n.n.name is r) ((@)) ((e:)))
                            ((p.p.name is o)
                             ((@))
                             ((n.n.name is z)
                              ((@))
                              ((n.n.name is o)
                               ((p.p.name is e) ((e:)) ((@)))
                               ((@)))))))))))))))))
                ((p.p.name is #)
                 ((n.name is e)
                  ((p.name is s)
                   ((_epsilon_))
                   ((n.n.name is r)
                    ((_epsilon_))
                    ((n.n.n.name is e)
                     ((_epsilon_))
                     ((p.name is t) ((_epsilon_)) ((e:))))))
                  ((n.name is h)
                   ((e:))
                   ((p.name is r)
                    ((n.name is c)
                     ((E))
                     ((n.n.name is t)
                      ((n.name is s)
                       ((n.n.n.name is a)
                        ((e:))
                        ((n.n.n.name is r) ((e:)) ((E))))
                       ((E)))
                      ((n.name is n)
                       ((n.n.name is n)
                        ((E))
                        ((n.n.name is o)
                         ((e:))
                         ((n.n.name is i)
                          ((e:))
                          ((n.n.name is u) ((e:)) ((E))))))
                       ((e:)))))
                    ((n.n.name is i)
                     ((n.name is x)
                      ((E))
                      ((n.name is s)
                       ((n.n.n.name is n) ((E)) ((e:)))
                       ((e:))))
                     ((n.n.name is o)
                      ((n.name is s) ((E)) ((e:)))
                      ((n.n.name is a)
                       ((p.name is h)
                        ((E))
                        ((n.name is s) ((E)) ((e:))))
                       ((n.name is b)
                        ((e:))
                        ((n.name is l)
                         ((E))
                         ((n.name is n)
                          ((p.name is p)
                           ((n.n.n.name is i) ((a~:)) ((E)))
                           ((n.n.name is u) ((e:)) ((E))))
                          ((p.name is d)
                           ((n.n.name is l)
                            ((e:))
                            ((n.n.name is u)
                             ((e:))
                             ((n.n.n.name is r)
                              ((e:))
                              ((n.name is g)
                               ((e:))
                               ((n.name is s)
                                ((E))
                                ((n.n.name is k)
                                 ((E))
                                 ((n.name is f)
                                  ((E))
                                  ((n.n.n.name is i) ((E)) ((e:))))))))))
                           ((p.name is z)
                            ((n.name is p) ((e:)) ((E)))
                            ((n.n.name is r)
                             ((n.name is r)
                              ((E))
                              ((p.name is w) ((E)) ((e:))))
                             ((p.name is f)
                              ((E))
                              ((n.name is o)
                               ((e:))
                               ((p.name is t)
                                ((E))
                                ((n.n.name is v)
                                 ((E))
                                 ((p.name is p)
                                  ((n.n.name is u) ((e:)) ((E)))
                                  ((n.n.name is l)
                                   ((p.name is w) ((E)) ((e:)))
                                   ((n.name is r)
                                    ((n.n.name is t)
                                     ((e:))
                                     ((n.n.name is g)
                                      ((e:))
                                      ((n.n.name is d)
                                       ((e:))
                                       ((n.n.name is s)
                                        ((e:))
                                        ((n.n.n.name is u)
                                         ((e:))
                                         ((n.n.n.name is o)
                                          ((p.name is h) ((e:)) ((E)))
                                          ((n.n.n.name is a)
                                           ((e:))
                                           ((n.n.n.name is r)
                                            ((e:))
                                            ((n.n.n.name is i)
                                             ((p.name is h)
                                              ((n.n.name is z)
                                               ((E))
                                               ((e:)))
                                              ((E)))
                                             ((E)))))))))))
                                    ((n.n.name is u)
                                     ((n.name is x) ((E)) ((e:)))
                                     ((n.n.name is t)
                                      ((E))
                                      ((p.name is m)
                                       ((n.n.name is h)
                                        ((e:))
                                        ((n.n.name is c) ((e:)) ((E))))
                                       ((n.name is c)
                                        ((E))
                                        ((n.n.name is z)
                                         ((E))
                                         ((p.name is l)
                                          ((e:))
                                          ((n.n.name is s)
                                           ((E))
                                           ((p.name is n)
                                            ((e:))
                                            ((n.n.name is k)
                                             ((E))
                                             ((n.n.name is w)
                                              ((n.n.n.name is e)
                                               ((e:))
                                               ((E)))
                                              ((E)))))))))))))))))))))))))))))))
                 ((n.name is c)
                  ((E))
                  ((n.name is h)
                   ((n.n.name is a)
                    ((p.name is e) ((e:)) ((@)))
                    ((e:)))
                   ((n.n.name is i)
                    ((n.name is r)
                     ((n.n.n.name is g)
                      ((@))
                      ((n.n.n.name is s)
                       ((p.name is t)
                        ((p.p.p.name is e)
                         ((@))
                         ((p.p.name is e) ((@)) ((e:))))
                        ((p.p.p.name is z)
                         ((e:))
                         ((p.name is h)
                          ((p.p.name is c)
                           ((@))
                           ((p.p.p.name is e) ((e:)) ((@))))
                          ((p.p.name is u)
                           ((p.p.p.name is e) ((@)) ((e:)))
                           ((@))))))
                       ((n.n.n.name is n)
                        ((p.p.p.name is v)
                         ((e:))
                         ((p.name is h) ((e:)) ((@))))
                        ((p.p.name is t)
                         ((@))
                         ((p.p.p.name is g)
                          ((@))
                          ((p.name is s)
                           ((p.p.name is s) ((@)) ((e:)))
                           ((p.p.name is l)
                            ((@))
                            ((p.p.name is f)
                             ((@))
                             ((n.n.n.name is c)
                              ((@))
                              ((p.name is p)
                               ((n.n.n.name is e) ((@)) ((e:)))
                               ((e:))))))))))))
                     ((n.name is l)
                      ((p.name is s)
                       ((p.p.p.name is o)
                        ((@))
                        ((p.p.name is u)
                         ((@))
                         ((p.p.name is s)
                          ((p.p.p.name is n) ((e:)) ((@)))
                          ((e:)))))
                       ((n.n.n.name is g)
                        ((p.name is r) ((e:)) ((@)))
                        ((p.name is h)
                         ((@))
                         ((n.n.n.name is n) ((@)) ((e:))))))
                      ((n.name is x)
                       ((E))
                       ((p.p.name is w)
                        ((E))
                        ((n.name is e)
                         ((@))
                         ((p.name is s)
                          ((p.p.p.name is e) ((@)) ((e:)))
                          ((n.n.n.name is n)
                           ((n.name is n)
                            ((@))
                            ((n.name is g) ((@)) ((e:))))
                           ((n.n.n.name is e)
                            ((p.p.name is t)
                             ((e:))
                             ((p.name is m)
                              ((@))
                              ((p.name is n) ((@)) ((e:)))))
                            ((e:))))))))))
                    ((p.name is w)
                     ((n.n.name is t)
                      ((n.name is r)
                       ((e:))
                       ((n.name is b)
                        ((e:))
                        ((n.name is g) ((e:)) ((E)))))
                      ((p.p.name is h)
                       ((n.name is r)
                        ((n.n.name is k)
                         ((n.n.n.name is r) ((e:)) ((E)))
                         ((e:)))
                        ((n.name is f) ((e:)) ((E))))
                       ((n.name is g)
                        ((p.p.p.name is i)
                         ((E))
                         ((p.p.p.name is o) ((E)) ((e:))))
                        ((n.name is s)
                         ((e:))
                         ((p.p.p.name is o)
                          ((p.p.name is e) ((@)) ((E)))
                          ((n.n.name is s)
                           ((n.name is l) ((E)) ((@)))
                           ((n.n.name is d)
                            ((n.name is n) ((E)) ((e:)))
                            ((n.name is n)
                             ((@))
                             ((n.n.name is k)
                              ((E))
                              ((n.n.name is f)
                               ((E))
                               ((n.n.name is b)
                                ((E))
                                ((p.p.name is z)
                                 ((E))
                                 ((n.n.name is l)
                                  ((E))
                                  ((n.name is t) ((E)) ((@))))))))))))))))
                     ((p.p.p.name is #)
                      ((p.name is e)
                       ((n.name is n)
                        ((E))
                        ((n.n.n.name is e)
                         ((p.p.name is s)
                          ((e:))
                          ((p.p.name is t)
                           ((_epsilon_))
                           ((p.p.name is b) ((E)) ((e:)))))
                         ((e:))))
                       ((n.name is a)
                        ((e:))
                        ((n.n.name is o)
                         ((e:))
                         ((n.name is o)
                          ((e:))
                          ((n.n.name is u)
                           ((p.p.name is a) ((E)) ((e:)))
                           ((n.n.name is a)
                            ((n.name is x)
                             ((E))
                             ((p.p.name is o)
                              ((@))
                              ((n.name is m)
                               ((n.n.n.name is t) ((e:)) ((@)))
                               ((e:)))))
                            ((n.name is e)
                             ((p.p.name is i) ((e:)) ((_epsilon_)))
                             ((n.name is b)
                              ((e:))
                              ((p.p.name is o)
                               ((@))
                               ((p.name is d)
                                ((n.name is l) ((@)) ((E)))
                                ((p.name is f)
                                 ((n.n.name is d)
                                  ((e:))
                                  ((p.p.name is p) ((E)) ((@))))
                                 ((p.p.name is a)
                                  ((p.name is t)
                                   ((@))
                                   ((p.name is n)
                                    ((E))
                                    ((n.n.name is t) ((E)) ((e:)))))
                                  ((p.p.name is e)
                                   ((n.name is l)
                                    ((@))
                                    ((p.name is h) ((@)) ((E))))
                                   ((n.name is t)
                                    ((n.n.name is t)
                                     ((E))
                                     ((n.n.name is s) ((E)) ((e:))))
                                    ((n.n.n.name is e)
                                     ((n.n.name is l)
                                      ((n.name is l) ((E)) ((e:)))
                                      ((E)))
                                     ((E)))))))))))))))))
                      ((n.name is g)
                       ((p.name is d)
                        ((@))
                        ((n.n.name is m)
                         ((E))
                         ((p.name is p) ((E)) ((e:)))))
                       ((n.name is e)
                        ((p.name is r) ((e:)) ((_epsilon_)))
                        ((p.name is r)
                         ((n.name is n)
                          ((p.p.name is h)
                           ((@))
                           ((n.n.name is n)
                            ((E))
                            ((p.p.p.name is s)
                             ((E))
                             ((n.n.name is t)
                              ((E))
                              ((n.n.name is z)
                               ((E))
                               ((p.p.p.name is v)
                                ((E))
                                ((n.n.name is k)
                                 ((n.n.n.name is t) ((E)) ((@)))
                                 ((@)))))))))
                          ((n.name is s)
                           ((p.p.name is h)
                            ((@))
                            ((p.p.p.name is e)
                             ((p.p.name is e) ((@)) ((E)))
                             ((E))))
                           ((n.name is d)
                            ((e:))
                            ((n.n.name is a)
                             ((p.p.p.name is i) ((@)) ((e:)))
                             ((n.name is a)
                              ((e:))
                              ((n.name is o)
                               ((e:))
                               ((n.n.name is o)
                                ((p.p.name is e)
                                 ((p.p.p.name is z) ((e:)) ((E)))
                                 ((e:)))
                                ((n.name is b)
                                 ((p.p.name is e) ((E)) ((e:)))
                                 ((n.n.name is u)
                                  ((n.n.n.name is e) ((@)) ((e:)))
                                  ((n.n.n.name is t)
                                   ((p.p.name is k)
                                    ((e:))
                                    ((n.n.name is s)
                                     ((p.p.name is e) ((e:)) ((E)))
                                     ((E))))
                                   ((n.n.n.name is a)
                                    ((p.p.name is e)
                                     ((E))
                                     ((p.p.name is h) ((@)) ((e:))))
                                    ((p.p.name is n)
                                     ((n.name is f) ((e:)) ((E)))
                                     ((p.p.p.name is e)
                                      ((p.p.name is t)
                                       ((E))
                                       ((n.n.name is b)
                                        ((E))
                                        ((p.p.name is f) ((E)) ((@)))))
                                      ((E)))))))))))))))
                         ((n.name is t)
                          ((n.n.name is z)
                           ((E))
                           ((n.n.name is t)
                            ((E))
                            ((n.n.n.name is t)
                             ((@))
                             ((p.p.p.name is o)
                              ((p.p.name is n) ((@)) ((E)))
                              ((n.n.name is s)
                               ((E))
                               ((p.p.p.name is e)
                                ((p.p.name is r) ((e:)) ((@)))
                                ((e:))))))))
                          ((n.n.n.name is i)
                           ((n.n.name is t)
                            ((n.name is l)
                             ((@))
                             ((p.name is s)
                              ((E))
                              ((p.name is h)
                               ((p.p.p.name is u) ((E)) ((@)))
                               ((p.p.name is p)
                                ((@))
                                ((p.name is t)
                                 ((E))
                                 ((p.p.name is a)
                                  ((p.name is l)
                                   ((E))
                                   ((p.name is m) ((E)) ((@))))
                                  ((E))))))))
                            ((n.name is b)
                             ((p.p.p.name is n) ((@)) ((e:)))
                             ((p.name is h)
                              ((n.n.name is z)
                               ((E))
                               ((n.name is l)
                                ((E))
                                ((p.p.name is c)
                                 ((n.n.name is b) ((E)) ((@)))
                                 ((n.n.name is r) ((@)) ((e:))))))
                              ((n.name is r)
                               ((n.n.name is l)
                                ((@))
                                ((p.p.name is n)
                                 ((p.p.p.name is u)
                                  ((@))
                                  ((p.p.p.name is i)
                                   ((@))
                                   ((p.p.p.name is a) ((@)) ((E)))))
                                 ((p.p.p.name is i)
                                  ((@))
                                  ((p.p.name is i)
                                   ((@))
                                   ((n.n.name is d)
                                    ((@))
                                    ((n.n.name is w)
                                     ((@))
                                     ((p.p.p.name is u)
                                      ((@))
                                      ((n.n.name is v)
                                       ((E))
                                       ((p.p.p.name is d)
                                        ((E))
                                        ((n.n.name is z)
                                         ((E))
                                         ((p.p.name is o)
                                          ((E))
                                          ((p.name is d)
                                           ((@))
                                           ((p.p.name is l)
                                            ((E))
                                            ((p.p.p.name is a)
                                             ((@))
                                             ((p.p.p.name is n)
                                              ((@))
                                              ((p.p.p.name is e)
                                               ((p.p.name is r)
                                                ((E))
                                                ((n.n.name is b)
                                                 ((E))
                                                 ((@))))
                                               ((E))))))))))))))))))
                               ((n.n.name is s)
                                ((n.name is l) ((@)) ((E)))
                                ((n.name is n)
                                 ((n.n.name is d)
                                  ((p.name is p)
                                   ((E))
                                   ((p.p.p.name is s)
                                    ((E))
                                    ((p.p.name is h)
                                     ((@))
                                     ((p.p.p.name is a) ((E)) ((@))))))
                                  ((n.n.name is z)
                                   ((p.p.p.name is a) ((@)) ((E)))
                                   ((p.p.name is e)
                                    ((n.n.name is g) ((@)) ((E)))
                                    ((@)))))
                                 ((n.n.name is l)
                                  ((E))
                                  ((n.name is l)
                                   ((@))
                                   ((n.name is s)
                                    ((n.n.name is z) ((E)) ((@)))
                                    ((n.name is o) ((e:)) ((E))))))))))))
                           ((n.n.name is a)
                            ((n.n.n.name is t)
                             ((n.name is m)
                              ((e:))
                              ((p.p.name is s)
                               ((e:))
                               ((p.p.p.name is e)
                                ((@))
                                ((p.p.name is i)
                                 ((@))
                                 ((p.p.p.name is g)
                                  ((@))
                                  ((p.name is d) ((@)) ((e:))))))))
                             ((p.name is l)
                              ((p.p.name is l)
                               ((@))
                               ((n.n.n.name is n)
                                ((e:))
                                ((n.name is m) ((e:)) ((@)))))
                              ((p.p.p.name is m)
                               ((e:))
                               ((n.n.n.name is u)
                                ((@))
                                ((n.name is d)
                                 ((e:))
                                 ((p.name is e)
                                  ((p.p.p.name is i) ((@)) ((e:)))
                                  ((n.n.n.name is p)
                                   ((e:))
                                   ((n.n.n.name is l)
                                    ((p.name is n)
                                     ((@))
                                     ((p.p.p.name is e)
                                      ((@))
                                      ((p.p.p.name is a)
                                       ((e:))
                                       ((p.p.p.name is l) ((e:)) ((@))))))
                                    ((p.name is s)
                                     ((@))
                                     ((p.p.p.name is t)
                                      ((@))
                                      ((n.name is m)
                                       ((n.n.n.name is c) ((@)) ((e:)))
                                       ((@)))))))))))))
                            ((n.n.name is l)
                             ((n.name is l)
                              ((n.n.n.name is o)
                               ((@))
                               ((n.n.n.name is a)
                                ((p.p.p.name is c)
                                 ((E))
                                 ((p.name is p) ((E)) ((@))))
                                ((E))))
                              ((n.name is n)
                               ((@))
                               ((n.name is r)
                                ((p.name is t)
                                 ((@))
                                 ((p.name is d)
                                  ((@))
                                  ((p.p.p.name is u)
                                   ((e:))
                                   ((p.p.name is c)
                                    ((@))
                                    ((p.name is l)
                                     ((@))
                                     ((p.name is n)
                                      ((@))
                                      ((n.n.n.name is a)
                                       ((@))
                                       ((p.p.name is s) ((@)) ((E))))))))))
                                ((p.p.p.name is e)
                                 ((@))
                                 ((n.n.n.name is a) ((@)) ((e:)))))))
                             ((p.name is t)
                              ((n.name is m)
                               ((p.p.p.name is y) ((e:)) ((E)))
                               ((n.name is n)
                                ((n.n.name is t)
                                 ((p.p.p.name is p)
                                  ((E))
                                  ((p.p.name is s)
                                   ((E))
                                   ((n.n.n.name is a)
                                    ((@))
                                    ((p.p.name is a)
                                     ((@))
                                     ((p.p.p.name is a) ((@)) ((E)))))))
                                 ((n.n.name is z)
                                  ((p.p.p.name is p)
                                   ((E))
                                   ((p.p.p.name is i) ((E)) ((@))))
                                  ((n.n.n.name is e)
                                   ((p.p.p.name is e)
                                    ((@))
                                    ((n.n.name is r)
                                     ((@))
                                     ((p.p.name is n)
                                      ((n.n.name is u) ((@)) ((E)))
                                      ((@)))))
                                   ((@)))))
                                ((p.p.name is e)
                                 ((p.p.p.name is h)
                                  ((e:))
                                  ((n.name is o)
                                   ((e:))
                                   ((n.name is r)
                                    ((@))
                                    ((n.name is s) ((@)) ((E))))))
                                 ((n.n.name is n)
                                  ((n.n.n.name is d)
                                   ((@))
                                   ((p.p.p.name is u)
                                    ((@))
                                    ((n.n.n.name is e)
                                     ((p.p.p.name is c)
                                      ((@))
                                      ((p.p.p.name is e) ((@)) ((E))))
                                     ((p.p.p.name is a)
                                      ((E))
                                      ((n.n.n.name is a)
                                       ((@))
                                       ((n.n.n.name is o)
                                        ((@))
                                        ((p.p.p.name is e) ((@)) ((E)))))))))
                                  ((n.n.name is r)
                                   ((p.p.name is r)
                                    ((e:))
                                    ((p.p.p.name is u)
                                     ((@))
                                     ((p.p.p.name is e)
                                      ((@))
                                      ((p.p.p.name is c)
                                       ((E))
                                       ((p.p.name is n)
                                        ((E))
                                        ((n.n.n.name is o) ((@)) ((E))))))))
                                   ((p.p.name is o)
                                    ((n.n.name is t)
                                     ((n.n.n.name is e) ((@)) ((E)))
                                     ((E)))
                                    ((p.p.p.name is b)
                                     ((E))
                                     ((n.name is k)
                                      ((E))
                                      ((n.n.name is b)
                                       ((n.n.n.name is t)
                                        ((E))
                                        ((p.p.p.name is u)
                                         ((@))
                                         ((p.p.p.name is i)
                                          ((@))
                                          ((p.p.p.name is e)
                                           ((@))
                                           ((n.n.n.name is e)
                                            ((E))
                                            ((@)))))))
                                       ((p.p.name is n)
                                        ((@))
                                        ((n.n.name is t)
                                         ((n.n.n.name is a)
                                          ((E))
                                          ((@)))
                                         ((p.p.p.name is i)
                                          ((@))
                                          ((p.p.name is i)
                                           ((@))
                                           ((n.n.n.name is e)
                                            ((n.name is r)
                                             ((n.n.name is g)
                                              ((E))
                                              ((@)))
                                             ((E)))
                                            ((p.p.name is t)
                                             ((@))
                                             ((n.n.name is f)
                                              ((E))
                                              ((p.p.name is s)
                                               ((@))
                                               ((n.n.name is h)
                                                ((E))
                                                ((@))))))))))))))))))))
                              ((p.name is d)
                               ((n.name is n)
                                ((n.n.name is k)
                                 ((E))
                                 ((n.n.name is t)
                                  ((p.p.name is r)
                                   ((@))
                                   ((n.n.n.name is e)
                                    ((E))
                                    ((p.p.p.name is e) ((@)) ((E)))))
                                  ((n.n.name is z)
                                   ((E))
                                   ((p.p.p.name is o)
                                    ((p.p.name is n) ((E)) ((@)))
                                    ((@))))))
                                ((n.n.n.name is k)
                                 ((e:))
                                 ((p.p.p.name is m)
                                  ((n.n.name is n) ((E)) ((@)))
                                  ((n.n.name is p)
                                   ((n.n.n.name is r) ((@)) ((E)))
                                   ((p.p.p.name is e)
                                    ((n.n.name is b)
                                     ((n.n.n.name is a) ((@)) ((E)))
                                     ((@)))
                                    ((p.p.name is o)
                                     ((n.name is r) ((E)) ((@)))
                                     ((@))))))))
                               ((n.name is n)
                                ((n.n.name is t)
                                 ((n.n.n.name is l)
                                  ((p.p.name is a)
                                   ((E))
                                   ((p.p.name is e)
                                    ((@))
                                    ((p.p.p.name is e)
                                     ((@))
                                     ((p.p.name is l) ((@)) ((E))))))
                                  ((p.p.name is e)
                                   ((p.name is m)
                                    ((n.n.n.name is e)
                                     ((E))
                                     ((n.n.n.name is a)
                                      ((E))
                                      ((n.n.n.name is s)
                                       ((p.p.p.name is l)
                                        ((E))
                                        ((a~:)))
                                       ((a~:)))))
                                    ((E)))
                                   ((p.p.name is m)
                                    ((@))
                                    ((p.name is h)
                                     ((@))
                                     ((p.p.p.name is u)
                                      ((@))
                                      ((n.n.n.name is e)
                                       ((E))
                                       ((p.p.name is l)
                                        ((@))
                                        ((p.name is n)
                                         ((p.p.name is i) ((E)) ((@)))
                                         ((p.name is s)
                                          ((p.p.name is r)
                                           ((E))
                                           ((p.p.name is t)
                                            ((E))
                                            ((@))))
                                          ((p.p.name is t) ((@)) ((E))))))))))))
                                 ((n.n.name is n)
                                  ((n.n.n.name is a) ((@)) ((E)))
                                  ((n.n.name is k)
                                   ((n.n.n.name is e)
                                    ((p.p.name is m) ((@)) ((E)))
                                    ((n.n.n.name is t)
                                     ((E))
                                     ((n.n.n.name is s)
                                      ((E))
                                      ((n.n.n.name is u)
                                       ((p.p.p.name is o) ((@)) ((E)))
                                       ((@))))))
                                   ((p.p.name is b)
                                    ((E))
                                    ((p.p.name is c)
                                     ((@))
                                     ((n.n.n.name is a)
                                      ((@))
                                      ((p.p.p.name is a)
                                       ((p.p.name is u)
                                        ((n.n.n.name is t) ((E)) ((@)))
                                        ((@)))
                                       ((p.name is m)
                                        ((n.n.name is g)
                                         ((E))
                                         ((n.n.n.name is c)
                                          ((E))
                                          ((n.n.n.name is u)
                                           ((E))
                                           ((@)))))
                                        ((n.n.name is d)
                                         ((p.p.name is i)
                                          ((@))
                                          ((p.name is h)
                                           ((p.p.p.name is b)
                                            ((E))
                                            ((@)))
                                           ((n.n.n.name is s)
                                            ((@))
                                            ((p.name is p)
                                             ((E))
                                             ((p.p.p.name is k)
                                              ((E))
                                              ((n.n.n.name is u)
                                               ((E))
                                               ((p.p.p.name is c)
                                                ((E))
                                                ((p.p.p.name is n)
                                                 ((E))
                                                 ((p.name is k)
                                                  ((@))
                                                  ((p.name is z)
                                                   ((@))
                                                   ((p.p.p.name is w)
                                                    ((@))
                                                    ((p.p.name is f)
                                                     ((@))
                                                     ((p.p.name is s)
                                                      ((@))
                                                      ((p.name is s)
                                                       ((p.p.p.name
                                                         is
                                                         e)
                                                        ((E))
                                                        ((p.p.p.name
                                                          is
                                                          i)
                                                         ((E))
                                                         ((@))))
                                                       ((p.p.p.name
                                                         is
                                                         i)
                                                        ((@))
                                                        ((p.p.name
                                                          is
                                                          r)
                                                         ((@))
                                                         ((p.p.name
                                                           is
                                                           e)
                                                          ((E))
                                                          ((@)))))))))))))))))))
                                         ((p.name is p)
                                          ((p.p.name is s) ((E)) ((@)))
                                          ((@))))))))))))
                                ((n.name is l)
                                 ((n.n.name is d)
                                  ((p.p.name is c) ((@)) ((E)))
                                  ((n.n.name is z)
                                   ((n.n.n.name is u)
                                    ((p.p.p.name is o) ((E)) ((@)))
                                    ((E)))
                                   ((p.name is e)
                                    ((e:))
                                    ((p.name is h)
                                     ((n.n.name is f)
                                      ((E))
                                      ((n.n.name is m)
                                       ((E))
                                       ((n.n.name is c) ((E)) ((@)))))
                                     ((n.n.n.name is s)
                                      ((n.n.name is b) ((E)) ((@)))
                                      ((p.name is l) ((e:)) ((@))))))))
                                 ((n.name is b)
                                  ((n.n.name is r) ((@)) ((e:)))
                                  ((p.name is s)
                                   ((n.n.name is t)
                                    ((n.name is k) ((E)) ((@)))
                                    ((p.p.name is s)
                                     ((n.name is s)
                                      ((E))
                                      ((p.p.p.name is i) ((E)) ((@))))
                                     ((n.n.name is u)
                                      ((n.name is x)
                                       ((E))
                                       ((p.p.p.name is o)
                                        ((e:))
                                        ((n.name is r) ((@)) ((e:)))))
                                      ((n.name is k)
                                       ((@))
                                       ((n.n.name is n)
                                        ((@))
                                        ((n.n.n.name is t)
                                         ((@))
                                         ((n.n.n.name is r)
                                          ((@))
                                          ((n.n.n.name is e)
                                           ((E))
                                           ((n.name is r) ((E)) ((@)))))))))))
                                   ((n.name is r)
                                    ((p.name is h)
                                     ((p.p.name is c)
                                      ((n.n.name is z)
                                       ((E))
                                       ((p.p.p.name is s)
                                        ((n.n.name is t)
                                         ((e:))
                                         ((n.n.n.name is e)
                                          ((E))
                                          ((n.n.name is s)
                                           ((e:))
                                           ((@)))))
                                        ((p.p.p.name is i)
                                         ((@))
                                         ((n.n.n.name is e)
                                          ((@))
                                          ((p.p.p.name is u)
                                           ((@))
                                           ((E)))))))
                                      ((p.p.name is e)
                                       ((p.p.p.name is b) ((E)) ((@)))
                                       ((n.n.name is r)
                                        ((E))
                                        ((p.p.p.name is r)
                                         ((E))
                                         ((p.p.name is i)
                                          ((@))
                                          ((p.p.name is t)
                                           ((n.n.name is f)
                                            ((@))
                                            ((E)))
                                           ((n.n.n.name is o)
                                            ((E))
                                            ((e:)))))))))
                                     ((n.n.name is t)
                                      ((p.name is z)
                                       ((p.p.p.name is o) ((E)) ((@)))
                                       ((@)))
                                      ((p.p.name is s)
                                       ((E))
                                       ((p.name is e)
                                        ((e:))
                                        ((n.n.name is d)
                                         ((p.p.name is p)
                                          ((n.n.n.name is e)
                                           ((e:))
                                           ((@)))
                                          ((@)))
                                         ((n.n.name is z)
                                          ((p.p.name is h)
                                           ((E))
                                           ((p.p.name is e)
                                            ((E))
                                            ((@))))
                                          ((n.n.name is k)
                                           ((p.name is m) ((E)) ((@)))
                                           ((p.p.p.name is n)
                                            ((E))
                                            ((n.n.name is r)
                                             ((p.name is k)
                                              ((@))
                                              ((E)))
                                             ((p.p.name is p)
                                              ((@))
                                              ((n.n.name is o)
                                               ((p.p.p.name is s)
                                                ((e:))
                                                ((p.name is k)
                                                 ((E))
                                                 ((@))))
                                               ((n.n.n.name is d)
                                                ((@))
                                                ((n.n.name is n)
                                                 ((p.p.name is i)
                                                  ((@))
                                                  ((p.name is m)
                                                   ((@))
                                                   ((p.p.name is l)
                                                    ((@))
                                                    ((E)))))
                                                 ((n.n.name is f)
                                                  ((n.n.n.name is u)
                                                   ((E))
                                                   ((@)))
                                                  ((p.p.name is m)
                                                   ((@))
                                                   ((p.p.p.name is i)
                                                    ((p.name is k)
                                                     ((p.p.name is c)
                                                      ((@))
                                                      ((E)))
                                                     ((@)))
                                                    ((n.n.n.name is o)
                                                     ((n.n.name is s)
                                                      ((E))
                                                      ((p.name is l)
                                                       ((E))
                                                       ((@))))
                                                     ((n.n.name is h)
                                                      ((@))
                                                      ((p.name is z)
                                                       ((p.p.p.name
                                                         is
                                                         a)
                                                        ((@))
                                                        ((E)))
                                                       ((p.p.name is e)
                                                        ((n.n.name
                                                          is
                                                          w)
                                                         ((E))
                                                         ((n.n.name
                                                           is
                                                           g)
                                                          ((E))
                                                          ((@))))
                                                        ((p.p.name
                                                          is
                                                          u)
                                                         ((p.p.p.name
                                                           is
                                                           a)
                                                          ((E))
                                                          ((@)))
                                                         ((n.n.n.name
                                                           is
                                                           e)
                                                          ((p.p.name
                                                            is
                                                            l)
                                                           ((@))
                                                           ((p.p.p.name
                                                             is
                                                             o)
                                                            ((@))
                                                            ((p.p.name
                                                              is
                                                              h)
                                                             ((@))
                                                             ((p.name
                                                               is
                                                               p)
                                                              ((@))
                                                              ((E))))))
                                                          ((p.p.p.name
                                                            is
                                                            a)
                                                           ((p.p.name
                                                             is
                                                             c)
                                                            ((@))
                                                            ((n.n.name
                                                              is
                                                              s)
                                                             ((E))
                                                             ((@))))
                                                           ((p.p.name
                                                             is
                                                             c)
                                                            ((p.p.p.name
                                                              is
                                                              e)
                                                             ((E))
                                                             ((@)))
                                                            ((@))))))))))))))))))))))))))
                                    ((p.name is h)
                                     ((n.name is s)
                                      ((p.p.p.name is r)
                                       ((p.p.name is c) ((E)) ((@)))
                                       ((@)))
                                      ((p.p.name is t)
                                       ((n.name is a) ((e:)) ((E)))
                                       ((n.n.name is u)
                                        ((@))
                                        ((n.n.name is o) ((@)) ((E))))))
                                     ((n.n.name is o)
                                      ((p.p.name is n) ((@)) ((e:)))
                                      ((n.n.name is u)
                                       ((p.p.p.name is e)
                                        ((@))
                                        ((p.name is m) ((@)) ((e:))))
                                       ((n.name is s)
                                        ((p.name is f)
                                         ((E))
                                         ((n.n.name is s)
                                          ((E))
                                          ((p.p.name is e)
                                           ((p.name is l) ((e:)) ((E)))
                                           ((p.p.p.name is e)
                                            ((@))
                                            ((p.p.p.name is a)
                                             ((@))
                                             ((p.name is l)
                                              ((E))
                                              ((n.n.name is t)
                                               ((n.n.n.name is e)
                                                ((p.name is n)
                                                 ((E))
                                                 ((@)))
                                                ((E)))
                                               ((@)))))))))
                                        ((n.name is a)
                                         ((e:))
                                         ((n.n.name is h)
                                          ((e:))
                                          ((n.n.name is k)
                                           ((e:))
                                           ((p.p.name is n)
                                            ((n.n.name is t)
                                             ((E))
                                             ((e:)))
                                            ((E)))))))))))))))))))))))))))))))))))))))))))))
 (f
  ((p.name is p)
   ((n.name is r) ((p.p.name is e) ((f)) ((_epsilon_))) ((_epsilon_)))
   ((n.name is f)
    ((p.p.name is a)
     ((p.name is e) ((_epsilon_)) ((f)))
     ((p.p.name is e) ((f)) ((_epsilon_))))
    ((f)))))
 (g
  ((p.name is n)
   ((p.p.p.name is #)
    ((p.p.name is e)
     ((_epsilon_))
     ((n.name is s)
      ((_epsilon_))
      ((n.n.name is n)
       ((n.n.n.name is i) ((p.p.name is i) ((g)) ((Z))) ((g)))
       ((g)))))
    ((p.p.p.name is e)
     ((g))
     ((p.p.name is u)
      ((n.name is i)
       ((g))
       ((n.n.n.name is h)
        ((g))
        ((n.name is l)
         ((n.n.name is u) ((g)) ((_epsilon_)))
         ((_epsilon_)))))
      ((p.p.p.name is a)
       ((_epsilon_))
       ((n.n.n.name is #)
        ((_epsilon_))
        ((n.n.name is #)
         ((_epsilon_))
         ((n.name is i)
          ((n.n.name is g)
           ((_epsilon_))
           ((n.n.n.name is r)
            ((p.p.name is a) ((Z)) ((p.p.name is i) ((g)) ((Z))))
            ((g))))
          ((p.p.name is e)
           ((p.p.p.name is u)
            ((_epsilon_))
            ((p.p.p.name is r)
             ((n.name is e)
              ((n.n.name is n)
               ((_epsilon_))
               ((n.n.n.name is t) ((_epsilon_)) ((g))))
              ((_epsilon_)))
             ((n.n.n.name is e)
              ((g))
              ((n.n.name is i)
               ((_epsilon_))
               ((n.name is t)
                ((_epsilon_))
                ((n.n.name is n)
                 ((_epsilon_))
                 ((n.n.name is l)
                  ((n.n.n.name is d)
                   ((g))
                   ((p.p.p.name is t) ((_epsilon_)) ((g))))
                  ((p.p.p.name is s) ((_epsilon_)) ((g))))))))))
           ((p.p.name is o)
            ((p.p.p.name is k)
             ((g))
             ((p.p.p.name is m)
              ((g))
              ((p.p.p.name is t) ((g)) ((_epsilon_)))))
            ((n.name is u)
             ((n.n.name is n)
              ((_epsilon_))
              ((n.n.n.name is i) ((_epsilon_)) ((g))))
             ((n.name is e)
              ((n.n.n.name is o)
               ((g))
               ((p.p.p.name is n)
                ((g))
                ((p.p.p.name is h)
                 ((p.p.name is a) ((_epsilon_)) ((g)))
                 ((p.p.name is i)
                  ((p.p.p.name is t)
                   ((g))
                   ((n.n.n.name is i)
                    ((_epsilon_))
                    ((n.n.n.name is d)
                     ((_epsilon_))
                     ((n.n.name is n) ((g)) ((_epsilon_))))))
                  ((n.n.name is n)
                   ((_epsilon_))
                   ((p.p.p.name is m)
                    ((_epsilon_))
                    ((p.p.name is a)
                     ((n.n.n.name is f)
                      ((_epsilon_))
                      ((p.p.p.name is l)
                       ((_epsilon_))
                       ((n.n.name is h)
                        ((g))
                        ((p.p.p.name is r)
                         ((n.n.name is l) ((_epsilon_)) ((g)))
                         ((n.n.name is l)
                          ((g))
                          ((n.n.n.name is s)
                           ((g))
                           ((p.p.p.name is t) ((g)) ((_epsilon_)))))))))
                     ((g)))))))))
              ((n.name is r)
               ((p.p.p.name is f) ((_epsilon_)) ((g)))
               ((n.name is a)
                ((p.p.p.name is h)
                 ((g))
                 ((p.p.p.name is s) ((g)) ((_epsilon_))))
                ((_epsilon_)))))))))))))))
   ((n.name is e)
    ((p.p.p.name is g)
     ((n.n.n.name is t) ((tS)) ((n.n.name is a) ((Z)) ((g))))
     ((p.name is a)
      ((p.p.p.name is a) ((p.p.name is p) ((g)) ((Z))) ((g)))
      ((n.n.n.name is i)
       ((n.n.name is n)
        ((g))
        ((p.p.name is u)
         ((p.p.p.name is a)
          ((g))
          ((p.name is e) ((g)) ((p.name is m) ((g)) ((Z)))))
         ((g))))
       ((g)))))
    ((p.name is i)
     ((n.name is s)
      ((p.p.name is e) ((k)) ((x)))
      ((n.name is #)
       ((x))
       ((n.name is t)
        ((p.p.name is e) ((k)) ((x)))
        ((n.name is k)
         ((x))
         ((n.name is b)
          ((p.p.name is e) ((k)) ((x)))
          ((n.name is g)
           ((x))
           ((n.n.name is i)
            ((p.p.name is s)
             ((g))
             ((n.n.n.name is e)
              ((n.name is n) ((g)) ((n.name is r) ((g)) ((x))))
              ((k))))
            ((n.n.name is a)
             ((n.n.n.name is t)
              ((g))
              ((n.name is n)
               ((g))
               ((n.name is r)
                ((g))
                ((n.name is m) ((n.n.n.name is c) ((x)) ((g))) ((x))))))
             ((p.p.name is s)
              ((n-j))
              ((n.n.name is e)
               ((p.p.name is l) ((Z)) ((n.name is r) ((k)) ((g))))
               ((n.n.name is n)
                ((g))
                ((n.name is i)
                 ((g))
                 ((p.p.p.name is #)
                  ((g))
                  ((n.name is n)
                   ((g))
                   ((p.p.p.name is b)
                    ((g))
                    ((p.p.name is f)
                     ((g))
                     ((n.name is a)
                      ((g))
                      ((p.p.name is l) ((x)) ((g))))))))))))))))))))
     ((n.name is t)
      ((k))
      ((n.name is s)
       ((k))
       ((n.name is g)
        ((p.p.name is w)
         ((k))
         ((n.n.n.name is b)
          ((k))
          ((p.p.p.name is f)
           ((p.name is a) ((_epsilon_)) ((k)))
           ((_epsilon_)))))
        ((n.name is #)
         ((k))
         ((p.p.name is w)
          ((p.p.p.name is #)
           ((k))
           ((n.name is l)
            ((k))
            ((p.p.p.name is n) ((k)) ((p.p.p.name is r) ((k)) ((g))))))
          ((n.n.n.name is c)
           ((n.n.name is i)
            ((p.p.p.name is #)
             ((g))
             ((p.name is e)
              ((k))
              ((p.p.p.name is t)
               ((k))
               ((p.name is a) ((k)) ((p.p.p.name is s) ((k)) ((g)))))))
            ((n.name is i) ((g)) ((n.name is l) ((g)) ((k)))))
           ((p.name is a)
            ((n.name is i)
             ((n.n.n.name is r) ((p.p.p.name is n) ((Z)) ((g))) ((g)))
             ((p.p.p.name is h)
              ((k))
              ((p.p.p.name is t)
               ((n.n.name is n) ((g)) ((n.name is n) ((g)) ((k))))
               ((n.name is d)
                ((k))
                ((n.name is n)
                 ((n.n.n.name is s)
                  ((g))
                  ((n.n.n.name is t)
                   ((g))
                   ((n.n.n.name is e) ((g)) ((n-j)))))
                 ((n.name is h)
                  ((k))
                  ((n.name is w)
                   ((k))
                   ((p.p.name is t)
                    ((n.name is o)
                     ((g))
                     ((p.p.p.name is #) ((k)) ((g))))
                    ((n.n.n.name is r)
                     ((n.name is r) ((g)) ((k)))
                     ((g)))))))))))
            ((n.name is b)
             ((k))
             ((p.name is u)
              ((p.p.name is l)
               ((k))
               ((n.name is i)
                ((g))
                ((n.name is u)
                 ((g))
                 ((p.p.p.name is z)
                  ((k))
                  ((n.name is f)
                   ((k))
                   ((n.name is k)
                    ((k))
                    ((p.p.p.name is a)
                     ((k))
                     ((n.n.name is o)
                      ((k))
                      ((n.name is r)
                       ((g))
                       ((p.p.name is e)
                        ((g))
                        ((n.name is a)
                         ((p.p.name is a) ((k)) ((g)))
                         ((n.name is l)
                          ((g))
                          ((n.name is o) ((g)) ((k)))))))))))))))
              ((n.name is i)
               ((p.p.p.name is p)
                ((tS))
                ((p.name is o)
                 ((n.n.n.name is r) ((Z)) ((g)))
                 ((p.p.name is t)
                  ((n.n.n.name is r) ((Z)) ((g)))
                  ((g)))))
               ((n.name is w)
                ((k))
                ((p.p.p.name is s)
                 ((n.n.n.name is s)
                  ((k))
                  ((n.n.n.name is i)
                   ((n.name is r) ((k)) ((g)))
                   ((p.p.name is o) ((n.name is u) ((g)) ((k))) ((g)))))
                 ((p.p.name is a)
                  ((n.n.n.name is s)
                   ((n.n.name is i) ((k)) ((n.name is l) ((k)) ((g))))
                   ((n.name is h) ((k)) ((g))))
                  ((p.p.p.name is w)
                   ((p.name is r) ((k)) ((g)))
                   ((p.p.p.name is f)
                    ((p.p.name is o) ((k)) ((g)))
                    ((p.p.p.name is b)
                     ((n.name is r)
                      ((g))
                      ((n.name is o)
                       ((g))
                       ((n.n.name is n)
                        ((g))
                        ((n.name is l)
                         ((g))
                         ((n.name is a) ((g)) ((k)))))))
                     ((p.name is e)
                      ((p.p.p.name is z) ((k)) ((g)))
                      ((g)))))))))))))))))))))))
 (h
  ((p.name is c)
   ((_epsilon_))
   ((p.name is #)
    ((h))
    ((n.name is a)
     ((p.name is p)
      ((n.n.name is f) ((h)) ((_epsilon_)))
      ((p.p.name is #)
       ((p.name is a) ((h)) ((_epsilon_)))
       ((p.name is g)
        ((n.n.name is f)
         ((h))
         ((p.p.p.name is w)
          ((h))
          ((p.p.name is i)
           ((h))
           ((n.n.name is a)
            ((h))
            ((p.p.p.name is a) ((h)) ((_epsilon_)))))))
        ((h)))))
     ((p.name is r)
      ((p.p.name is e)
       ((h))
       ((p.p.name is #)
        ((_epsilon_))
        ((p.p.name is r)
         ((_epsilon_))
         ((n.n.name is i) ((p.p.name is h) ((h)) ((_epsilon_))) ((h))))))
      ((p.name is n)
       ((h))
       ((n.name is r)
        ((_epsilon_))
        ((n.name is l)
         ((_epsilon_))
         ((n.name is n)
          ((_epsilon_))
          ((n.name is m)
           ((_epsilon_))
           ((n.n.name is i)
            ((n.name is e)
             ((p.name is t)
              ((p.p.p.name is e)
               ((h))
               ((p.p.p.name is c)
                ((h))
                ((p.p.name is m) ((h)) ((_epsilon_)))))
              ((h)))
             ((_epsilon_)))
            ((p.p.p.name is #)
             ((p.p.name is r)
              ((_epsilon_))
              ((p.p.name is n)
               ((n.n.name is l)
                ((n.name is e) ((_epsilon_)) ((h)))
                ((_epsilon_)))
               ((p.p.name is s)
                ((_epsilon_))
                ((p.p.name is w)
                 ((_epsilon_))
                 ((p.name is t)
                  ((_epsilon_))
                  ((p.name is u)
                   ((p.p.name is z) ((h)) ((_epsilon_)))
                   ((p.name is p)
                    ((_epsilon_))
                    ((p.p.name is g)
                     ((n.n.name is n)
                      ((_epsilon_))
                      ((n.name is o)
                       ((h))
                       ((n.name is i)
                        ((h))
                        ((n.name is e) ((h)) ((_epsilon_))))))
                     ((p.name is o) ((_epsilon_)) ((h)))))))))))
             ((p.p.p.name is a)
              ((p.name is t)
               ((n.n.name is n)
                ((_epsilon_))
                ((p.p.name is e)
                 ((_epsilon_))
                 ((p.p.name is n) ((_epsilon_)) ((h)))))
               ((p.name is p) ((_epsilon_)) ((h))))
              ((n.name is o)
               ((p.name is p)
                ((_epsilon_))
                ((p.name is t)
                 ((n.n.name is e)
                  ((h))
                  ((p.p.p.name is e) ((h)) ((_epsilon_))))
                 ((p.p.name is i)
                  ((p.p.p.name is s) ((_epsilon_)) ((h)))
                  ((h)))))
               ((p.p.name is c)
                ((h))
                ((p.p.name is b)
                 ((h))
                 ((p.name is e)
                  ((n.n.name is u)
                   ((h))
                   ((n.name is u)
                    ((p.p.p.name is z)
                     ((_epsilon_))
                     ((p.p.p.name is h)
                      ((_epsilon_))
                      ((p.p.p.name is r)
                       ((_epsilon_))
                       ((p.p.p.name is s) ((h)) ((_epsilon_))))))
                    ((n.n.name is m)
                     ((h))
                     ((p.p.name is l)
                      ((_epsilon_))
                      ((n.name is i)
                       ((n.n.name is g) ((_epsilon_)) ((h)))
                       ((_epsilon_)))))))
                  ((p.name is p)
                   ((_epsilon_))
                   ((p.name is s)
                    ((h))
                    ((n.name is u)
                     ((p.name is i)
                      ((_epsilon_))
                      ((n.n.name is s) ((_epsilon_)) ((h))))
                     ((n.n.name is r)
                      ((p.p.name is #)
                       ((_epsilon_))
                       ((p.p.p.name is f)
                        ((_epsilon_))
                        ((p.p.p.name is l)
                         ((_epsilon_))
                         ((p.p.name is o)
                          ((_epsilon_))
                          ((p.name is i)
                           ((_epsilon_))
                           ((n.name is e)
                            ((p.name is a) ((_epsilon_)) ((h)))
                            ((_epsilon_))))))))
                      ((n.name is i)
                       ((n.n.name is s)
                        ((_epsilon_))
                        ((p.name is u)
                         ((_epsilon_))
                         ((p.p.name is a) ((_epsilon_)) ((h)))))
                       ((n.n.name is b)
                        ((h))
                        ((n.n.name is l)
                         ((n.name is e) ((h)) ((_epsilon_)))
                         ((p.p.name is h)
                          ((p.name is u) ((_epsilon_)) ((h)))
                          ((_epsilon_)))))))))))))))))))))))))))
 (i
  ((p.name is e)
   ((p.p.name is a)
    ((I))
    ((n.n.name is r)
     ((n.name is r)
      ((I))
      ((p.p.p.name is k)
       ((n.n.n.name is t) ((i:)) ((_epsilon_)))
       ((_epsilon_))))
     ((p.p.name is o)
      ((I))
      ((n.name is s)
       ((p.p.p.name is t)
        ((n.n.n.name is i) ((I)) ((_epsilon_)))
        ((n.n.name is c)
         ((p.p.p.name is f)
          ((_epsilon_))
          ((p.p.name is b)
           ((_epsilon_))
           ((p.p.name is h)
            ((_epsilon_))
            ((p.p.p.name is k) ((_epsilon_)) ((I))))))
         ((n.n.n.name is l)
          ((p.p.name is m) ((i:)) ((_epsilon_)))
          ((_epsilon_)))))
       ((n.n.name is p)
        ((n.name is m) ((I)) ((_epsilon_)))
        ((_epsilon_)))))))
   ((n.name is e)
    ((p.name is a)
     ((_epsilon_))
     ((p.p.name is z)
      ((p.p.p.name is #)
       ((n.n.name is b)
        ((i:))
        ((n.n.name is l)
         ((_epsilon_))
         ((n.n.name is s)
          ((_epsilon_))
          ((n.n.name is t) ((_epsilon_)) ((i:))))))
       ((i:)))
      ((p.name is v)
       ((n.n.n.name is t) ((p.p.name is #) ((I)) ((i:))) ((i:)))
       ((i:)))))
    ((n.n.name is i)
     ((p.name is a)
      ((p.p.p.name is t)
       ((_epsilon_))
       ((p.p.name is l)
        ((_epsilon_))
        ((p.p.p.name is #) ((i:)) ((_epsilon_)))))
      ((n.name is x) ((I)) ((i:))))
     ((n.name is o)
      ((i:))
      ((n.n.name is a)
       ((p.name is h)
        ((p.p.name is #) ((I)) ((i:)))
        ((p.name is #)
         ((n.name is n) ((I)) ((i:)))
         ((p.name is a)
          ((_epsilon_))
          ((n.n.n.name is r) ((p.name is m) ((I)) ((i:))) ((i:))))))
       ((n.name is v)
        ((i:))
        ((n.name is d)
         ((n.n.name is m)
          ((I))
          ((n.n.name is e)
           ((i:))
           ((p.p.name is #)
            ((p.name is s) ((i:)) ((I)))
            ((n.n.name is o) ((I)) ((i:))))))
         ((n.name is a)
          ((i:))
          ((n.n.name is o)
           ((p.name is a)
            ((_epsilon_))
            ((n.n.n.name is f)
             ((I))
             ((p.name is f)
              ((I))
              ((n.n.n.name is p) ((n.name is n) ((I)) ((i:))) ((i:))))))
           ((n.n.name is u)
            ((n.n.n.name is n)
             ((n.name is g) ((I)) ((p.p.name is #) ((I)) ((i:))))
             ((i:)))
            ((n.n.name is e)
             ((n.name is g)
              ((p.p.name is #)
               ((i:))
               ((n.n.n.name is n)
                ((p.p.name is l)
                 ((p.p.p.name is e) ((p.name is l) ((i:)) ((I))) ((I)))
                 ((p.p.name is g)
                  ((I))
                  ((p.name is z)
                   ((I))
                   ((p.p.name is n)
                    ((p.name is s) ((i:)) ((I)))
                    ((p.p.name is d)
                     ((p.p.p.name is e) ((i:)) ((I)))
                     ((I)))))))
                ((n.n.n.name is a)
                 ((i:))
                 ((p.p.p.name is g)
                  ((I))
                  ((p.p.name is e)
                   ((I))
                   ((p.name is n)
                    ((p.p.name is u)
                     ((p.p.p.name is a) ((I)) ((i:)))
                     ((I)))
                    ((I))))))))
              ((p.name is a)
               ((_epsilon_))
               ((p.name is #)
                ((n.n.n.name is x)
                 ((I))
                 ((n.n.n.name is f)
                  ((I))
                  ((n.n.n.name is r)
                   ((I))
                   ((n.n.n.name is s) ((I)) ((i:))))))
                ((n.name is x)
                 ((I))
                 ((p.name is o)
                  ((a:))
                  ((n.name is t)
                   ((n.n.n.name is r)
                    ((p.p.p.name is a)
                     ((I))
                     ((p.p.name is #) ((I)) ((i:))))
                    ((i:)))
                   ((p.p.name is g) ((I)) ((i:)))))))))
             ((p.name is a)
              ((n.n.name is c)
               ((I))
               ((p.p.p.name is c)
                ((I))
                ((p.p.p.name is o) ((i:)) ((_epsilon_)))))
              ((n.name is u)
               ((i:))
               ((n.name is b)
                ((n.n.name is b) ((I)) ((i:)))
                ((n.n.name is r)
                 ((n.name is r)
                  ((I))
                  ((n.name is s)
                   ((I))
                   ((p.name is h)
                    ((I))
                    ((n.n.n.name is e)
                     ((n.name is t) ((I)) ((i:)))
                     ((i:))))))
                 ((n.n.name is #)
                  ((n.name is g)
                   ((I))
                   ((n.name is l)
                    ((i:))
                    ((n.name is t)
                     ((i:))
                     ((p.p.name is u)
                      ((i:))
                      ((p.name is n)
                       ((I))
                       ((p.p.name is e)
                        ((I))
                        ((p.name is t)
                         ((p.p.p.name is l) ((i:)) ((I)))
                         ((p.name is h)
                          ((I))
                          ((p.p.p.name is u)
                           ((i:))
                           ((p.p.p.name is t)
                            ((I))
                            ((p.name is l)
                             ((i:))
                             ((p.p.p.name is l)
                              ((I))
                              ((n.name is k)
                               ((p.p.p.name is h) ((i:)) ((I)))
                               ((n.name is n)
                                ((p.p.name is r) ((I)) ((i:)))
                                ((i:))))))))))))))))
                  ((n.name is #)
                   ((i:))
                   ((n.name is l)
                    ((n.n.name is s)
                     ((i:))
                     ((n.n.n.name is o)
                      ((p.p.name is s) ((i:)) ((I)))
                      ((p.p.name is o)
                       ((p.p.p.name is r) ((I)) ((i:)))
                       ((p.p.name is i)
                        ((p.p.p.name is z) ((i:)) ((I)))
                        ((p.name is t)
                         ((n.n.name is l)
                          ((I))
                          ((p.p.p.name is #) ((i:)) ((I))))
                         ((I)))))))
                    ((n.n.name is l)
                     ((p.name is t)
                      ((i:))
                      ((n.name is f)
                       ((i:))
                       ((n.n.n.name is i)
                        ((p.p.p.name is i)
                         ((I))
                         ((n.name is g)
                          ((I))
                          ((p.p.name is #) ((I)) ((i:)))))
                        ((I)))))
                     ((n.n.n.name is #)
                      ((n.n.name is s)
                       ((n.name is s)
                        ((I))
                        ((n.name is g)
                         ((I))
                         ((p.p.name is a)
                          ((i:))
                          ((n.name is n)
                           ((i:))
                           ((n.name is t) ((i:)) ((I)))))))
                       ((I)))
                      ((n.n.n.name is a)
                       ((p.p.name is #)
                        ((I))
                        ((p.name is #)
                         ((I))
                         ((n.name is g)
                          ((I))
                          ((p.p.p.name is r)
                           ((i:))
                           ((p.name is t)
                            ((n.n.name is p)
                             ((i:))
                             ((p.p.p.name is a) ((i:)) ((I))))
                            ((p.p.name is a)
                             ((p.p.p.name is d) ((I)) ((i:)))
                             ((p.p.p.name is e)
                              ((i:))
                              ((p.p.name is i) ((i:)) ((I))))))))))
                       ((n.name is k)
                        ((n.n.name is t) ((I)) ((i:)))
                        ((n.name is z)
                         ((n.n.name is z) ((I)) ((i:)))
                         ((n.name is t)
                          ((n.n.name is h)
                           ((p.name is l)
                            ((i:))
                            ((p.p.name is #)
                             ((I))
                             ((p.name is r) ((I)) ((i:)))))
                           ((p.p.name is i)
                            ((n.n.name is s) ((i:)) ((I)))
                            ((I))))
                          ((n.n.n.name is r)
                           ((p.name is t) ((i:)) ((I)))
                           ((n.n.name is b)
                            ((p.name is t)
                             ((i:))
                             ((n.name is n)
                              ((p.p.name is #)
                               ((I))
                               ((p.name is #) ((I)) ((i:))))
                              ((I))))
                            ((n.n.n.name is i)
                             ((p.p.p.name is u)
                              ((n.n.name is t) ((i:)) ((I)))
                              ((I)))
                             ((p.p.p.name is p)
                              ((n.name is p) ((i:)) ((I)))
                              ((n.name is m)
                               ((n.n.name is s)
                                ((p.name is b) ((I)) ((i:)))
                                ((I)))
                               ((I))))))))))))))))))))))))))))))))
 (j ((j)))
 (k
  ((n.name is k)
   ((p.p.name is e)
    ((k))
    ((p.p.name is a) ((k)) ((p.p.name is i) ((k)) ((_epsilon_)))))
   ((n.name is q)
    ((_epsilon_))
    ((p.p.name is #) ((n.name is i) ((_epsilon_)) ((k))) ((k))))))
 (l
  ((n.name is l)
   ((n.n.name is o)
    ((p.p.p.name is #)
     ((_epsilon_))
     ((p.p.name is #) ((_epsilon_)) ((l))))
    ((p.p.name is v)
     ((_epsilon_))
     ((n.n.name is a)
      ((p.name is o)
       ((_epsilon_))
       ((p.p.p.name is s)
        ((_epsilon_))
        ((p.name is y)
         ((_epsilon_))
         ((p.p.p.name is b)
          ((l))
          ((p.p.name is p)
           ((_epsilon_))
           ((p.name is a)
            ((_epsilon_))
            ((p.p.name is b)
             ((l))
             ((p.name is h) ((l)) ((p.name is e) ((l)) ((_epsilon_)))))))))))
      ((p.p.name is #)
       ((_epsilon_))
       ((p.name is a)
        ((p.p.p.name is r)
         ((_epsilon_))
         ((p.p.name is b)
          ((_epsilon_))
          ((p.p.p.name is f)
           ((l))
           ((n.n.name is i)
            ((p.p.p.name is s) ((_epsilon_)) ((l)))
            ((p.p.p.name is e)
             ((_epsilon_))
             ((n.n.name is e)
              ((p.p.name is r)
               ((p.p.p.name is p)
                ((_epsilon_))
                ((p.p.p.name is o) ((_epsilon_)) ((l))))
               ((p.p.p.name is s)
                ((p.p.name is t) ((_epsilon_)) ((l)))
                ((p.p.name is w)
                 ((_epsilon_))
                 ((p.p.p.name is m)
                  ((_epsilon_))
                  ((p.p.p.name is #)
                   ((p.p.name is g) ((_epsilon_)) ((l)))
                   ((p.p.name is n)
                    ((p.p.p.name is h) ((_epsilon_)) ((l)))
                    ((_epsilon_))))))))
              ((p.p.p.name is n)
               ((n.n.name is t) ((l)) ((_epsilon_)))
               ((p.p.name is n)
                ((n.n.name is t)
                 ((_epsilon_))
                 ((n.n.name is s) ((_epsilon_)) ((l))))
                ((p.p.p.name is #)
                 ((n.n.name is s) ((l)) ((_epsilon_)))
                 ((_epsilon_)))))))))))
        ((p.p.p.name is g)
         ((p.name is i)
          ((n.n.name is i) ((_epsilon_)) ((l)))
          ((p.p.name is r) ((_epsilon_)) ((l))))
         ((n.n.name is e)
          ((p.name is u)
           ((p.p.p.name is h) ((l)) ((_epsilon_)))
           ((p.p.name is b)
            ((l))
            ((p.p.p.name is n)
             ((p.p.name is t)
              ((l))
              ((p.name is o) ((l)) ((_epsilon_))))
             ((p.p.p.name is p)
              ((l))
              ((p.name is i)
               ((p.p.name is w)
                ((_epsilon_))
                ((p.p.name is d)
                 ((l))
                 ((p.p.name is a) ((l)) ((_epsilon_)))))
               ((_epsilon_)))))))
          ((n.n.name is i)
           ((p.p.name is u)
            ((l))
            ((p.name is u)
             ((p.p.p.name is h) ((l)) ((_epsilon_)))
             ((p.p.name is w)
              ((_epsilon_))
              ((p.p.p.name is e)
               ((_epsilon_))
               ((p.name is i)
                ((p.p.name is a) ((l)) ((_epsilon_)))
                ((_epsilon_)))))))
           ((_epsilon_))))))))))
   ((p.name is l)
    ((p.p.name is i)
     ((p.p.p.name is a)
      ((j))
      ((n.name is a)
       ((n.n.name is n) ((j)) ((n.n.name is r) ((j)) ((l))))
       ((p.p.p.name is u)
        ((j))
        ((p.p.p.name is r)
         ((l))
         ((p.p.p.name is d) ((_epsilon_)) ((l)))))))
     ((p.p.p.name is v)
      ((n.name is m) ((n.n.name is a) ((_epsilon_)) ((l))) ((l)))
      ((p.p.p.name is #)
       ((l))
       ((p.p.name is a)
        ((p.p.p.name is b)
         ((l))
         ((n.n.name is l)
          ((_epsilon_))
          ((n.n.name is g)
           ((_epsilon_))
           ((n.name is a)
            ((l))
            ((n.n.name is r)
             ((p.p.p.name is f) ((_epsilon_)) ((l)))
             ((n.name is e)
              ((n.n.name is n)
               ((p.p.p.name is n) ((_epsilon_)) ((l)))
               ((l)))
              ((n.n.name is o)
               ((_epsilon_))
               ((n.n.name is u)
                ((_epsilon_))
                ((n.name is u)
                 ((l))
                 ((n.n.name is n)
                  ((l))
                  ((p.p.p.name is n)
                   ((l))
                   ((n.name is f)
                    ((l))
                    ((n.n.name is a)
                     ((l))
                     ((p.p.p.name is w)
                      ((l))
                      ((n.n.name is e)
                       ((l))
                       ((p.p.p.name is r)
                        ((l))
                        ((n.n.name is p)
                         ((l))
                         ((n.n.name is c)
                          ((l))
                          ((p.p.p.name is f)
                           ((l))
                           ((n.n.name is #)
                            ((n.name is s) ((_epsilon_)) ((l)))
                            ((l))))))))))))))))))))))
        ((p.p.p.name is b)
         ((p.p.name is u)
          ((l))
          ((n.n.name is r)
           ((_epsilon_))
           ((n.n.name is e)
            ((_epsilon_))
            ((n.n.name is n) ((_epsilon_)) ((l))))))
         ((p.p.name is u)
          ((p.p.p.name is r) ((_epsilon_)) ((l)))
          ((n.name is e)
           ((p.p.p.name is u)
            ((l))
            ((n.n.name is k)
             ((p.p.p.name is k) ((l)) ((_epsilon_)))
             ((p.p.p.name is k)
              ((l))
              ((p.p.p.name is w)
               ((l))
               ((p.p.p.name is h)
                ((l))
                ((p.p.p.name is n)
                 ((l))
                 ((p.p.p.name is z)
                  ((l))
                  ((p.p.name is o)
                   ((n.n.name is r)
                    ((l))
                    ((p.p.p.name is t) ((_epsilon_)) ((l))))
                   ((n.n.name is m)
                    ((l))
                    ((n.n.name is t)
                     ((p.p.p.name is t) ((l)) ((_epsilon_)))
                     ((l))))))))))))
           ((n.name is a)
            ((l))
            ((n.n.name is s)
             ((l))
             ((n.n.name is a)
              ((l))
              ((n.n.name is e)
               ((l))
               ((p.p.p.name is s)
                ((l))
                ((n.name is w)
                 ((l))
                 ((n.n.name is r)
                  ((l))
                  ((n.n.name is l)
                   ((l))
                   ((n.name is u)
                    ((l))
                    ((p.p.p.name is t)
                     ((l))
                     ((p.p.p.name is n)
                      ((l))
                      ((p.p.p.name is m)
                       ((l))
                       ((n.n.name is u)
                        ((l))
                        ((n.n.name is #)
                         ((l))
                         ((p.p.p.name is k)
                          ((l))
                          ((n.n.name is o)
                           ((l))
                           ((p.p.p.name is o)
                            ((l))
                            ((n.n.name is n)
                             ((l))
                             ((n.n.name is p)
                              ((l))
                              ((n.name is s)
                               ((l))
                               ((p.p.name is e)
                                ((p.p.p.name is u) ((_epsilon_)) ((l)))
                                ((l))))))))))))))))))))))))))))))
    ((p.p.name is a)
     ((p.name is i)
      ((_epsilon_))
      ((p.p.p.name is s)
       ((n.name is e)
        ((l))
        ((p.name is a) ((l)) ((n.name is a) ((l)) ((_epsilon_)))))
       ((l))))
     ((l))))))
 (m ((n.name is m) ((_epsilon_)) ((m))))
 (n
  ((n.name is g)
   ((p.p.name is #)
    ((p.name is e)
     ((n.n.name is a) ((_epsilon_)) ((N)))
     ((n.n.name is e)
      ((n))
      ((p.name is u)
       ((n))
       ((n.n.name is r)
        ((n))
        ((n.n.name is a)
         ((n))
         ((n.n.n.name is o)
          ((N))
          ((n.n.name is s)
           ((N))
           ((n.n.n.name is e) ((N)) ((n.n.name is l) ((N)) ((n)))))))))))
    ((p.p.name is e)
     ((n))
     ((p.name is u)
      ((p.p.name is j)
       ((n.n.name is f) ((N)) ((n.n.n.name is n) ((n)) ((N))))
       ((N)))
      ((p.p.name is a)
       ((N))
       ((p.name is e)
        ((p.p.name is u)
         ((N))
         ((p.p.name is r)
          ((N))
          ((n.n.name is t)
           ((N))
           ((n.n.n.name is t)
            ((N))
            ((n.n.n.name is i)
             ((N))
             ((n.n.name is e)
              ((n.n.n.name is n)
               ((N))
               ((n.n.n.name is l)
                ((p.p.name is t) ((N)) ((n)))
                ((p.p.name is s) ((n.n.n.name is r) ((N)) ((n))) ((n)))))
              ((n))))))))
        ((n.n.name is i)
         ((n.n.n.name is e)
          ((p.name is a) ((_epsilon_)) ((N)))
          ((n.n.n.name is n) ((n)) ((N))))
         ((p.p.name is n)
          ((p.name is a) ((n)) ((N)))
          ((p.p.name is h)
           ((p.name is i) ((n.n.n.name is #) ((N)) ((n))) ((N)))
           ((p.name is i)
            ((N))
            ((p.name is a)
             ((n.n.n.name is h)
              ((n))
              ((n.n.name is r)
               ((n.n.n.name is i) ((n)) ((N)))
               ((n.n.name is e)
                ((p.p.name is g)
                 ((N))
                 ((p.p.name is f)
                  ((N))
                  ((n.n.n.name is n)
                   ((N))
                   ((p.p.name is l)
                    ((N))
                    ((p.p.name is m)
                     ((N))
                     ((n.n.n.name is #)
                      ((N))
                      ((p.p.name is v)
                       ((N))
                       ((p.p.name is t)
                        ((n))
                        ((n.n.n.name is s)
                         ((N))
                         ((n.n.n.name is r)
                          ((N))
                          ((p.p.name is r) ((N)) ((n)))))))))))))
                ((N)))))
             ((p.p.name is m)
              ((N))
              ((p.p.name is k) ((n)) ((p.name is o) ((N)) ((n)))))))))))))))
   ((n.name is n)
    ((n.n.name is a)
     ((p.name is u)
      ((n))
      ((n.n.n.name is e)
       ((n))
       ((n.n.n.name is h)
        ((n))
        ((p.name is e) ((n)) ((p.name is a) ((n)) ((_epsilon_)))))))
     ((p.p.name is e)
      ((n))
      ((p.p.name is #)
       ((p.name is i) ((_epsilon_)) ((n)))
       ((p.name is o)
        ((_epsilon_))
        ((p.p.name is g)
         ((p.name is e) ((n)) ((_epsilon_)))
         ((n.n.n.name is h)
          ((n.n.name is e) ((n)) ((_epsilon_)))
          ((p.name is e)
           ((n.n.name is #) ((n)) ((_epsilon_)))
           ((_epsilon_)))))))))
    ((n.name is k)
     ((p.p.name is #)
      ((n.n.name is e)
       ((p.name is u) ((n)) ((N)))
       ((n.n.name is o)
        ((n))
        ((n.n.name is l)
         ((n))
         ((n.n.name is r)
          ((n))
          ((n.n.name is u)
           ((n))
           ((n.n.name is n)
            ((n))
            ((n.n.n.name is r) ((n)) ((n.n.name is a) ((n)) ((N))))))))))
      ((p.p.name is e)
       ((n))
       ((n.n.name is e)
        ((n.n.n.name is h) ((n)) ((N)))
        ((n.n.name is t)
         ((N))
         ((n.n.name is s)
          ((N))
          ((p.p.name is d)
           ((N))
           ((p.name is a)
            ((n.n.name is a) ((n)) ((N)))
            ((p.name is i)
             ((N))
             ((p.name is u)
              ((N))
              ((p.p.name is l)
               ((N))
               ((p.p.name is a)
                ((p.name is e) ((N)) ((n)))
                ((p.p.name is w)
                 ((N))
                 ((p.p.name is s)
                  ((p.name is e)
                   ((n.n.name is a)
                    ((n))
                    ((n.n.n.name is a) ((n)) ((N))))
                   ((n)))
                  ((n)))))))))))))))
     ((n.name is c)
      ((p.name is a)
       ((n.n.n.name is o) ((N)) ((_epsilon_)))
       ((p.p.name is n) ((_epsilon_)) ((n))))
      ((p.name is n)
       ((p.p.name is o)
        ((n.n.n.name is #)
         ((n))
         ((n.n.name is n)
          ((n.n.n.name is e)
           ((n))
           ((n.n.n.name is h)
            ((n))
            ((n.n.n.name is k) ((_epsilon_)) ((n)))))
          ((n))))
        ((p.p.name is i)
         ((n))
         ((n.n.n.name is l)
          ((n.name is e) ((n)) ((_epsilon_)))
          ((n.name is t)
           ((n))
           ((n.n.n.name is c)
            ((n.name is i) ((n)) ((n.name is l) ((n)) ((_epsilon_))))
            ((n)))))))
       ((p.name is o)
        ((n.n.name is #)
         ((n))
         ((p.p.name is l)
          ((n.name is f) ((_epsilon_)) ((n)))
          ((p.p.name is s)
           ((n.name is #)
            ((_epsilon_))
            ((n.n.name is u) ((_epsilon_)) ((n))))
           ((n)))))
        ((p.name is g)
         ((p.p.name is e)
          ((n))
          ((n.n.name is s)
           ((n))
           ((n.name is o)
            ((n.n.name is m)
             ((n))
             ((n.n.n.name is a) ((n)) ((_epsilon_))))
            ((n.n.name is r)
             ((n))
             ((n.name is u)
              ((n))
              ((n.name is a)
               ((n))
               ((p.p.name is i)
                ((n))
                ((p.p.name is u)
                 ((n))
                 ((n.n.n.name is i)
                  ((n))
                  ((n.name is e) ((_epsilon_)) ((n))))))))))))
         ((n.name is t)
          ((p.p.name is m)
           ((n))
           ((p.name is a)
            ((p.p.name is g)
             ((n))
             ((p.p.name is l)
              ((n.n.name is e)
               ((n.n.n.name is s) ((_epsilon_)) ((n)))
               ((n)))
              ((p.p.name is v)
               ((n.n.name is e) ((n)) ((_epsilon_)))
               ((n)))))
            ((n))))
          ((n.n.n.name is o)
           ((p.p.name is p) ((p.name is e) ((_epsilon_)) ((n))) ((n)))
           ((n.n.name is o)
            ((p.p.name is b) ((n.name is d) ((_epsilon_)) ((n))) ((n)))
            ((n)))))))))))))
 (o
  ((n.name is e)
   ((n.n.n.name is e)
    ((2:))
    ((n.n.n.name is i)
     ((p.name is p) ((o:)) ((2:)))
     ((n.n.name is h)
      ((2:))
      ((n.n.name is p)
       ((9))
       ((p.name is f)
        ((n.n.name is r) ((9)) ((p.p.name is #) ((2:)) ((9))))
        ((n.n.name is g)
         ((2:))
         ((n.n.n.name is n)
          ((9))
          ((n.n.n.name is k)
           ((9))
           ((p.name is w)
            ((p.p.p.name is c) ((n.n.name is r) ((2:)) ((9))) ((9)))
            ((n.n.name is n)
             ((p.p.name is #) ((p.name is r) ((9)) ((2:))) ((2:)))
             ((n.n.n.name is f)
              ((n.n.name is f) ((9)) ((2:)))
              ((n.n.n.name is z)
               ((9))
               ((p.name is k)
                ((n.n.n.name is p)
                 ((9))
                 ((n.n.name is r)
                  ((n.n.n.name is b) ((9)) ((2:)))
                  ((9))))
                ((p.p.name is s)
                 ((n.n.name is t)
                  ((9))
                  ((p.p.p.name is u)
                   ((p.name is l) ((2:)) ((9)))
                   ((2:))))
                 ((p.name is h)
                  ((p.p.p.name is s)
                   ((n.n.name is s)
                    ((9))
                    ((n.n.n.name is l) ((9)) ((2:))))
                   ((n.n.name is l) ((9)) ((2:))))
                  ((n.n.name is c)
                   ((9))
                   ((n.n.name is r)
                    ((p.p.name is f)
                     ((2:))
                     ((p.name is m)
                      ((9))
                      ((n.n.n.name is g)
                       ((9))
                       ((p.name is b)
                        ((9))
                        ((p.name is d)
                         ((9))
                         ((n.n.n.name is d)
                          ((9))
                          ((p.p.name is e) ((9)) ((2:)))))))))
                    ((p.name is g)
                     ((9))
                     ((n.n.n.name is m)
                      ((9))
                      ((p.p.name is g)
                       ((2:))
                       ((n.n.n.name is r)
                        ((2:))
                        ((n.n.n.name is #)
                         ((2:))
                         ((p.name is #)
                          ((2:))
                          ((n.n.name is l)
                           ((p.name is n) ((2:)) ((9)))
                           ((n.n.name is s)
                            ((n.n.n.name is s)
                             ((p.p.p.name is n) ((2:)) ((9)))
                             ((n.n.n.name is c)
                              ((9))
                              ((p.p.name is f) ((9)) ((2:)))))
                            ((n.n.n.name is t)
                             ((n.n.name is t) ((9)) ((2:)))
                             ((2:))))))))))))))))))))))))))))
   ((n.n.name is e)
    ((n.name is x)
     ((O))
     ((p.p.name is o)
      ((n.name is g)
       ((o:))
       ((p.name is n) ((o:)) ((p.p.p.name is r) ((O)) ((o:)))))
      ((p.p.name is l)
       ((p.p.p.name is i) ((n.name is s) ((o:)) ((_epsilon_))) ((o:)))
       ((o:)))))
    ((n.n.name is i)
     ((n.name is x) ((O)) ((n.name is u) ((_epsilon_)) ((o:))))
     ((n.n.name is a)
      ((n.name is r)
       ((p.p.name is s) ((p.name is p) ((o:)) ((O))) ((o:)))
       ((o:)))
      ((n.name is h)
       ((o:))
       ((n.n.name is o)
        ((p.p.name is k)
         ((n.name is m) ((O)) ((o:)))
         ((n.name is b) ((O)) ((o:))))
        ((n.name is u)
         ((_epsilon_))
         ((p.name is k)
          ((n.name is n)
           ((O))
           ((n.name is m)
            ((O))
            ((n.name is o)
             ((o:))
             ((n.n.name is u)
              ((o:))
              ((n.name is a)
               ((o:))
               ((n.n.name is #)
                ((o:))
                ((n.n.name is s)
                 ((o:))
                 ((n.name is #)
                  ((o:))
                  ((n.n.n.name is i)
                   ((n.name is p) ((o:)) ((O)))
                   ((n.n.name is c)
                    ((o:))
                    ((n.n.name is r)
                     ((n.name is r) ((O)) ((o:)))
                     ((O)))))))))))))
          ((n.name is l)
           ((n.n.name is l)
            ((O))
            ((n.n.name is u)
             ((o:))
             ((n.n.name is y)
              ((o:))
              ((n.n.name is b)
               ((o:))
               ((n.n.name is t)
                ((p.name is h) ((o:)) ((p.p.name is m) ((o:)) ((O))))
                ((n.n.name is s)
                 ((p.name is p) ((O)) ((o:)))
                 ((p.p.name is o)
                  ((o:))
                  ((p.p.p.name is y)
                   ((o:))
                   ((n.n.name is #) ((o:)) ((O)))))))))))
           ((p.name is v)
            ((n.n.name is d)
             ((n.n.n.name is e) ((O)) ((o:)))
             ((n.n.name is n)
              ((n.n.n.name is u) ((O)) ((o:)))
              ((n.name is r) ((o:)) ((n.n.n.name is e) ((o:)) ((O))))))
            ((n.name is r)
             ((p.name is l)
              ((p.p.name is #)
               ((O))
               ((n.n.n.name is e)
                ((o:))
                ((p.p.name is f) ((o:)) ((O)))))
              ((n.n.name is s)
               ((p.name is f)
                ((O))
                ((p.p.name is e)
                 ((o:))
                 ((p.p.name is m)
                  ((o:))
                  ((p.name is b)
                   ((O))
                   ((p.name is m)
                    ((O))
                    ((p.name is t)
                     ((O))
                     ((n.n.n.name is #)
                      ((O))
                      ((p.p.name is #) ((O)) ((o:))))))))))
               ((n.n.name is v)
                ((o:))
                ((n.n.name is l)
                 ((o:))
                 ((n.n.name is #)
                  ((p.name is t)
                   ((O))
                   ((p.p.p.name is e) ((O)) ((o:))))
                  ((p.name is t)
                   ((O))
                   ((p.p.name is m)
                    ((n.n.name is t)
                     ((O))
                     ((p.p.p.name is u) ((O)) ((o:))))
                    ((O)))))))))
             ((n.n.n.name is e)
              ((n.name is o)
               ((_epsilon_))
               ((n.n.name is l)
                ((o:))
                ((n.name is i)
                 ((o:))
                 ((n.name is g)
                  ((n.n.name is g) ((O)) ((o:)))
                  ((n.name is s)
                   ((p.name is t)
                    ((o:))
                    ((n.n.name is s)
                     ((p.p.name is g)
                      ((o:))
                      ((p.p.p.name is c)
                       ((O))
                       ((p.name is r)
                        ((O))
                        ((p.p.name is e)
                         ((O))
                         ((p.name is g)
                          ((O))
                          ((p.name is p)
                           ((O))
                           ((p.name is b)
                            ((O))
                            ((p.p.p.name is r)
                             ((O))
                             ((p.p.p.name is s)
                              ((O))
                              ((p.p.name is f) ((O)) ((o:))))))))))))
                     ((p.p.name is f)
                      ((O))
                      ((p.name is l)
                       ((o:))
                       ((p.p.name is #)
                        ((O))
                        ((p.name is n)
                         ((O))
                         ((n.n.name is t)
                          ((p.p.name is m)
                           ((o:))
                           ((p.name is p)
                            ((O))
                            ((p.p.name is p) ((o:)) ((O)))))
                          ((o:)))))))))
                   ((n.n.name is w)
                    ((o:))
                    ((n.n.name is g)
                     ((o:))
                     ((n.n.name is h)
                      ((n.name is c)
                       ((p.name is h) ((o:)) ((O)))
                       ((o:)))
                      ((n.name is b)
                       ((p.name is #)
                        ((O))
                        ((p.name is n)
                         ((O))
                         ((n.n.name is b)
                          ((O))
                          ((n.n.name is t)
                           ((o:))
                           ((n.n.name is n) ((o:)) ((O)))))))
                       ((n.n.name is s)
                        ((n.name is t) ((o:)) ((O)))
                        ((n.name is n)
                         ((n.n.name is t)
                          ((p.name is t) ((o:)) ((O)))
                          ((p.name is m) ((o:)) ((O))))
                         ((n.name is a)
                          ((o:))
                          ((n.name is d)
                           ((n.n.name is d) ((O)) ((o:)))
                           ((p.p.p.name is s)
                            ((n.name is m) ((o:)) ((O)))
                            ((p.p.name is a)
                             ((n.name is t) ((O)) ((o:)))
                             ((p.p.p.name is f)
                              ((O))
                              ((n.name is k)
                               ((O))
                               ((p.name is h)
                                ((O))
                                ((n.name is t)
                                 ((n.n.name is t)
                                  ((O))
                                  ((p.p.name is #) ((o:)) ((O))))
                                 ((O)))))))))))))))))))))
              ((p.name is i)
               ((o:))
               ((n.name is o)
                ((p.name is m)
                 ((_epsilon_))
                 ((p.name is b) ((_epsilon_)) ((o:))))
                ((n.n.name is r)
                 ((o:))
                 ((n.n.name is h)
                  ((p.name is h) ((o:)) ((n.name is c) ((O)) ((o:))))
                  ((n.name is c)
                   ((O))
                   ((n.n.n.name is i)
                    ((n.n.name is c)
                     ((o~:))
                     ((n.n.name is l)
                      ((o:))
                      ((n.name is a)
                       ((o:))
                       ((p.p.name is #)
                        ((p.name is l)
                         ((n.name is s) ((o:)) ((o~:)))
                         ((p.name is t) ((o:)) ((O))))
                        ((p.name is r)
                         ((p.p.name is f)
                          ((O))
                          ((n.name is t)
                           ((O))
                           ((p.p.p.name is #)
                            ((o:))
                            ((p.p.name is e) ((o:)) ((O))))))
                         ((O)))))))
                    ((n.n.name is f)
                     ((n.name is n)
                      ((p.p.name is a) ((o~:)) ((o:)))
                      ((n.name is t)
                       ((o:))
                       ((p.name is l)
                        ((p.p.name is k) ((O)) ((o:)))
                        ((O)))))
                     ((n.n.name is t)
                      ((n.n.n.name is #)
                       ((n.name is t)
                        ((O))
                        ((n.name is s) ((O)) ((o:))))
                       ((p.p.name is t)
                        ((n.name is s) ((o:)) ((O)))
                        ((p.name is m)
                         ((o:))
                         ((p.name is t)
                          ((o:))
                          ((p.name is n)
                           ((n.n.n.name is a) ((o:)) ((O)))
                           ((O)))))))
                      ((n.name is n)
                       ((n.n.name is n)
                        ((O))
                        ((n.n.n.name is m)
                         ((o:))
                         ((n.n.name is g)
                          ((O))
                          ((p.name is n)
                           ((n.n.name is c) ((o~:)) ((O)))
                           ((p.name is s)
                            ((p.p.p.name is a) ((o~:)) ((O)))
                            ((p.name is l)
                             ((O))
                             ((p.p.p.name is d)
                              ((O))
                              ((p.p.p.name is s)
                               ((o:))
                               ((p.p.name is p)
                                ((o:))
                                ((p.p.name is o)
                                 ((o:))
                                 ((n.n.n.name is s)
                                  ((o:))
                                  ((p.p.name is h)
                                   ((o:))
                                   ((p.name is t)
                                    ((n.n.n.name is o)
                                     ((o:))
                                     ((p.p.name is #)
                                      ((o:))
                                      ((p.p.p.name is b) ((O)) ((o:)))))
                                    ((n.n.n.name is t)
                                     ((O))
                                     ((p.name is m)
                                      ((n.n.n.name is a)
                                       ((O))
                                       ((n.n.name is d) ((o:)) ((O))))
                                      ((p.p.p.name is #)
                                       ((o:))
                                       ((n.n.n.name is #)
                                        ((p.name is r) ((O)) ((o:)))
                                        ((O)))))))))))))))))))
                       ((n.n.name is p)
                        ((n.name is p)
                         ((O))
                         ((p.name is h)
                          ((O))
                          ((p.name is p) ((O)) ((o:)))))
                        ((p.name is #)
                         ((n.n.n.name is t)
                          ((O))
                          ((n.n.n.name is u)
                           ((O))
                           ((n.name is b)
                            ((O))
                            ((n.name is x) ((O)) ((o:))))))
                         ((n.n.name is c)
                          ((O))
                          ((n.n.name is z)
                           ((n.n.n.name is u) ((o:)) ((O)))
                           ((n.name is m)
                            ((n.n.name is b)
                             ((O))
                             ((n.n.name is m) ((O)) ((o:))))
                            ((n.name is s)
                             ((p.p.name is g)
                              ((o:))
                              ((n.n.name is s)
                               ((p.name is t)
                                ((o:))
                                ((p.name is l)
                                 ((p.p.name is #)
                                  ((o:))
                                  ((p.p.p.name is #) ((o:)) ((O))))
                                 ((O))))
                               ((p.name is l)
                                ((o:))
                                ((p.p.p.name is e)
                                 ((n.n.name is k) ((O)) ((o:)))
                                 ((o:))))))
                             ((n.name is x)
                              ((O))
                              ((n.n.name is m)
                               ((p.name is t) ((o:)) ((O)))
                               ((p.name is m)
                                ((n.n.name is u)
                                 ((o:))
                                 ((p.p.name is #) ((O)) ((o:))))
                                ((n.n.name is b)
                                 ((n.name is b) ((O)) ((o:)))
                                 ((p.p.name is c)
                                  ((n.name is b)
                                   ((o:))
                                   ((p.p.p.name is y) ((o:)) ((O))))
                                  ((p.name is p)
                                   ((n.name is p) ((o:)) ((O)))
                                   ((o:))))))))))))))))))))))))))))))))))))
 (p
  ((n.name is f)
   ((pf))
   ((n.name is p) ((_epsilon_)) ((n.name is h) ((f)) ((p))))))
 (q ((k)))
 (r
  ((n.name is r)
   ((p.name is e)
    ((p.p.name is h)
     ((p.p.p.name is e)
      ((_epsilon_))
      ((p.p.p.name is t)
       ((_epsilon_))
       ((p.p.p.name is #)
        ((_epsilon_))
        ((n.n.n.name is i) ((R)) ((_epsilon_))))))
     ((p.p.name is p)
      ((_epsilon_))
      ((p.p.name is v)
       ((R))
       ((p.p.p.name is e)
        ((R))
        ((n.n.n.name is s)
         ((p.p.name is z)
          ((R))
          ((p.p.p.name is #)
           ((_epsilon_))
           ((p.p.name is u)
            ((_epsilon_))
            ((p.p.p.name is t)
             ((_epsilon_))
             ((p.p.name is a) ((_epsilon_)) ((R)))))))
         ((p.p.p.name is d)
          ((_epsilon_))
          ((p.p.p.name is #)
           ((p.p.name is z) ((R)) ((_epsilon_)))
           ((p.p.p.name is r)
            ((_epsilon_))
            ((p.p.p.name is t)
             ((p.p.name is t) ((R)) ((_epsilon_)))
             ((n.n.n.name is n)
              ((p.p.name is t) ((_epsilon_)) ((R)))
              ((R))))))))))))
    ((p.p.name is v)
     ((R))
     ((p.p.p.name is #)
      ((_epsilon_))
      ((p.p.p.name is s)
       ((_epsilon_))
       ((p.p.name is t)
        ((p.name is a) ((_epsilon_)) ((R)))
        ((p.p.p.name is g)
         ((R))
         ((p.name is h)
          ((R))
          ((p.p.p.name is e)
           ((p.p.name is r)
            ((_epsilon_))
            ((n.n.n.name is e) ((R)) ((_epsilon_))))
           ((n.n.n.name is t)
            ((p.name is a)
             ((_epsilon_))
             ((p.p.name is #) ((_epsilon_)) ((R))))
            ((p.p.p.name is i) ((R)) ((_epsilon_))))))))))))
   ((R))))
 (s
  ((n.name is c)
   ((p.name is s) ((p.p.name is t) ((_epsilon_)) ((s))) ((_epsilon_)))
   ((n.name is s)
    ((n.n.name is p)
     ((p.p.p.name is h)
      ((_epsilon_))
      ((p.p.name is a)
       ((s))
       ((n.n.n.name is e)
        ((s))
        ((p.p.p.name is e)
         ((s))
         ((n.n.n.name is r)
          ((s))
          ((p.p.p.name is r) ((s)) ((_epsilon_))))))))
     ((n.n.name is t)
      ((p.p.name is a)
       ((p.name is e) ((_epsilon_)) ((s)))
       ((p.p.name is n)
        ((s))
        ((n.n.n.name is #)
         ((_epsilon_))
         ((n.n.n.name is e)
          ((p.name is s) ((s)) ((p.name is o) ((s)) ((_epsilon_))))
          ((n.n.n.name is s)
           ((_epsilon_))
           ((p.name is i)
            ((p.p.p.name is r) ((s)) ((_epsilon_)))
            ((p.name is t)
             ((_epsilon_))
             ((p.name is u)
              ((_epsilon_))
              ((p.p.name is r) ((_epsilon_)) ((s)))))))))))
      ((n.n.n.name is c)
       ((n.n.name is s)
        ((_epsilon_))
        ((p.name is t)
         ((_epsilon_))
         ((n.n.name is a) ((_epsilon_)) ((s)))))
       ((n.n.name is a)
        ((p.p.name is a)
         ((s))
         ((p.name is g) ((s)) ((p.p.name is e) ((s)) ((_epsilon_)))))
        ((p.name is g)
         ((n.n.name is c) ((_epsilon_)) ((s)))
         ((p.name is n)
          ((n.n.name is c) ((_epsilon_)) ((s)))
          ((p.name is u)
           ((n.n.name is o)
            ((s))
            ((n.n.n.name is t)
             ((p.p.name is a) ((s)) ((_epsilon_)))
             ((p.p.name is a)
              ((n.n.n.name is e)
               ((s))
               ((n.n.name is e)
                ((n.n.n.name is r)
                 ((_epsilon_))
                 ((n.n.n.name is n) ((_epsilon_)) ((s))))
                ((_epsilon_))))
              ((_epsilon_)))))
           ((p.p.name is #)
            ((p.name is e)
             ((n.n.name is e) ((_epsilon_)) ((s)))
             ((_epsilon_)))
            ((_epsilon_))))))))))
    ((n.name is t)
     ((p.name is #)
      ((S))
      ((n.n.name is #)
       ((p.name is t)
        ((_epsilon_))
        ((p.name is d)
         ((_epsilon_))
         ((p.p.p.name is s)
          ((p.p.name is c) ((_epsilon_)) ((s)))
          ((s)))))
       ((p.p.p.name is s)
        ((p.p.name is c)
         ((_epsilon_))
         ((n.n.name is e)
          ((n.n.n.name is l)
           ((S))
           ((p.name is u)
            ((s))
            ((p.p.name is e)
             ((p.name is n) ((s)) ((p.name is r) ((s)) ((S))))
             ((s)))))
          ((n.n.n.name is g)
           ((s))
           ((n.n.n.name is s)
            ((s))
            ((n.n.name is s)
             ((s))
             ((p.name is b)
              ((s))
              ((n.n.n.name is u)
               ((s))
               ((n.n.name is a)
                ((S))
                ((p.p.name is g)
                 ((S))
                 ((p.p.name is e)
                  ((S))
                  ((p.name is n)
                   ((s))
                   ((p.p.name is u)
                    ((S))
                    ((n.n.n.name is m)
                     ((S))
                     ((n.n.name is i) ((s)) ((S))))))))))))))))
        ((n.n.name is e)
         ((n.n.n.name is l)
          ((p.name is a)
           ((s))
           ((p.p.p.name is u)
            ((p.name is n) ((s)) ((S)))
            ((p.p.name is e)
             ((S))
             ((p.name is i)
              ((s))
              ((p.p.name is n)
               ((p.name is e) ((s)) ((S)))
               ((p.p.p.name is r)
                ((p.name is e) ((p.p.name is g) ((S)) ((s))) ((S)))
                ((p.name is r)
                 ((p.p.p.name is v)
                  ((S))
                  ((p.p.p.name is d) ((S)) ((s))))
                 ((p.name is e)
                  ((S))
                  ((p.p.name is u)
                   ((S))
                   ((p.p.p.name is e)
                    ((S))
                    ((p.p.name is a)
                     ((S))
                     ((p.p.p.name is t)
                      ((S))
                      ((p.name is s)
                       ((S))
                       ((p.name is t)
                        ((S))
                        ((p.p.name is c)
                         ((S))
                         ((p.p.name is z) ((S)) ((s))))))))))))))))))
          ((n.n.n.name is h)
           ((S))
           ((n.n.n.name is i)
            ((p.name is t)
             ((S))
             ((p.name is u) ((p.p.p.name is #) ((s)) ((S))) ((S))))
            ((n.n.n.name is c)
             ((p.p.p.name is i) ((s)) ((S)))
             ((n.n.n.name is u)
              ((p.p.name is b) ((s)) ((S)))
              ((p.p.p.name is #)
               ((p.p.name is u) ((S)) ((p.name is b) ((S)) ((s))))
               ((n.n.n.name is r)
                ((p.name is r)
                 ((p.p.p.name is b)
                  ((s))
                  ((p.p.name is e) ((s)) ((S))))
                 ((s)))
                ((s)))))))))
         ((n.n.name is a)
          ((n.n.n.name is e)
           ((p.p.name is j) ((s)) ((S)))
           ((p.p.name is r)
            ((p.name is t) ((S)) ((s)))
            ((n.n.n.name is g)
             ((p.name is t) ((_epsilon_)) ((s)))
             ((p.name is o)
              ((s))
              ((p.name is a)
               ((s))
               ((p.p.p.name is #)
                ((p.p.name is t)
                 ((s))
                 ((p.name is k)
                  ((s))
                  ((p.name is u)
                   ((p.p.name is a) ((s)) ((S)))
                   ((p.p.name is i)
                    ((n.n.n.name is l) ((s)) ((S)))
                    ((p.p.name is a)
                     ((S))
                     ((p.p.name is g)
                      ((S))
                      ((p.p.name is b)
                       ((S))
                       ((p.name is e)
                        ((s))
                        ((p.p.name is u)
                         ((S))
                         ((p.p.name is e) ((S)) ((s))))))))))))
                ((p.p.name is o)
                 ((p.name is n) ((s)) ((S)))
                 ((p.name is g)
                  ((s))
                  ((p.p.name is t)
                   ((p.name is e) ((s)) ((S)))
                   ((n.n.n.name is u)
                    ((p.p.name is e) ((S)) ((p.name is u) ((s)) ((S))))
                    ((S))))))))))))
          ((p.name is i)
           ((p.p.p.name is b)
            ((S))
            ((p.p.p.name is w) ((n.n.n.name is e) ((S)) ((s))) ((s))))
           ((n.n.name is o)
            ((p.p.name is p)
             ((s))
             ((n.n.n.name is l)
              ((s))
              ((p.name is u) ((p.p.name is z) ((S)) ((s))) ((S)))))
            ((n.n.name is u)
             ((p.name is o)
              ((s))
              ((p.name is a)
               ((s))
               ((p.p.p.name is c)
                ((S))
                ((n.n.n.name is n)
                 ((p.p.name is u)
                  ((s))
                  ((p.name is s) ((S)) ((p.p.p.name is i) ((s)) ((S)))))
                 ((p.name is h)
                  ((n.n.n.name is e) ((S)) ((s)))
                  ((p.name is r)
                   ((S))
                   ((p.p.name is g)
                    ((S))
                    ((p.p.p.name is a)
                     ((S))
                     ((p.p.p.name is e)
                      ((S))
                      ((p.name is k)
                       ((s))
                       ((p.p.p.name is b)
                        ((p.name is n) ((s)) ((S)))
                        ((p.name is n)
                         ((S))
                         ((p.p.p.name is r)
                          ((s))
                          ((p.name is u)
                           ((p.p.name is a) ((s)) ((S)))
                           ((S))))))))))))))))
             ((n.n.name is r)
              ((p.name is u)
               ((p.p.name is z) ((S)) ((s)))
               ((n.n.n.name is u)
                ((p.p.name is u)
                 ((S))
                 ((p.name is n)
                  ((s))
                  ((p.name is b) ((s)) ((p.p.name is d) ((s)) ((S))))))
                ((p.p.name is e)
                 ((S))
                 ((p.name is t)
                  ((p.p.name is f)
                   ((_epsilon_))
                   ((p.p.p.name is c)
                    ((S))
                    ((p.p.name is t)
                     ((S))
                     ((n.n.n.name is o) ((S)) ((_epsilon_))))))
                  ((p.name is a)
                   ((p.p.name is #)
                    ((s))
                    ((p.p.p.name is #)
                     ((s))
                     ((p.p.name is t) ((s)) ((S)))))
                   ((p.p.p.name is m)
                    ((s))
                    ((p.name is o)
                     ((s))
                     ((p.name is n)
                      ((S))
                      ((p.p.p.name is a)
                       ((S))
                       ((p.p.name is b)
                        ((S))
                        ((p.name is m)
                         ((S))
                         ((p.p.name is g)
                          ((S))
                          ((p.name is e)
                           ((s))
                           ((p.name is g)
                            ((s))
                            ((p.name is l)
                             ((S))
                             ((p.name is d)
                              ((S))
                              ((p.p.p.name is v)
                               ((S))
                               ((p.p.name is r)
                                ((S))
                                ((p.name is s)
                                 ((s))
                                 ((p.p.p.name is #)
                                  ((n.n.n.name is i) ((S)) ((s)))
                                  ((n.n.n.name is o)
                                   ((s))
                                   ((p.p.p.name is r)
                                    ((S))
                                    ((n.n.n.name is a) ((S)) ((s)))))))))))))))))))))))))
              ((n.n.name is i)
               ((n.n.n.name is g)
                ((s))
                ((n.n.n.name is s)
                 ((s))
                 ((n.n.n.name is n)
                  ((s))
                  ((p.p.name is e)
                   ((S))
                   ((n.n.n.name is m)
                    ((S))
                    ((p.p.name is u)
                     ((S))
                     ((p.p.name is a)
                      ((S))
                      ((n.n.n.name is t)
                       ((s))
                       ((p.p.name is j)
                        ((s))
                        ((n.n.n.name is k)
                         ((s))
                         ((p.p.p.name is g)
                          ((s))
                          ((p.name is e)
                           ((p.p.name is g)
                            ((S))
                            ((p.p.name is b)
                             ((n.n.n.name is a) ((s)) ((S)))
                             ((s))))
                           ((p.p.p.name is #)
                            ((s))
                            ((p.name is a) ((s)) ((S))))))))))))))))
               ((s))))))))))))
     ((n.name is p)
      ((p.name is #)
       ((n.n.name is h) ((s)) ((S)))
       ((n.n.n.name is e)
        ((n.n.name is f)
         ((s))
         ((n.n.name is i)
          ((S))
          ((p.name is r)
           ((S))
           ((p.p.p.name is b)
            ((s))
            ((p.name is u)
             ((S))
             ((p.p.p.name is a)
              ((S))
              ((p.p.name is i)
               ((S))
               ((p.p.p.name is #)
                ((S))
                ((p.name is t)
                 ((S))
                 ((p.name is s)
                  ((S))
                  ((p.p.p.name is r) ((S)) ((p.name is n) ((S)) ((s))))))))))))))
        ((n.n.name is r)
         ((n.n.n.name is o)
          ((p.p.name is g)
           ((S))
           ((p.p.name is e) ((S)) ((p.name is e) ((S)) ((s)))))
          ((p.name is u)
           ((p.p.name is z) ((S)) ((s)))
           ((p.p.p.name is b) ((p.name is n) ((s)) ((S))) ((S)))))
         ((n.n.name is a)
          ((n.n.n.name is n)
           ((S))
           ((n.n.n.name is p)
            ((s))
            ((p.p.p.name is r)
             ((s))
             ((p.name is u)
              ((p.p.p.name is #) ((s)) ((S)))
              ((p.p.p.name is i) ((s)) ((S)))))))
          ((p.name is t)
           ((n.n.n.name is l)
            ((_epsilon_))
            ((n.n.n.name is n) ((_epsilon_)) ((S))))
           ((p.p.name is r)
            ((s))
            ((n.n.n.name is a)
             ((s))
             ((p.p.name is u)
              ((S))
              ((p.p.name is e)
               ((p.p.p.name is p)
                ((s))
                ((p.name is r) ((S)) ((p.name is n) ((S)) ((s)))))
               ((p.p.name is g)
                ((S))
                ((p.p.name is b)
                 ((S))
                 ((p.name is b)
                  ((S))
                  ((p.p.name is z)
                   ((S))
                   ((p.p.p.name is e)
                    ((S))
                    ((p.name is s)
                     ((S))
                     ((p.p.name is c)
                      ((S))
                      ((p.name is l)
                       ((S))
                       ((p.name is n)
                        ((p.p.p.name is r)
                         ((s))
                         ((p.p.name is a) ((S)) ((s))))
                        ((p.p.p.name is r) ((S)) ((s)))))))))))))))))))))
      ((n.name is #)
       ((p.name is t)
        ((_epsilon_))
        ((p.name is d) ((_epsilon_)) ((s))))
       ((p.name is s)
        ((n.n.name is c)
         ((z))
         ((n.name is a)
          ((p.p.p.name is a)
           ((z))
           ((n.n.name is g)
            ((p.p.name is a) ((s)) ((z)))
            ((p.p.name is g) ((z)) ((n.n.name is e) ((z)) ((s))))))
          ((p.p.name is g)
           ((z))
           ((p.p.name is n)
            ((z))
            ((p.p.name is u)
             ((p.p.p.name is a)
              ((n.name is e)
               ((n.n.name is t)
                ((z))
                ((n.n.name is r) ((s)) ((n.n.name is n) ((s)) ((z)))))
               ((z)))
              ((s)))
             ((p.p.name is t)
              ((z))
              ((p.p.p.name is #)
               ((p.p.name is a)
                ((s))
                ((n.n.name is n) ((s)) ((_epsilon_))))
               ((s)))))))))
        ((p.name is t)
         ((n.name is a)
          ((n.n.name is n)
           ((_epsilon_))
           ((n.n.name is b)
            ((_epsilon_))
            ((n.n.n.name is e)
             ((z))
             ((p.p.p.name is a)
              ((n.n.name is m) ((z)) ((_epsilon_)))
              ((z))))))
          ((n.name is i)
           ((z))
           ((n.name is e)
            ((n.n.name is r)
             ((_epsilon_))
             ((n.n.name is n)
              ((_epsilon_))
              ((p.p.p.name is e)
               ((z))
               ((p.p.p.name is o)
                ((z))
                ((n.n.n.name is h)
                 ((z))
                 ((p.p.p.name is s)
                  ((z))
                  ((n.n.name is l) ((z)) ((_epsilon_)))))))))
            ((n.name is u)
             ((n.n.n.name is c)
              ((z))
              ((p.p.name is n) ((z)) ((_epsilon_))))
             ((n.name is o)
              ((n.n.n.name is t)
               ((_epsilon_))
               ((p.p.p.name is a) ((_epsilon_)) ((z))))
              ((_epsilon_)))))))
         ((p.p.name is a)
          ((p.name is u)
           ((n.name is e)
            ((p.p.p.name is #) ((s)) ((z)))
            ((n.name is i)
             ((n.n.name is g) ((z)) ((n.n.name is e) ((z)) ((s))))
             ((n.name is a)
              ((p.p.p.name is #) ((s)) ((n.n.n.name is e) ((z)) ((s))))
              ((s)))))
           ((p.name is p)
            ((s))
            ((p.name is g)
             ((s))
             ((n.name is e)
              ((z))
              ((n.name is i)
               ((p.name is k) ((p.p.p.name is l) ((s)) ((z))) ((z)))
               ((p.p.p.name is #)
                ((n.n.name is e) ((n.name is a) ((z)) ((s))) ((z)))
                ((n.name is a)
                 ((p.p.p.name is h)
                  ((s))
                  ((p.p.p.name is r) ((p.name is n) ((s)) ((z))) ((z))))
                 ((p.name is n)
                  ((s))
                  ((n.n.name is n)
                   ((z))
                   ((n.name is u)
                    ((z))
                    ((n.n.n.name is t) ((z)) ((s)))))))))))))
          ((n.name is k)
           ((p.name is d)
            ((_epsilon_))
            ((n.n.name is i)
             ((p.name is #) ((n.n.n.name is z) ((s)) ((S))) ((s)))
             ((s))))
           ((p.name is g)
            ((n.n.name is m)
             ((n.name is a) ((z)) ((s)))
             ((p.p.p.name is u)
              ((s))
              ((n.n.name is l)
               ((z))
               ((n.name is e) ((s)) ((n.n.name is n) ((z)) ((s)))))))
            ((n.name is w)
             ((p.name is d) ((_epsilon_)) ((s)))
             ((p.name is #)
              ((n.n.name is o)
               ((s))
               ((n.n.name is a)
                ((n.name is a) ((z)) ((s)))
                ((n.name is z)
                 ((s))
                 ((n.n.name is b)
                  ((n.n.n.name is s) ((Z)) ((z)))
                  ((z))))))
              ((p.name is d)
               ((n.n.name is o)
                ((_epsilon_))
                ((p.p.p.name is a)
                 ((n.name is i) ((z)) ((_epsilon_)))
                 ((n.n.name is a)
                  ((_epsilon_))
                  ((n.n.name is i)
                   ((_epsilon_))
                   ((n.n.name is e)
                    ((n.name is u)
                     ((z))
                     ((p.p.p.name is u) ((z)) ((_epsilon_))))
                    ((z)))))))
               ((n.name is i)
                ((p.name is h)
                 ((n.n.name is g)
                  ((s))
                  ((p.p.p.name is e) ((s)) ((z))))
                 ((p.name is p)
                  ((s))
                  ((p.p.name is d)
                   ((n.n.name is e)
                    ((z))
                    ((n.n.name is n) ((s)) ((z))))
                   ((p.p.p.name is b)
                    ((n.n.name is n) ((s)) ((z)))
                    ((z))))))
                ((n.name is e)
                 ((p.p.name is c)
                  ((p.p.p.name is r)
                   ((z))
                   ((p.name is h)
                    ((p.p.p.name is e)
                     ((s))
                     ((n.n.n.name is #)
                      ((s))
                      ((n.n.name is #)
                       ((s))
                       ((p.p.p.name is i) ((z)) ((s))))))
                    ((p.p.p.name is e) ((z)) ((s)))))
                  ((p.name is p)
                   ((s))
                   ((p.name is b)
                    ((n.n.name is n)
                     ((s))
                     ((p.p.p.name is r) ((s)) ((z))))
                    ((n.n.name is i)
                     ((n.n.n.name is t)
                      ((z))
                      ((p.p.name is d)
                       ((s))
                       ((n.n.n.name is g)
                        ((s))
                        ((p.p.p.name is #) ((s)) ((z))))))
                     ((p.name is k)
                      ((s))
                      ((p.p.name is n)
                       ((p.name is i) ((s)) ((z)))
                       ((n.n.name is x)
                        ((z))
                        ((p.p.name is e)
                         ((p.p.p.name is t)
                          ((n.n.n.name is t) ((s)) ((z)))
                          ((z)))
                         ((z))))))))))
                 ((n.name is a)
                  ((n.n.name is r)
                   ((n.n.n.name is t)
                    ((s))
                    ((n.n.n.name is m) ((s)) ((z))))
                   ((p.p.name is d)
                    ((s))
                    ((n.n.name is b)
                     ((p.p.p.name is #)
                      ((z))
                      ((n.n.n.name is l) ((z)) ((s))))
                     ((n.n.n.name is p)
                      ((s))
                      ((n.n.n.name is r)
                       ((s))
                       ((p.p.name is #)
                        ((s))
                        ((p.p.p.name is #)
                         ((z))
                         ((n.n.n.name is f)
                          ((n.n.name is u) ((z)) ((s)))
                          ((p.name is r)
                           ((z))
                           ((n.n.name is u)
                            ((n.n.n.name is s) ((s)) ((z)))
                            ((z))))))))))))
                  ((n.name is u)
                   ((n.n.n.name is b)
                    ((s))
                    ((n.n.name is r)
                     ((p.name is n)
                      ((z))
                      ((p.p.name is #) ((z)) ((s))))
                     ((z))))
                   ((n.name is o)
                    ((p.p.name is d)
                     ((s))
                     ((p.p.name is x)
                      ((s))
                      ((p.name is f)
                       ((z))
                       ((n.n.n.name is d)
                        ((p.name is e) ((z)) ((s)))
                        ((z))))))
                    ((n.name is y)
                     ((p.name is p) ((s)) ((z)))
                     ((n.name is n)
                      ((n.n.name is e) ((z)) ((s)))
                      ((p.name is u)
                       ((n.name is l)
                        ((n.n.n.name is g) ((z)) ((s)))
                        ((s)))
                       ((s))))))))))))))))))))))))
 (t
  ((n.name is t)
   ((p.p.name is e)
    ((t))
    ((p.name is h)
     ((t))
     ((n.n.name is a)
      ((p.p.name is a)
       ((t))
       ((p.p.name is b)
        ((t))
        ((n.n.n.name is u) ((t)) ((p.name is u) ((t)) ((_epsilon_))))))
      ((n.n.name is r)
       ((n.n.n.name is i)
        ((_epsilon_))
        ((p.p.name is #)
         ((_epsilon_))
         ((n.n.n.name is a)
          ((t))
          ((p.p.name is a) ((t)) ((_epsilon_))))))
       ((n.n.name is u)
        ((n.n.n.name is n) ((_epsilon_)) ((t)))
        ((n.n.n.name is i)
         ((n.n.name is e)
          ((p.p.name is m) ((t)) ((_epsilon_)))
          ((_epsilon_)))
         ((p.name is l) ((t)) ((_epsilon_)))))))))
   ((n.name is z)
    ((p.p.name is e)
     ((t))
     ((n.n.name is u)
      ((n.n.n.name is n) ((_epsilon_)) ((t)))
      ((p.name is s)
       ((t))
       ((p.name is h)
        ((n.n.n.name is g)
         ((_epsilon_))
         ((n.n.n.name is h) ((_epsilon_)) ((t))))
        ((n.n.name is o)
         ((n.n.n.name is h) ((_epsilon_)) ((t)))
         ((n.n.name is i)
          ((n.n.n.name is g) ((_epsilon_)) ((t)))
          ((_epsilon_))))))))
    ((n.name is s)
     ((n.n.name is c)
      ((p.name is u)
       ((p.p.name is e)
        ((tS))
        ((p.p.name is r)
         ((tS))
         ((p.p.name is p)
          ((tS))
          ((p.p.name is g)
           ((t))
           ((p.p.name is a) ((tS)) ((p.p.name is l) ((tS)) ((t))))))))
       ((p.name is a)
        ((p.p.name is w)
         ((t))
         ((p.p.name is r)
          ((t))
          ((p.p.name is u)
           ((tS))
           ((p.p.name is p)
            ((tS))
            ((p.p.name is m) ((tS)) ((p.p.name is l) ((tS)) ((t))))))))
        ((p.name is #)
         ((tS))
         ((p.name is e)
          ((p.p.name is u)
           ((tS))
           ((p.p.name is a)
            ((t))
            ((p.p.name is l) ((t)) ((p.p.name is m) ((t)) ((tS))))))
          ((p.name is i) ((p.p.name is k) ((tS)) ((t))) ((t)))))))
      ((n.n.n.name is e)
       ((n.n.name is t)
        ((t))
        ((p.name is n)
         ((t))
         ((n.n.name is u)
          ((p.p.name is e) ((t)) ((p.p.name is b) ((t)) ((ts))))
          ((n.n.name is a)
           ((t))
           ((p.p.name is a)
            ((ts))
            ((p.name is i)
             ((ts))
             ((p.p.name is c)
              ((ts))
              ((p.name is r)
               ((ts))
               ((p.name is f)
                ((ts))
                ((p.name is u) ((ts)) ((p.name is a) ((ts)) ((t)))))))))))))
       ((n.n.name is #)
        ((ts))
        ((n.n.n.name is #)
         ((ts))
         ((p.name is n)
          ((n.n.n.name is o) ((ts)) ((t)))
          ((p.name is s)
           ((t))
           ((n.n.n.name is m)
            ((t))
            ((n.n.name is t)
             ((p.name is i)
              ((ts))
              ((p.name is a)
               ((ts))
               ((p.name is f)
                ((ts))
                ((p.p.name is c)
                 ((n.n.n.name is r)
                  ((t))
                  ((n.n.n.name is u) ((ts)) ((t))))
                 ((t))))))
             ((n.n.name is i)
              ((n.n.n.name is c) ((t)) ((p.name is i) ((ts)) ((t))))
              ((n.n.name is p)
               ((p.p.name is a)
                ((n.n.n.name is r) ((t)) ((ts)))
                ((n.n.n.name is r)
                 ((t))
                 ((n.n.n.name is i)
                  ((t))
                  ((n.n.n.name is a) ((t)) ((ts))))))
               ((n.n.name is e)
                ((n.n.n.name is r)
                 ((ts))
                 ((n.n.n.name is n)
                  ((ts))
                  ((p.p.name is o)
                   ((t))
                   ((n.n.n.name is l) ((t)) ((ts))))))
                ((n.n.name is a)
                 ((n.n.n.name is n)
                  ((ts))
                  ((n.n.n.name is b) ((ts)) ((t))))
                 ((ts))))))))))))))
     ((n.n.name is o)
      ((n.name is i)
       ((n.n.n.name is n)
        ((ts))
        ((p.p.name is e) ((ts)) ((p.p.name is b) ((ts)) ((t)))))
       ((t)))
      ((n.name is i)
       ((n.n.name is a)
        ((p.name is s)
         ((t))
         ((n.n.n.name is l) ((ts)) ((n.n.n.name is t) ((ts)) ((t)))))
        ((n.n.name is e)
         ((n.n.n.name is l)
          ((p.name is s) ((t)) ((ts)))
          ((n.n.n.name is n) ((p.name is k) ((ts)) ((t))) ((t))))
         ((t))))
       ((p.name is n)
        ((p.p.name is a)
         ((n.n.n.name is r) ((_epsilon_)) ((t)))
         ((n.name is m) ((n.n.n.name is e) ((_epsilon_)) ((t))) ((t))))
        ((t)))))))))
 (u
  ((n.name is e)
   ((n.n.n.name is e)
    ((n.n.name is r)
     ((p.name is e)
      ((_epsilon_))
      ((p.name is a) ((_epsilon_)) ((p.name is q) ((v)) ((y:)))))
     ((p.name is a)
      ((_epsilon_))
      ((p.name is q)
       ((v))
       ((p.name is b)
        ((n.n.name is g) ((y:)) ((n.n.name is k) ((y:)) ((Y))))
        ((y:))))))
    ((p.name is a)
     ((_epsilon_))
     ((p.name is e)
      ((p.p.name is g) ((y:)) ((_epsilon_)))
      ((n.n.name is h)
       ((y:))
       ((p.name is q)
        ((v))
        ((n.n.name is g)
         ((p.p.name is r) ((n.n.n.name is t) ((u:)) ((y:))) ((y:)))
         ((n.n.n.name is i)
          ((n.n.name is r)
           ((u:))
           ((p.p.name is u) ((u:)) ((p.p.name is t) ((u:)) ((y:)))))
          ((n.n.name is b)
           ((y:))
           ((n.n.n.name is l)
            ((n.n.name is l)
             ((p.name is f)
              ((Y))
              ((p.name is h)
               ((Y))
               ((p.p.name is b)
                ((Y))
                ((p.name is m) ((Y)) ((p.name is n) ((Y)) ((u:)))))))
             ((y:)))
            ((n.n.n.name is k)
             ((Y))
             ((n.n.n.name is #)
              ((p.name is t) ((u:)) ((y:)))
              ((n.n.n.name is d)
               ((p.name is t) ((p.p.name is s) ((Y)) ((u:))) ((Y)))
               ((p.name is p)
                ((y:))
                ((n.n.name is d)
                 ((y:))
                 ((p.name is z)
                  ((n.n.name is c)
                   ((Y))
                   ((n.n.name is n)
                    ((Y))
                    ((n.n.n.name is n) ((Y)) ((u:)))))
                  ((n.n.n.name is o)
                   ((y:))
                   ((n.n.name is s)
                    ((p.name is l)
                     ((Y))
                     ((p.name is r)
                      ((p.p.name is g) ((y:)) ((Y)))
                      ((p.name is t)
                       ((u:))
                       ((p.p.name is c)
                        ((Y))
                        ((p.name is s)
                         ((y:))
                         ((p.name is w)
                          ((y:))
                          ((p.name is f)
                           ((y:))
                           ((p.name is d)
                            ((y:))
                            ((p.p.name is a)
                             ((y:))
                             ((n.n.n.name is s)
                              ((p.name is b)
                               ((y:))
                               ((p.p.name is #) ((y:)) ((Y))))
                              ((Y))))))))))))
                    ((p.p.name is g)
                     ((p.name is r) ((y:)) ((Y)))
                     ((n.n.name is #)
                      ((u:))
                      ((n.n.n.name is u)
                       ((y:))
                       ((n.n.name is t)
                        ((Y))
                        ((n.n.n.name is f)
                         ((Y))
                         ((p.name is s)
                          ((Y))
                          ((p.p.name is h)
                           ((n.n.name is r)
                            ((y:))
                            ((n.n.name is c) ((y:)) ((Y))))
                           ((n.n.n.name is h)
                            ((p.name is r)
                             ((Y))
                             ((p.name is w)
                              ((y:))
                              ((p.name is b)
                               ((y:))
                               ((p.name is t)
                                ((p.p.name is s)
                                 ((Y))
                                 ((p.p.name is e)
                                  ((Y))
                                  ((p.p.name is #) ((Y)) ((y:)))))
                                ((Y))))))
                            ((p.name is f)
                             ((n.n.n.name is c)
                              ((Y))
                              ((n.n.n.name is s) ((Y)) ((y:))))
                             ((p.p.name is t)
                              ((p.name is d)
                               ((U))
                               ((n.n.name is n) ((y:)) ((Y))))
                              ((n.n.name is n)
                               ((Y))
                               ((p.p.name is p)
                                ((y:))
                                ((n.n.n.name is s)
                                 ((p.name is t) ((y:)) ((Y)))
                                 ((p.name is g)
                                  ((Y))
                                  ((n.n.n.name is m)
                                   ((Y))
                                   ((p.p.name is c)
                                    ((Y))
                                    ((n.n.n.name is z)
                                     ((Y))
                                     ((p.name is k)
                                      ((y:))
                                      ((p.name is t)
                                       ((n.n.name is r)
                                        ((p.p.name is #) ((y:)) ((Y)))
                                        ((Y)))
                                       ((Y))))))))))))))))))))))))))))))))))))))
   ((p.name is a)
    ((_epsilon_))
    ((p.name is e)
     ((p.p.name is b)
      ((n.name is r)
       ((u:))
       ((n.n.name is e)
        ((_epsilon_))
        ((n.name is g)
         ((_epsilon_))
         ((n.name is l) ((_epsilon_)) ((U))))))
      ((n.name is m)
       ((p.p.name is a)
        ((_epsilon_))
        ((n.n.name is s) ((U)) ((_epsilon_))))
       ((_epsilon_))))
     ((n.name is n)
      ((n.n.name is i)
       ((p.name is #) ((U)) ((u:)))
       ((p.name is z)
        ((n.n.name is g)
         ((U))
         ((n.n.name is a) ((u:)) ((n.n.name is e) ((u:)) ((U)))))
        ((n.n.name is #)
         ((u:))
         ((p.name is #)
          ((U))
          ((n.n.name is e)
           ((u:))
           ((n.n.name is a)
            ((p.p.name is c) ((U)) ((u:)))
            ((n.n.name is l)
             ((u:))
             ((n.n.n.name is i)
              ((U))
              ((n.n.name is s)
               ((p.p.name is #)
                ((U))
                ((p.name is d)
                 ((U))
                 ((p.name is k)
                  ((U))
                  ((p.name is r) ((U)) ((p.name is w) ((U)) ((u:)))))))
               ((U)))))))))))
      ((p.name is z)
       ((n.name is c) ((U)) ((n.n.name is f) ((U)) ((u:))))
       ((p.name is q)
        ((v))
        ((n.n.name is e)
         ((p.name is g) ((n.name is i) ((_epsilon_)) ((u:))) ((u:)))
         ((n.n.name is i)
          ((u:))
          ((n.name is m)
           ((p.name is #)
            ((U))
            ((n.n.name is o)
             ((u:))
             ((n.n.name is u)
              ((u:))
              ((n.n.name is a)
               ((p.name is h) ((u:)) ((U)))
               ((p.name is t)
                ((p.p.name is n)
                 ((u:))
                 ((n.n.name is #)
                  ((u:))
                  ((n.n.name is s) ((u:)) ((U)))))
                ((U)))))))
           ((n.n.name is c)
            ((p.name is w) ((p.p.name is #) ((U)) ((u:))) ((U)))
            ((n.n.name is a)
             ((n.n.n.name is e)
              ((p.name is k) ((U)) ((u:)))
              ((n.name is b) ((U)) ((u:))))
             ((n.name is h)
              ((u:))
              ((n.n.name is h)
               ((p.name is r)
                ((p.p.name is b) ((U)) ((p.p.name is p) ((U)) ((u:))))
                ((n.n.n.name is t)
                 ((p.p.name is e)
                  ((u:))
                  ((p.p.name is #)
                   ((U))
                   ((p.name is b)
                    ((u:))
                    ((p.name is s)
                     ((p.p.name is n) ((U)) ((u:)))
                     ((U))))))
                 ((p.name is f)
                  ((U))
                  ((p.name is l)
                   ((p.p.name is f)
                    ((u:))
                    ((p.p.name is o) ((u:)) ((U))))
                   ((p.p.name is g)
                    ((n.n.n.name is e) ((U)) ((u:)))
                    ((u:)))))))
               ((n.name is a)
                ((n.n.n.name is c) ((y:)) ((u:)))
                ((n.name is g)
                 ((n.n.name is g)
                  ((U))
                  ((n.n.n.name is i) ((U)) ((u:))))
                 ((n.name is c)
                  ((U))
                  ((n.n.name is z)
                   ((n.n.n.name is u)
                    ((n.name is r) ((u:)) ((U)))
                    ((U)))
                   ((n.name is t)
                    ((n.n.name is t)
                     ((p.name is g) ((u:)) ((U)))
                     ((n.n.n.name is c)
                      ((p.name is g)
                       ((u:))
                       ((p.name is w) ((u:)) ((U))))
                      ((u:))))
                    ((p.p.name is a)
                     ((p.name is t)
                      ((u:))
                      ((n.n.name is s)
                       ((u:))
                       ((n.name is s)
                        ((U))
                        ((n.name is l)
                         ((U))
                         ((p.name is k) ((u:)) ((U)))))))
                     ((p.name is #)
                      ((n.name is l)
                       ((U))
                       ((n.n.n.name is e)
                        ((n.n.name is t) ((U)) ((u:)))
                        ((n.n.name is b) ((U)) ((u:)))))
                      ((n.name is f)
                       ((p.name is r)
                        ((u:))
                        ((p.name is t)
                         ((u:))
                         ((p.name is h)
                          ((n.n.name is t) ((U)) ((u:)))
                          ((n.n.n.name is l) ((u:)) ((U))))))
                       ((n.name is i)
                        ((n.n.name is l) ((U)) ((u:)))
                        ((n.n.name is o)
                         ((p.name is k)
                          ((n.n.n.name is e) ((U)) ((u:)))
                          ((u:)))
                         ((p.name is h)
                          ((n.n.name is d)
                           ((U))
                           ((n.name is l)
                            ((n.n.name is t)
                             ((n.n.n.name is e) ((u:)) ((U)))
                             ((u:)))
                            ((n.name is b)
                             ((n.n.n.name is e) ((U)) ((u:)))
                             ((n.n.name is t)
                              ((p.p.name is #) ((U)) ((u:)))
                              ((U))))))
                          ((n.name is d)
                           ((n.n.name is d)
                            ((U))
                            ((p.p.name is #) ((Y)) ((u:))))
                           ((n.name is #)
                            ((u:))
                            ((p.name is f)
                             ((n.name is l)
                              ((U))
                              ((n.n.n.name is e)
                               ((p.p.name is #) ((U)) ((u:)))
                               ((u:))))
                             ((n.name is o)
                              ((u:))
                              ((n.name is r)
                               ((n.n.name is #)
                                ((u:))
                                ((n.n.name is l)
                                 ((u:))
                                 ((n.n.name is n)
                                  ((U))
                                  ((p.name is b)
                                   ((p.p.name is e) ((u:)) ((U)))
                                   ((p.p.name is h)
                                    ((n.n.name is r) ((U)) ((u:)))
                                    ((p.name is p)
                                     ((n.n.n.name is i) ((u:)) ((U)))
                                     ((p.p.name is l)
                                      ((p.name is t) ((u:)) ((U)))
                                      ((n.n.n.name is e)
                                       ((U))
                                       ((n.n.n.name is i)
                                        ((U))
                                        ((p.name is k)
                                         ((n.n.n.name is #)
                                          ((U))
                                          ((n.n.name is s)
                                           ((U))
                                           ((u:))))
                                         ((p.p.name is #)
                                          ((U))
                                          ((p.name is d)
                                           ((U))
                                           ((n.n.name is s)
                                            ((p.name is w)
                                             ((U))
                                             ((u:)))
                                            ((U)))))))))))))))
                               ((n.n.name is u)
                                ((n.name is x) ((U)) ((u:)))
                                ((n.n.n.name is #)
                                 ((n.n.name is t)
                                  ((p.name is t)
                                   ((u:))
                                   ((n.name is s)
                                    ((U))
                                    ((p.name is r) ((u:)) ((U)))))
                                  ((U)))
                                 ((p.name is b)
                                  ((n.n.n.name is f)
                                   ((u:))
                                   ((n.n.name is #) ((u:)) ((U))))
                                  ((p.name is p)
                                   ((n.n.name is t)
                                    ((u:))
                                    ((p.p.name is s) ((u:)) ((U))))
                                   ((p.name is r)
                                    ((n.n.name is s)
                                     ((n.n.n.name is i)
                                      ((U))
                                      ((p.p.name is #)
                                       ((u:))
                                       ((p.p.name is g)
                                        ((u:))
                                        ((p.p.name is e) ((u:)) ((U))))))
                                     ((U)))
                                    ((p.p.name is p)
                                     ((n.n.name is t)
                                      ((u:))
                                      ((p.name is l) ((U)) ((u:))))
                                     ((n.n.name is r)
                                      ((u:))
                                      ((n.n.name is l)
                                       ((n.name is l)
                                        ((U))
                                        ((p.name is s)
                                         ((U))
                                         ((n.name is p) ((U)) ((u:)))))
                                       ((U))))))))))))))))))))))))))))))))))))))))
 (v
  ((n.n.name is r)
   ((p.name is i)
    ((n.name is e) ((v)) ((f)))
    ((p.name is #)
     ((n.name is a) ((v)) ((n.name is i) ((v)) ((f))))
     ((p.name is a)
      ((v))
      ((p.p.name is o)
       ((p.name is r)
        ((f))
        ((p.p.p.name is k)
         ((v))
         ((p.name is u)
          ((v))
          ((p.p.p.name is n) ((v)) ((p.p.p.name is v) ((v)) ((f)))))))
       ((p.p.name is r)
        ((p.name is o) ((v)) ((f)))
        ((p.p.name is a)
         ((p.name is d)
          ((v))
          ((p.p.p.name is #) ((f)) ((p.p.p.name is n) ((f)) ((v)))))
         ((p.name is b)
          ((v))
          ((p.name is u)
           ((p.p.name is z) ((f)) ((v)))
           ((p.p.p.name is p)
            ((p.name is r) ((v)) ((f)))
            ((p.p.name is i)
             ((p.p.p.name is #) ((v)) ((f)))
             ((p.p.p.name is s)
              ((p.p.name is k) ((f)) ((p.p.name is e) ((f)) ((v))))
              ((f)))))))))))))
   ((n.name is o)
    ((p.p.name is r)
     ((p.p.p.name is e) ((f)) ((v)))
     ((n.n.name is k)
      ((v))
      ((n.n.name is t)
       ((v))
       ((p.name is #)
        ((f))
        ((n.n.name is l)
         ((f))
         ((n.n.name is e) ((f)) ((n.n.name is g) ((f)) ((v)))))))))
    ((n.name is s)
     ((f))
     ((n.name is #)
      ((f))
      ((n.n.name is e)
       ((p.name is #)
        ((f))
        ((n.name is i)
         ((p.p.name is t)
          ((v))
          ((p.p.p.name is s)
           ((v))
           ((p.p.name is e)
            ((f))
            ((p.name is i)
             ((v))
             ((p.name is a)
              ((v))
              ((p.p.name is r)
               ((v))
               ((p.p.p.name is e)
                ((v))
                ((p.p.p.name is v) ((v)) ((p.name is o) ((v)) ((f)))))))))))
         ((f))))
       ((p.p.p.name is f)
        ((f))
        ((n.n.name is t)
         ((n.name is i)
          ((v))
          ((p.name is #)
           ((n.name is a) ((f)) ((v)))
           ((p.name is s) ((f)) ((v)))))
         ((n.n.name is i)
          ((p.name is e) ((v)) ((f)))
          ((n.name is t)
           ((f))
           ((n.name is i)
            ((v))
            ((n.n.name is n)
             ((v))
             ((n.name is a)
              ((v))
              ((n.name is e)
               ((p.name is i)
                ((v))
                ((n.n.name is s) ((p.name is #) ((f)) ((v))) ((v))))
               ((n.name is u) ((v)) ((f)))))))))))))))))
 (w ((v)))
 (x ((k-s)))
 (y
  ((n.n.name is t)
   ((Y))
   ((n.name is m)
    ((p.p.name is #) ((Y)) ((n.n.name is p) ((Y)) ((y:))))
    ((p.name is a)
     ((_epsilon_))
     ((n.n.name is i)
      ((y:))
      ((n.n.name is c)
       ((Y))
       ((n.n.name is a)
        ((y:))
        ((n.n.name is e)
         ((y:))
         ((n.n.name is o)
          ((y:))
          ((n.n.name is h)
           ((p.p.name is r) ((Y)) ((y:)))
           ((p.name is s)
            ((Y))
            ((p.name is d)
             ((Y))
             ((n.name is s)
              ((Y))
              ((p.p.name is o)
               ((y:))
               ((p.name is z)
                ((y:))
                ((n.name is o)
                 ((y:))
                 ((n.n.name is n)
                  ((Y))
                  ((p.name is h)
                   ((n.name is d)
                    ((p.p.name is #) ((y:)) ((Y)))
                    ((y:)))
                   ((n.name is p) ((y:)) ((Y)))))))))))))))))))))
 (z
  ((n.name is z)
   ((p.p.name is k)
    ((_epsilon_))
    ((p.p.name is e)
     ((ts))
     ((p.p.name is a) ((ts)) ((p.p.name is u) ((ts)) ((_epsilon_))))))
   ((ts)))))
)

(provide 'de-celex-lts)
